dcl_settings : default_dcl_settings { audit_level = 3; }

clg5_ok_not : retirement_button {
        label           = "  OK  ";
        key             = "accept";
}

clg5_ok_cancel : column {
    : row {
        fixed_width = true;
        alignment = centered;
        clg5_ok_not;
//        : spacer { width = 2; }
        cancel_button;
    }
}

myswatch : image_button {
    alignment = centered;
    vertical_margin = none;
    horizontal_margin = none;
    fixed_height = true;
    fixed_width = true;
    height = 1.5;
    width = 3;
    allow_accept = true;
}

clg5_smallswatch : image_button {
    alignment = centered;
    vertical_margin = none;
    horizontal_margin = none;
    fixed_height = true;
    fixed_width = true;
    height = 1;
    width = 2;
    allow_accept = true;
}

clg5_base_colors : column
  {
    : spacer { height = 1;}
    : spacer { height = 1;}
    : spacer { height = 1;}
    : clg5_smallswatch { color = 001; key = "001"; }
    : clg5_smallswatch { color = 002; key = "002"; }
    : clg5_smallswatch { color = 003; key = "003"; }
    : clg5_smallswatch { color = 004; key = "004"; }
    : clg5_smallswatch { color = 005; key = "005"; }
    : clg5_smallswatch { color = 006; key = "006"; }
    : clg5_smallswatch { color = 007; key = "007"; }
    : clg5_smallswatch { color = 008; key = "008"; }
    : clg5_smallswatch { color = 009; key = "009"; }
    : spacer { height = 1;}
    : spacer { height = 1;}
    : clg5_smallswatch { color = 250; key = "250"; }
    : clg5_smallswatch { color = 251; key = "251"; }
    : clg5_smallswatch { color = 252; key = "252"; }
    : clg5_smallswatch { color = 253; key = "253"; }
    : clg5_smallswatch { color = 254; key = "254"; }
    : clg5_smallswatch { color = 255; key = "255"; }
    : spacer { height = 1;}
    : spacer { height = 1;}
    : spacer { height = 1;}
  }


clg5_std_colors : column
  {
    : row {
      : spacer {}
      : text { label = "9 "; horizontal_margin = none; vertical_margin = none;}
      : text { label = "7 "; horizontal_margin = none; vertical_margin = none;}
      : text { label = "5 "; horizontal_margin = none; vertical_margin = none;}
      : text { label = "3 "; horizontal_margin = none; vertical_margin = none;}
      : text { label = "1 "; horizontal_margin = none; vertical_margin = none;}
      : spacer {}
      : text { label = "0"; horizontal_margin = none; vertical_margin = none;}
      : text { label = " 2"; horizontal_margin = none; vertical_margin = none;}
      : text { label = " 4"; horizontal_margin = none; vertical_margin = none;}
      : text { label = " 6"; horizontal_margin = none; vertical_margin = none;}
      : text { label = " 8"; horizontal_margin = none; vertical_margin = none;}
    }
    : row {
      : spacer {}
      : clg5_smallswatch { color = 019; key = "019"; }
      : clg5_smallswatch { color = 017; key = "017"; }
      : clg5_smallswatch { color = 015; key = "015"; }
      : clg5_smallswatch { color = 013; key = "013"; }
      : clg5_smallswatch { color = 011; key = "011"; }
      : spacer {}
      : clg5_smallswatch { color = 010; key = "010"; }
      : clg5_smallswatch { color = 012; key = "012"; }
      : clg5_smallswatch { color = 014; key = "014"; }
      : clg5_smallswatch { color = 016; key = "016"; }
      : clg5_smallswatch { color = 018; key = "018"; }
    }
    : row {
      : spacer {}
      : clg5_smallswatch { color = 029; key = "029"; }
      : clg5_smallswatch { color = 027; key = "027"; }
      : clg5_smallswatch { color = 025; key = "025"; }
      : clg5_smallswatch { color = 023; key = "023"; }
      : clg5_smallswatch { color = 021; key = "021"; }
      : spacer {}
      : clg5_smallswatch { color = 020; key = "020"; }
      : clg5_smallswatch { color = 022; key = "022"; }
      : clg5_smallswatch { color = 024; key = "024"; }
      : clg5_smallswatch { color = 026; key = "026"; }
      : clg5_smallswatch { color = 028; key = "028"; }
    }
    : row {
      : spacer {}
      : clg5_smallswatch { color = 039; key = "039"; }
      : clg5_smallswatch { color = 037; key = "037"; }
      : clg5_smallswatch { color = 035; key = "035"; }
      : clg5_smallswatch { color = 033; key = "033"; }
      : clg5_smallswatch { color = 031; key = "031"; }
      : spacer {}
      : clg5_smallswatch { color = 030; key = "030"; }
      : clg5_smallswatch { color = 032; key = "032"; }
      : clg5_smallswatch { color = 034; key = "034"; }
      : clg5_smallswatch { color = 036; key = "036"; }
      : clg5_smallswatch { color = 038; key = "038"; }
    }
    : row {
      : spacer {}
      : clg5_smallswatch { color = 049; key = "049"; }
      : clg5_smallswatch { color = 047; key = "047"; }
      : clg5_smallswatch { color = 045; key = "045"; }
      : clg5_smallswatch { color = 043; key = "043"; }
      : clg5_smallswatch { color = 041; key = "041"; }
      : spacer {}
      : clg5_smallswatch { color = 040; key = "040"; }
      : clg5_smallswatch { color = 042; key = "042"; }
      : clg5_smallswatch { color = 044; key = "044"; }
      : clg5_smallswatch { color = 046; key = "046"; }
      : clg5_smallswatch { color = 048; key = "048"; }
    }
    : row {
      : spacer {}
      : clg5_smallswatch { color = 059; key = "059"; }
      : clg5_smallswatch { color = 057; key = "057"; }
      : clg5_smallswatch { color = 055; key = "055"; }
      : clg5_smallswatch { color = 053; key = "053"; }
      : clg5_smallswatch { color = 051; key = "051"; }
      : spacer {}
      : clg5_smallswatch { color = 050; key = "050"; }
      : clg5_smallswatch { color = 052; key = "052"; }
      : clg5_smallswatch { color = 054; key = "054"; }
      : clg5_smallswatch { color = 056; key = "056"; }
      : clg5_smallswatch { color = 058; key = "058"; }
    }
    : row {
      : spacer {}
      : clg5_smallswatch { color = 069; key = "069"; }
      : clg5_smallswatch { color = 067; key = "067"; }
      : clg5_smallswatch { color = 065; key = "065"; }
      : clg5_smallswatch { color = 063; key = "063"; }
      : clg5_smallswatch { color = 061; key = "061"; }
      : spacer {}
      : clg5_smallswatch { color = 060; key = "060"; }
      : clg5_smallswatch { color = 062; key = "062"; }
      : clg5_smallswatch { color = 064; key = "064"; }
      : clg5_smallswatch { color = 066; key = "066"; }
      : clg5_smallswatch { color = 068; key = "068"; }
    }
    : row {
      : spacer {}
      : clg5_smallswatch { color = 079; key = "079"; }
      : clg5_smallswatch { color = 077; key = "077"; }
      : clg5_smallswatch { color = 075; key = "075"; }
      : clg5_smallswatch { color = 073; key = "073"; }
      : clg5_smallswatch { color = 071; key = "071"; }
      : spacer {}
      : clg5_smallswatch { color = 070; key = "070"; }
      : clg5_smallswatch { color = 072; key = "072"; }
      : clg5_smallswatch { color = 074; key = "074"; }
      : clg5_smallswatch { color = 076; key = "076"; }
      : clg5_smallswatch { color = 078; key = "078"; }
    }
    : row {
      : spacer {}
      : clg5_smallswatch { color = 089; key = "089"; }
      : clg5_smallswatch { color = 087; key = "087"; }
      : clg5_smallswatch { color = 085; key = "085"; }
      : clg5_smallswatch { color = 083; key = "083"; }
      : clg5_smallswatch { color = 081; key = "081"; }
      : spacer {}
      : clg5_smallswatch { color = 080; key = "080"; }
      : clg5_smallswatch { color = 082; key = "082"; }
      : clg5_smallswatch { color = 084; key = "084"; }
      : clg5_smallswatch { color = 086; key = "086"; }
      : clg5_smallswatch { color = 088; key = "088"; }
    }
    : row {
      : spacer {}
      : clg5_smallswatch { color = 099; key = "099"; }
      : clg5_smallswatch { color = 097; key = "097"; }
      : clg5_smallswatch { color = 095; key = "095"; }
      : clg5_smallswatch { color = 093; key = "093"; }
      : clg5_smallswatch { color = 091; key = "091"; }
      : spacer {}
      : clg5_smallswatch { color = 090; key = "090"; }
      : clg5_smallswatch { color = 092; key = "092"; }
      : clg5_smallswatch { color = 094; key = "094"; }
      : clg5_smallswatch { color = 096; key = "096"; }
      : clg5_smallswatch { color = 098; key = "098"; }
    }
    : row {
      : spacer {}
      : clg5_smallswatch { color = 109; key = "109"; }
      : clg5_smallswatch { color = 107; key = "107"; }
      : clg5_smallswatch { color = 105; key = "105"; }
      : clg5_smallswatch { color = 103; key = "103"; }
      : clg5_smallswatch { color = 101; key = "101"; }
      : spacer {}
      : clg5_smallswatch { color = 100; key = "100"; }
      : clg5_smallswatch { color = 102; key = "102"; }
      : clg5_smallswatch { color = 104; key = "104"; }
      : clg5_smallswatch { color = 106; key = "106"; }
      : clg5_smallswatch { color = 108; key = "108"; }
    }
    : row {
      : spacer {}
      : clg5_smallswatch { color = 119; key = "119"; }
      : clg5_smallswatch { color = 117; key = "117"; }
      : clg5_smallswatch { color = 115; key = "115"; }
      : clg5_smallswatch { color = 113; key = "113"; }
      : clg5_smallswatch { color = 111; key = "111"; }
      : spacer {}
      : clg5_smallswatch { color = 110; key = "110"; }
      : clg5_smallswatch { color = 112; key = "112"; }
      : clg5_smallswatch { color = 114; key = "114"; }
      : clg5_smallswatch { color = 116; key = "116"; }
      : clg5_smallswatch { color = 118; key = "118"; }
    }
    : row {
      : spacer {}
      : clg5_smallswatch { color = 129; key = "129"; }
      : clg5_smallswatch { color = 127; key = "127"; }
      : clg5_smallswatch { color = 125; key = "125"; }
      : clg5_smallswatch { color = 123; key = "123"; }
      : clg5_smallswatch { color = 121; key = "121"; }
      : spacer {}
      : clg5_smallswatch { color = 120; key = "120"; }
      : clg5_smallswatch { color = 122; key = "122"; }
      : clg5_smallswatch { color = 124; key = "124"; }
      : clg5_smallswatch { color = 126; key = "126"; }
      : clg5_smallswatch { color = 128; key = "128"; }
    }
    : row {
      : spacer {}
      : clg5_smallswatch { color = 139; key = "139"; }
      : clg5_smallswatch { color = 137; key = "137"; }
      : clg5_smallswatch { color = 135; key = "135"; }
      : clg5_smallswatch { color = 133; key = "133"; }
      : clg5_smallswatch { color = 131; key = "131"; }
      : spacer {}
      : clg5_smallswatch { color = 130; key = "130"; }
      : clg5_smallswatch { color = 132; key = "132"; }
      : clg5_smallswatch { color = 134; key = "134"; }
      : clg5_smallswatch { color = 136; key = "136"; }
      : clg5_smallswatch { color = 138; key = "138"; }
    }
    : row {
      : spacer {}
      : clg5_smallswatch { color = 149; key = "149"; }
      : clg5_smallswatch { color = 147; key = "147"; }
      : clg5_smallswatch { color = 145; key = "145"; }
      : clg5_smallswatch { color = 143; key = "143"; }
      : clg5_smallswatch { color = 141; key = "141"; }
      : spacer {}
      : clg5_smallswatch { color = 140; key = "140"; }
      : clg5_smallswatch { color = 142; key = "142"; }
      : clg5_smallswatch { color = 144; key = "144"; }
      : clg5_smallswatch { color = 146; key = "146"; }
      : clg5_smallswatch { color = 148; key = "148"; }
    }
    : row {
      : spacer {}
      : clg5_smallswatch { color = 159; key = "159"; }
      : clg5_smallswatch { color = 157; key = "157"; }
      : clg5_smallswatch { color = 155; key = "155"; }
      : clg5_smallswatch { color = 153; key = "153"; }
      : clg5_smallswatch { color = 151; key = "151"; }
      : spacer {}
      : clg5_smallswatch { color = 150; key = "150"; }
      : clg5_smallswatch { color = 152; key = "152"; }
      : clg5_smallswatch { color = 154; key = "154"; }
      : clg5_smallswatch { color = 156; key = "156"; }
      : clg5_smallswatch { color = 158; key = "158"; }
    }
    : row {
      : spacer {}
      : clg5_smallswatch { color = 169; key = "169"; }
      : clg5_smallswatch { color = 167; key = "167"; }
      : clg5_smallswatch { color = 165; key = "165"; }
      : clg5_smallswatch { color = 163; key = "163"; }
      : clg5_smallswatch { color = 161; key = "161"; }
      : spacer {}
      : clg5_smallswatch { color = 160; key = "160"; }
      : clg5_smallswatch { color = 162; key = "162"; }
      : clg5_smallswatch { color = 164; key = "164"; }
      : clg5_smallswatch { color = 166; key = "166"; }
      : clg5_smallswatch { color = 168; key = "168"; }
    }
    : row {
      : spacer {}
      : clg5_smallswatch { color = 179; key = "179"; }
      : clg5_smallswatch { color = 177; key = "177"; }
      : clg5_smallswatch { color = 175; key = "175"; }
      : clg5_smallswatch { color = 173; key = "173"; }
      : clg5_smallswatch { color = 171; key = "171"; }
      : spacer {}
      : clg5_smallswatch { color = 170; key = "170"; }
      : clg5_smallswatch { color = 172; key = "172"; }
      : clg5_smallswatch { color = 174; key = "174"; }
      : clg5_smallswatch { color = 176; key = "176"; }
      : clg5_smallswatch { color = 178; key = "178"; }
    }
    : row {
      : spacer {}
      : clg5_smallswatch { color = 189; key = "189"; }
      : clg5_smallswatch { color = 187; key = "187"; }
      : clg5_smallswatch { color = 185; key = "185"; }
      : clg5_smallswatch { color = 183; key = "183"; }
      : clg5_smallswatch { color = 181; key = "181"; }
      : spacer {}
      : clg5_smallswatch { color = 180; key = "180"; }
      : clg5_smallswatch { color = 182; key = "182"; }
      : clg5_smallswatch { color = 184; key = "184"; }
      : clg5_smallswatch { color = 186; key = "186"; }
      : clg5_smallswatch { color = 188; key = "188"; }
    }
    : row {
      : spacer {}
      : clg5_smallswatch { color = 199; key = "199"; }
      : clg5_smallswatch { color = 197; key = "197"; }
      : clg5_smallswatch { color = 195; key = "195"; }
      : clg5_smallswatch { color = 193; key = "193"; }
      : clg5_smallswatch { color = 191; key = "191"; }
      : spacer {}
      : clg5_smallswatch { color = 190; key = "190"; }
      : clg5_smallswatch { color = 192; key = "192"; }
      : clg5_smallswatch { color = 194; key = "194"; }
      : clg5_smallswatch { color = 196; key = "196"; }
      : clg5_smallswatch { color = 198; key = "198"; }
    }
    : row {
      : spacer {}
      : clg5_smallswatch { color = 209; key = "209"; }
      : clg5_smallswatch { color = 207; key = "207"; }
      : clg5_smallswatch { color = 205; key = "205"; }
      : clg5_smallswatch { color = 203; key = "203"; }
      : clg5_smallswatch { color = 201; key = "201"; }
      : spacer {}
      : clg5_smallswatch { color = 200; key = "200"; }
      : clg5_smallswatch { color = 202; key = "202"; }
      : clg5_smallswatch { color = 204; key = "204"; }
      : clg5_smallswatch { color = 206; key = "206"; }
      : clg5_smallswatch { color = 208; key = "208"; }
    }
    : row {
      : spacer {}
      : clg5_smallswatch { color = 219; key = "219"; }
      : clg5_smallswatch { color = 217; key = "217"; }
      : clg5_smallswatch { color = 215; key = "215"; }
      : clg5_smallswatch { color = 213; key = "213"; }
      : clg5_smallswatch { color = 211; key = "211"; }
      : spacer {}
      : clg5_smallswatch { color = 210; key = "210"; }
      : clg5_smallswatch { color = 212; key = "212"; }
      : clg5_smallswatch { color = 214; key = "214"; }
      : clg5_smallswatch { color = 216; key = "216"; }
      : clg5_smallswatch { color = 218; key = "218"; }
    }
    : row {
      : spacer {}
      : clg5_smallswatch { color = 229; key = "229"; }
      : clg5_smallswatch { color = 227; key = "227"; }
      : clg5_smallswatch { color = 225; key = "225"; }
      : clg5_smallswatch { color = 223; key = "223"; }
      : clg5_smallswatch { color = 221; key = "221"; }
      : spacer {}
      : clg5_smallswatch { color = 220; key = "220"; }
      : clg5_smallswatch { color = 222; key = "222"; }
      : clg5_smallswatch { color = 224; key = "224"; }
      : clg5_smallswatch { color = 226; key = "226"; }
      : clg5_smallswatch { color = 228; key = "228"; }
    }
    : row {
      : spacer {}
      : clg5_smallswatch { color = 239; key = "239"; }
      : clg5_smallswatch { color = 237; key = "237"; }
      : clg5_smallswatch { color = 235; key = "235"; }
      : clg5_smallswatch { color = 233; key = "233"; }
      : clg5_smallswatch { color = 231; key = "231"; }
      : spacer {}
      : clg5_smallswatch { color = 230; key = "230"; }
      : clg5_smallswatch { color = 232; key = "232"; }
      : clg5_smallswatch { color = 234; key = "234"; }
      : clg5_smallswatch { color = 236; key = "236"; }
      : clg5_smallswatch { color = 238; key = "238"; }
    }
    : row {
      : spacer {}
      : clg5_smallswatch { color = 249; key = "249"; }
      : clg5_smallswatch { color = 247; key = "247"; }
      : clg5_smallswatch { color = 245; key = "245"; }
      : clg5_smallswatch { color = 243; key = "243"; }
      : clg5_smallswatch { color = 241; key = "241"; }
      : spacer {}
      : clg5_smallswatch { color = 240; key = "240"; }
      : clg5_smallswatch { color = 242; key = "242"; }
      : clg5_smallswatch { color = 244; key = "244"; }
      : clg5_smallswatch { color = 246; key = "246"; }
      : clg5_smallswatch { color = 248; key = "248"; }
    }
    : row {
      : spacer {}
      : text { label = "9 "; horizontal_margin = none; vertical_margin = none;}
      : text { label = "7 "; horizontal_margin = none; vertical_margin = none;}
      : text { label = "5 "; horizontal_margin = none; vertical_margin = none;}
      : text { label = "3 "; horizontal_margin = none; vertical_margin = none;}
      : text { label = "1 "; horizontal_margin = none; vertical_margin = none;}
      : spacer {}
      : text { label = "0"; horizontal_margin = none; vertical_margin = none;}
      : text { label = " 2"; horizontal_margin = none; vertical_margin = none;}
      : text { label = " 4"; horizontal_margin = none; vertical_margin = none;}
      : text { label = " 6"; horizontal_margin = none; vertical_margin = none;}
      : text { label = " 8"; horizontal_margin = none; vertical_margin = none;}
    }
}

//clg5_ltype : dialog {
//    label = "Select CLG Linetype";
//        :column {
//         fixed_height       = true;
//         height             = 1;
//        :text {
//           width            = 61;
//           height	    = 1.5;
//           key              = "setltype_header";
//           value            = "Linetype      Designation                              Sample";
//        }
//      :row {
//         fixed_height       = true;
//         height             = 1;
//        :text {
//           vertical_margin = none;
//           width            = 10;
//           height	    = 1;
//           key              = "Con_text";
//           value            = "Continuous";
//        }
//        :text {
//           vertical_margin = none;
//           width            = 3;
//           height	    = 1;
//           key              = "Con_symb";
//           value            = "-";
//        }
//          :image_button {
//            vertical_margin = none;
//            fixed_width     = true;
//            allow_accept    = true;
//            width           = 45;
//            height          = 1;
//            key             = "continuous_image";
//            color           = graphics_background;
//          }
//      }
//      :row {
//         fixed_height       = true;
//         height             = 1;
//        :text {
//           vertical_margin = none;
//           width            = 10;
//           height	    = 1;
//           key              = "Bdr_text";
//           value            = "Border";
//        }
//        :text {
//           vertical_margin = none;
//           width            = 3;
//           height	    = 1;
//           key              = "Bdr_symb";
//           value            = "B";
//        }
//          :image_button {
//            vertical_margin = none;
//            fixed_width     = true;
//            allow_accept    = true;
//            width           = 45;
//            height          = 1;
//            key             = "border_image";
//            color           = graphics_background;
//          }
//      }
//      : row {
//         fixed_height       = true;
//         height             = 1;
//        :text {
//           vertical_margin = none;
//           width            = 10;
//           height	    = 1;
//           key              = "ctr_text";
//           label            = "Center";
//        }
//        :text {
//           vertical_margin = none;
//           width            = 3;
//           height	    = 1;
//           key              = "Ctr_symb";
//           value            = "C";
//        }
//          :image_button {
//            vertical_margin = none;
//            fixed_width     = true;
//            allow_accept    = true;
//            width           = 45;
//            height          = 1;
//            key             = "center_image";
//            color           = graphics_background;
//          }
//      }
//      : row {
//         fixed_height       = true;
//         height             = 1;
//        :text {
//           vertical_margin = none;
//           width            = 10;
//           height	    = 1;
//           key              = "ctr2_text";
//           label            = "Center2";
//        }
//        :text {
//           vertical_margin = none;
//           width            = 3;
//           height	    = 1;
//           key              = "Ctr2_symb";
//           value            = "N";
//        }
//          :image_button {
//            vertical_margin = none;
//            fixed_width     = true;
//            allow_accept    = true;
//            width           = 45;
//            height          = 1;
//            key             = "center2_image";
//            color           = graphics_background;
//          }
//      }
//      : row {
//         fixed_height       = true;
//         height             = 1;
//        :text {
//           vertical_margin = none;
//           width            = 10;
//           height	    = 1;
//           key              = "Dd_text";
//           value            = "Dashdot";
//        }
//        :text {
//           vertical_margin = none;
//           width            = 3;
//           height	    = 1;
//           key              = "Dd_symb";
//           value            = "A";
//        }
//          :image_button {
//            vertical_margin = none;
//            fixed_width     = true;
//            allow_accept    = true;
//            width           = 45;
//            height          = 1;
//            key             = "dashdot_image";
//            color           = graphics_background;
//          }
//      }
//      : row {
//         fixed_height       = true;
//         height             = 1;
//        :text {
//           vertical_margin = none;
//           width            = 10;
//           height	    = 1;
//           key              = "Das_text";
//           value            = "Dashed";
//        }
//        :text {
//           vertical_margin = none;
//           width            = 3;
//           height	    = 1;
//           key              = "Das_symb";
//           value            = "D";
//        }
//          :image_button {
//            vertical_margin = none;
//            fixed_width     = true;
//            allow_accept    = true;
//            width           = 45;
//            height          = 1;
//            key             = "dashed_image";
//            color           = graphics_background;
//          }
//      }
//      : row {
//         fixed_height       = true;
//         height             = 1;
//        :text {
//           vertical_margin = none;
//           width            = 10;
//           height	    = 1;
//           key              = "Div_text";
//           value            = "Divide";
//        }
//        :text {
//           vertical_margin = none;
//           width            = 3;
//           height	    = 1;
//           key              = "Div_symb";
//           value            = "V";
//        }
//          :image_button {
//            vertical_margin = none;
//            fixed_width     = true;
//            allow_accept    = true;
//            width           = 45;
//            height          = 1;
//            key             = "divide_image";
//            color           = graphics_background;
//          }
//      }
//      : row {
//         fixed_height       = true;
//         height             = 1;
//        :text {
//           vertical_margin = none;
//           width            = 10;
//           height	    = 1;
//           key              = "Dot_text";
//           value            = "Dot";
//        }
//        :text {
//           vertical_margin = none;
//           width            = 3;
//           height	    = 1;
//           key              = "Dot_symb";
//           value            = "O";
//        }
//          :image_button {
//            vertical_margin = none;
//            fixed_width     = true;
//            allow_accept    = true;
//            width           = 45;
//            height          = 1;
//            key             = "dot_image";
//            color           = graphics_background;
//          }
//      }
//      : row {
//         fixed_height       = true;
//         height             = 1;
//        :text {
//           vertical_margin = none;
//           width            = 10;
//           height	    = 1;
//           key              = "Hid_text";
//           value            = "Hidden";
//        }
//        :text {
//           vertical_margin = none;
//           width            = 3;
//           height	    = 1;
//           key              = "Hid_symb";
//           value            = "H";
//        }
//          :image_button {
//            vertical_margin = none;
//            fixed_width     = true;
//            allow_accept    = true;
//            width           = 45;
//            height          = 1;
//            key             = "hidden_image";
//            color           = graphics_background;
//          }
//      }
//      : row {
//         fixed_height       = true;
//         height             = 1;
//        :text {
//           vertical_margin = none;
//           width            = 10;
//           height	    = 1;
//           key              = "Hid2_text";
//           value            = "Hidden2";
//        }
//        :text {
//           vertical_margin = none;
//           width            = 3;
//           height	    = 1;
//           key              = "Hid2_symb";
//           value            = "I";
//        }
//          :image_button {
//            vertical_margin = none;
//            fixed_width     = true;
//            allow_accept    = true;
//            width           = 45;
//            height          = 1;
//            key             = "hidden2_image";
//            color           = graphics_background;
//          }
//      }
//      : row {
//         fixed_height       = true;
//         height             = 1;
//        :text {
//           vertical_margin = none;
//           width            = 10;
//           height	    = 1;
//           key              = "Pha_text";
//           value            = "Phantom";
//        }
//        :text {
//           vertical_margin = none;
//           width            = 3;
//           height	    = 1;
//           key              = "Pha_symb";
//           value            = "P";
//        }
//          :image_button {
//            vertical_margin = none;
//            fixed_width     = true;
//            allow_accept    = true;
//            width           = 45;
//            height          = 1;
//            key             = "phantom_image";
//            color           = graphics_background;
//          }
//      }
//      : row {
//         fixed_height       = true;
//         height             = 1;
//        :text {
//           vertical_margin = none;
//           width            = 10;
//           height	    = 1;
//           key              = "Pha2_text";
//           value            = "Phantom2";
//        }
//        :text {
//           vertical_margin = none;
//           width            = 3;
//           height	    = 1;
//           key              = "Pha2_symb";
//           value            = "Q";
//        }
//          :image_button {
//            vertical_margin = none;
//            fixed_width     = true;
//            allow_accept    = true;
//            width           = 45;
//            height          = 1;
//            key             = "phantom2_image";
//            color           = graphics_background;
//          }
//      }
//    }
//    :row {
//        fixed_width = true;
//        alignment = centered;
//        children_alignment = bottom;
//        : spacer {
//          width = 2;
//        }
//        :text {
//          horizontal_margin = none;
//          is_bold = true;
//          width = 23;
//          value = "";
//          key = "part_lbl";
//        }
//    : edit_box {
//        key = "edit_lt";
//        allow_accept = false;
//        label = "Linetype:";
//        mnemonic = "L";
//	    edit_width = 24;
//	    edit_limit = 31;
//    }
//  }
//    ok_cancel_err;   
//}

clg5_button : button {
    alignment = centered;
    vertical_margin = none;
    horizontal_margin = none;
    fixed_width = true;
    height = 1;
    width = 15;
}

clg5_image : image {
    alignment = centered;
    horizontal_margin = none;
    vertical_margin = none;
}

clg5_popup_list : popup_list {
    alignment = right;
    horizontal_margin = tiny;
    vertical_margin = tiny;
}

clg5_toggle : toggle {
    alignment = centered;
    horizontal_margin = none;
    vertical_margin = none;
}

clg5_radio_button : radio_button {
    alignment = centered;
    horizontal_margin = none;
    vertical_margin = none;
}

clg5_boxed_radio_column : boxed_radio_column {
    alignment = centered;
    horizontal_margin = tiny;
    vertical_margin = tiny;
}

clg5_column : column {
    alignment = centered;
}

clg5_column_lt : column {
    alignment = left;
}

clg5_boxed_column : boxed_column {
    alignment = right;
    horizontal_margin = tiny;
    vertical_margin = tiny;
}

clg5_boxed_radio_row : boxed_radio_row {
    alignment = centered;
    horizontal_margin = tiny;
    vertical_margin = tiny;
}

clg5_radio_row : radio_row {
    alignment = centered;
}

clg5_boxed_row : boxed_row {
    alignment = centered;
    horizontal_margin = tiny;
    vertical_margin = tiny;
}

clg5_row : row {
    alignment = centered;
}

clg5_row_lt : row {
    alignment = left;
}

clg5_row_rt : row {
    alignment = right;
}


clg5_text : text {
    alignment = centered;
    horizontal_margin = tiny;
    vertical_margin = tiny;
}

clg5_textl : text {
    alignment = left;
    horizontal_margin = tiny;
    vertical_margin = tiny;
}

clg5_textr : text {
    alignment = right;
    horizontal_margin = tiny;
    vertical_margin = tiny;
}

clg5_list_box : list_box {
    alignment = centered;
    horizontal_margin = none;
    vertical_margin = none;
}

clg5_edit_box : edit_box {
    alignment = centered;
    vertical_margin   = none;
    height	      = 1;
}

clg5 : dialog {
      label = "AIA CAD Layer Guidelines - USNCADS Ver. 5 Management Dialog";
      fixed_width = true;
      width = 65;
//  : clg5_row {
    : clg5_column {
      : row{
        : spacer {}
        : spacer {}
          : clg5_button {
            mnemonic	    = "F";
            label           = "Find an Existing Layer";
            key             = "Set_exlayr";
//            width           = 8;
          }
        }
          : clg5_edit_box {
            key             = "clg5_layer";
            label           = "CLG Layer Name Constructed:";
            edit_width      = 45;
            }
      }
//    }
      : clg5_boxed_column {
        label           = "Construct CLG Layer Name";
        : clg5_row_lt {
        : clg5_column_lt {
        : clg5_row_rt {
//          : clg5_button {
//            label           = "Edit";
//            mnemonic	    = "E";
//            key             = "Edit_discipline";
//            width           = 5;
//          }
        : spacer {
          width		= 5;
        }
          : text {
            label           = "                      Discipline:";
          }
        }        
        : clg5_row_rt {
          : clg5_button {
            label           = "Edit";
            mnemonic	    = "d";
            key             = "Edit_major";
            width           = 5;
          }
          : text {
            label           = "               Major Group:";
          }
        }
        : clg5_row_rt {
          : clg5_button {
            label           = "Edit";
            mnemonic	    = "i";
            key             = "Edit_minor1";
            width           = 5;
          }
          : text {
            label           = "Minor Group: (optional)";
            key		    = "minor1_txt";
          }
        }
        : clg5_row_rt {
          : clg5_button {
            label           = "Edit";
            mnemonic	    = "i";
            key             = "Edit_minor2";
            width           = 5;
          }
          : text {
            label           = "Minor Group: (optional)";
            key		    = "minor2_txt";
          }
        }
        : clg5_row_rt {
          : clg5_button {
            label           = "Edit";
            mnemonic	    = "t";
            key             = "Edit_user";
            width           = 5;
          }
          : text {
            label           = "User Group: (optional)";
            key 	    = "user_txt";
          }
        }
        : clg5_row_rt {
        : spacer {
          width		= 5;
        }
//          : clg5_button {
//            label           = "Edit";
//            mnemonic	    = "t";
//            key             = "Edit_status";
//            width           = 5;
//          }
          : text {
            label           = "Status Group: (optional)";
            key 	    = "status_txt";
          }
        }
        }
        : clg5_column {
          : clg5_popup_list {
            tabs            = "8 10 14 16";
            fixed_width     = true;
            key             = "Discipline_list";
            width           = 65;
            }
          : clg5_popup_list {
            tabs            = "8 10 14 16";
            fixed_width     = true;
            key             = "Major_list";
            width           = 65;
          }
          : clg5_popup_list {
            tabs            = "8 10 14 16";
            fixed_width     = true;
            key             = "Minor1_list";
            width           = 65;
          }
          : clg5_popup_list {
            tabs            = "8 10 14 16";
            fixed_width     = true;
            key             = "Minor2_list";
            width           = 65;
          }
          : clg5_popup_list {
            tabs            = "8 10 14 16";
            fixed_width     = true;
            key             = "User_defined_list";
            width           = 65;
          }
          : clg5_popup_list {
            tabs            = "8 10 14 16";
            fixed_width     = true;
            key             = "Status_list";
            width           = 65;
          }
        }
      }
      : boxed_row {
        label           = "Specify Attributes for Constructed Layer";
        :edit_box {
            alignment = bottom;
            width = 4;
            fixed_width = true;
            label = "Color";
            key = "color_edit";
        }
        :myswatch {
            alignment = bottom;
            key = "color_image";
        }
//        :spacer { width = 2;}
        : clg5_text {
          label		= "Linetype:";
        }
        :image_button {
          alignment = bottom;
          width           = 45;
          height          = 1;
          key             = "clg5_lt_image";
          color           = graphics_background;
        }
        :edit_box {
            alignment = bottom;
            width = 12;
            fixed_width = true;
            label = "";
            key = "edit_lt";
        }
//        :spacer { width = 2;}
        : clg5_toggle {
            key           = "clg5_plot";
            mnemonic	    = "P";
            label         = "Plot";
        }
      }
    }
    : clg5_row {
          : clg5_button {
            label           = "Manuipulate Layers";
            mnemonic	    = "M";
            key             = "manip_layers";
          }
      ok_cancel_help;
      : spacer {}
    }
        : clg5_text {
          key		= "clg5_err";
          width		= 65;
        }
}

xlaysrch : dialog {
      initial_focus         = "filter_item";
      label                 = "Select Existing Layer";
          : row {
            : clg5_text {
              value           = "Layer Name:\t\t\t    -\tDescription:";
              key             = "layers_header";
              width           = 44;
            }
            : spacer {}
          }
          : list_box {
            tabs            = "28 34 40";
            width           =125;
            key             = "Results";
//            label           = "Search Results: ";
            }
          : row {
          :  boxed_row {
            label	= "Search Layer list";
            : clg5_button {
              mnemonic	    = "e";
//	      width           = 10;
              is_default      = true;
              label           = "Search";
              key             = "Filter";
            }
            : clg5_edit_box {
              key             = "filter_item";
              label           = "Filter text";
              allow_accept    = true;
              edit_width      = 36;
            }
            : spacer { width = 34;}
          }
    }
            clg5_ok_cancel;
            errtile;
}

selltype : dialog {
      initial_focus         = "Ltype_list";
      label                 = "Select Linetype";
          : row {
            : clg5_text {
              value           = "Linetype Name:\t\t\t    -\tDescription:";
              key             = "ltype_header";
              width           = 44;
            }
            : spacer {}
          }
          : list_box {
            tabs            = "28 34 40";
            width           =85;
            key             = "clg5_ltype_list";
            allow_accept    = true;
            }
            clg5_ok_cancel;
            errtile;
}

clg5_discipline : dialog {
      initial_focus         = "new_item";
      label                 = "Edit CLG Discipline Group Items";
  : clg5_column {
          : clg5_list_box {
            tabs            = "8 10 14 16";
            multiple_select = true;
            key             = "discipline_add";
            label           = "Discipline Group: ";
            }
          : clg5_edit_box {
            key             = "new_item";
            allow_accept    = true;
            edit_width      = 65;
            }
      : clg5_boxed_row {
            label           = "Edit Discipline Group Items and Descriptions";
          : clg5_text {
            value           = "Editing of the Discipline Group list is discouraged";
            key             = "group_name";
            width           = 44;
          }
          : clg5_button {
	    width           = 12;
            label           = "Append Tab-Tab";
            key             = "insert_tab";
          }
      }
  }
  : clg5_row {
          : clg5_button {
	    width           = 12;
            label           = "Add";
            key             = "Add_more";
          }
          : clg5_button {
	    width           = 12;
            label           = "Replace";
            key             = "Repl_line";
          }
          : clg5_button {
	    width           = 12;
            label           = "Delete";
            key             = "Delete_line";
          }
          : clg5_button {
	    width           = 12;
            mnemonic	    = "S";
            is_default      = true;
            label           = "Save and Close";
            key             = "Save_edits";
          }
//          : clg5_button {
//	    width           = 12;
//            label           = "Done";
//            key             = "Add_done";
//          }
          : clg5_button {
	    width           = 12;
            is_cancel       = true;
            label           = "Cancel";
            key             = "Add_cancel";
          }
        }
}

clg5_major : dialog {
      initial_focus         = "new_item";
      label                 = "Edit CLG Major Group Items";
  : clg5_textl {
     label	= "Filename: ";
     key	= "major_file";
     width	= 65;
  }
  : clg5_column {
          : clg5_list_box {
            tabs            = "8 10 14 16";
            multiple_select = true;
            key             = "major_add";
            label           = "Major Group: ";
            }
          : clg5_edit_box {
            key             = "new_item";
            allow_accept    = true;
            edit_width      = 65;
            }
      : clg5_boxed_row {
            label           = "Edit Major Group Items and Descriptions";
          : clg5_text {
            value           = "ITEM - New Descriptive Text";
            key             = "group_name";
            width           = 44;
          }
          : clg5_button {
	    width           = 12;
            label           = "Append Tab-Tab";
            key             = "insert_tab";
          }
      }
  }
  : clg5_row {
          : clg5_button {
	    width           = 12;
            label           = "Add";
            key             = "Add_more";
          }
          : clg5_button {
	    width           = 12;
            label           = "Replace";
            key             = "Repl_line";
          }
          : clg5_button {
	    width           = 12;
            label           = "Delete";
            key             = "Delete_line";
          }
          : clg5_button {
	    width           = 12;
            mnemonic	    = "S";
            is_default      = true;
            label           = "Save and Close";
            key             = "Save_edits";
          }
//          : clg5_button {
//	    width           = 12;
//            is_default      = true;
//            label           = "Done";
//            key             = "Add_done";
//          }
          : clg5_button {
	    width           = 12;
            is_cancel       = true;
            label           = "Cancel";
            key             = "Add_cancel";
          }
        }
}

clg5_minor : dialog {
      initial_focus         = "new_item";
      label                 = "Edit CLG Minor Group Items";
  : clg5_textl {
     label	= "Filename: ";
     key	= "minor_file";
     width	= 65;
  }
  : clg5_column {
          : clg5_list_box {
            tabs            = "8 10 14 16";
            multiple_select = true;
            key             = "minor_add";
            label           = "Minor Group: ";
            }
          : clg5_edit_box {
            key             = "new_item";
            allow_accept    = true;
            edit_width      = 65;
            }
      : clg5_boxed_row {
            label           = "Edit Minor Group Items and Descriptions";
          : clg5_text {
            value           = "ITEM - New Descriptive Text";
            key             = "group_name";
            width           = 44;
          }
          : clg5_button {
	    width           = 12;
            label           = "Append Tab-Tab";
            key             = "insert_tab";
          }
      }
  }
  : clg5_row {
          : clg5_button {
	    width           = 12;
            label           = "Add";
            key             = "Add_more";
          }
          : clg5_button {
	    width           = 12;
            label           = "Replace";
            key             = "Repl_line";
          }
          : clg5_button {
	    width           = 12;
            label           = "Delete";
            key             = "Delete_line";
          }
          : clg5_button {
	    width           = 12;
            mnemonic	    = "S";
            is_default      = true;
            label           = "Save and Close";
            key             = "Save_edits";
          }
//          : clg5_button {
//	    width           = 12;
//            is_default      = true;
//            label           = "Done";
//            key             = "Add_done";
//          }
          : clg5_button {
	    width           = 12;
            is_cancel       = true;
            label           = "Cancel";
            key             = "Add_cancel";
          }
        }
}

clg5_user : dialog {
      initial_focus         = "new_item";
      label                 = "Edit CLG User Defined Items";
  : clg5_textl {
     label	= "Filename: ";
     key	= "user_file";
     width	= 65;
  }
  : clg5_column {
          : clg5_list_box {
            tabs            = "8 10 14 16";
            multiple_select = true;
            key             = "user_add";
            label           = "User Defined Group: ";
            }
          : clg5_edit_box {
            key             = "new_item";
            allow_accept    = true;
            edit_width      = 65;
            }
      : clg5_boxed_row {
            label           = "Edit User Defined Items and Descriptions";
          : clg5_text {
            value           = "ITEM  - New Descriptive Text";
            key             = "group_name";
            width           = 44;
          }
          : clg5_button {
	    width           = 12;
            label           = "Append Tab-Tab";
            key             = "insert_tab";
          }
      }
  }
  : clg5_row {
          : clg5_button {
	    width           = 12;
            label           = "Add";
            key             = "Add_more";
          }
          : clg5_button {
	    width           = 12;
            label           = "Replace";
            key             = "Repl_line";
          }
          : clg5_button {
	    width           = 12;
            label           = "Delete";
            key             = "Delete_line";
          }
          : clg5_button {
	    width           = 12;
            mnemonic	    = "S";
            is_default      = true;
            label           = "Save and Close";
            key             = "Save_edits";
          }
//          : clg5_button {
//	    width           = 12;
//            is_default      = true;
//            label           = "Done";
//            key             = "Add_done";
//          }
          : clg5_button {
	    width           = 12;
            is_cancel       = true;
            label           = "Cancel";
            key             = "Add_cancel";
          }
        }
}

clg5_manip : dialog {
      initial_focus         = "new_item";
      label 		    = "AIA CAD Layer Guidelines - USNCADS Ver. 5 - Layer Manipulation Tool";
          : row {
          : clg5_boxed_column {
              label		= "CLG Groups";
            : clg5_text {
              label           = "Edits and Wildcards OK";
            }
            : clg5_textl {
              label           = "Layer Match String: ";
              key	      = "man_str";
              width	      = 20;
            }
            : clg5_edit_box {
              key             = "clg5_discipline";
              edit_width      = 15;
              mnemonic        = "D";
              label	      = "Discipline";
            }
            : clg5_edit_box {
              key             = "clg5_major";
              edit_width      = 15;
              mnemonic        = "i";
              label	      = "Major Group";
            }
            : clg5_edit_box {
              key             = "clg5_minor1";
              edit_width      = 15;
              mnemonic        = "g";
              label	      = "Minor Group (optional)";
            }
            : clg5_edit_box {
              key             = "clg5_minor2";
              edit_width      = 15;
              mnemonic        = "g";
              label	      = "Minor Group (optional)";
            }
            : clg5_edit_box {
              key             = "clg5_userd";
              edit_width      = 15;
              mnemonic        = "U";
              label	      = "User Group (optional)";
            }
            : clg5_edit_box {
              key             = "clg5_status";
              edit_width      = 15;
              mnemonic        = "S";
              label	      = "Status Group (optional)";
            }
        : spacer {}
        }
        : column {
          : clg5_boxed_column {
            : clg5_toggle {
              key           = "clg5_select";
              mnemonic	    = "C";
              label         = "Create Selection Set";
            }
            : clg5_text {
              label           = "\"!clgss\" or \"previous\" to use";
            }
            : row {
        : clg5_toggle {
            key             = "not_xreflay";
            value           = "0";
            mnemonic	    = "x";
            label           = "Ignore xref layers";
          }
          : clg5_button {
	    width           = 12;
            label           = "Isolate";
            mnemonic	    = "I";
            key             = "clg5_isolate";
          }
          }
            : spacer {}
          }
          : clg5_boxed_column {
              label		= "Change Settings";
          : clg5_popup_list {
            label	    = "On/Off:   ";
            mnemonic        = "n";
            fixed_width     = true;
            key             = "lay_onoff";
            edit_width      = 8;
            list	    = "Keep\nOn\nOff\n ";
          }
          : clg5_popup_list {
            label	    = "Freeze/Thaw:";
            mnemonic        = "F";
            fixed_width     = true;
            key             = "lay_frzthw";
            edit_width      = 8;
            list	    = "Keep\nFreeze\nThaw\n ";
          }
          : clg5_popup_list {
            label	    = "VPfreeze/Thaw:";
            mnemonic        = "V";
            fixed_width     = true;
            key             = "lay_vpfthw";
            edit_width      = 8;
            list	    = "Keep\nFreeze\nThaw\n ";
          }
          : clg5_popup_list {
            label	    = "Lock/Unlock: ";
            mnemonic        = "k";
            fixed_width     = true;
            key             = "lay_lckunl";
            edit_width      = 8;
            list	    = "Keep\nLock\nUnlock\n ";
          }
          : clg5_popup_list {
            label	    = "Plot/Noplot:";
            mnemonic        = "P";
            fixed_width     = true;
            key             = "lay_pltnop";
            edit_width      = 8;
            list	    = "Keep\nPlot\nNoplot\n ";
          }
        : spacer {}
        }
        }
      }
      ok_cancel_help;
        : clg5_text {
          key		= "clg5_err";
          width		= 65;
        }
}

set_clg5_color :dialog {
    label = "Select CLG Color";
    :row {
:column {
  : row {
  : column {
   children_alignment = centered;
  :text { label = "Color"; horizontal_margin = none; vertical_margin = none;}
     clg5_base_colors;
   }
: column {
   children_alignment = centered;
   : text { label = "ID"; horizontal_margin = none; vertical_margin = none;}
   : spacer { height = 1;}
   : spacer { height = 1;}
   : spacer { height = 1;}
   : text { label = "1"; horizontal_margin = none; vertical_margin = none;}
   : text { label = "2"; horizontal_margin = none; vertical_margin = none;}
   : text { label = "3"; horizontal_margin = none; vertical_margin = none;}
   : text { label = "4"; horizontal_margin = none; vertical_margin = none;}
   : text { label = "5"; horizontal_margin = none; vertical_margin = none;}
   : text { label = "6"; horizontal_margin = none; vertical_margin = none;}
   : text { label = "7"; horizontal_margin = none; vertical_margin = none;}
   : text { label = "8"; horizontal_margin = none; vertical_margin = none;}
   : text { label = "9"; horizontal_margin = none; vertical_margin = none;}
   : spacer { height = 1;}
   : spacer { height = 1;}
   : text { label = "250"; horizontal_margin = none; vertical_margin = none;}
   : text { label = "251"; horizontal_margin = none; vertical_margin = none;}
   : text { label = "252"; horizontal_margin = none; vertical_margin = none;}
   : text { label = "253"; horizontal_margin = none; vertical_margin = none;}
   : text { label = "254"; horizontal_margin = none; vertical_margin = none;}
   : text { label = "255"; horizontal_margin = none; vertical_margin = none;}
   : spacer { height = 1;}
   : spacer { height = 1;}
   : spacer { height = 1;}
   }
: column {
   children_alignment = centered;
   : text { label = "Name"; horizontal_margin = none; vertical_margin = none;}
   : spacer { height = 1;}
   : spacer { height = 1;}
   : spacer { height = 1;}
   : text { label = "Red"; horizontal_margin = none; vertical_margin = none;}
   : text { label = "Yellow"; horizontal_margin = none; vertical_margin = none;}
   : text { label = "Green"; horizontal_margin = none; vertical_margin = none;}
   : text { label = "Cyan"; horizontal_margin = none; vertical_margin = none;}
   : text { label = "Blue"; horizontal_margin = none; vertical_margin = none;}
   : text { label = "Magenta"; horizontal_margin = none; vertical_margin = none;}
   : text { label = "White"; horizontal_margin = none; vertical_margin = none;}
   : text { label = "8"; horizontal_margin = none; vertical_margin = none;}
   : text { label = "9"; horizontal_margin = none; vertical_margin = none;}
   : spacer { height = 1;}
   : spacer { height = 1;}
   : text { label = ""; horizontal_margin = none; vertical_margin = none;}
   : text { label = ""; horizontal_margin = none; vertical_margin = none;}
   : text { label = ""; horizontal_margin = none; vertical_margin = none;}
   : text { label = ""; horizontal_margin = none; vertical_margin = none;}
   : text { label = ""; horizontal_margin = none; vertical_margin = none;}
   : text { label = ""; horizontal_margin = none; vertical_margin = none;}
   : spacer { height = 1;}
   : spacer { height = 1;}
   : spacer { height = 1;}
  }
 }
  }
:column {
   children_alignment = centered;
  :text { label = "Color"; horizontal_margin = none; vertical_margin = none;}
    clg5_std_colors;
  }
//: column {
//   children_alignment = centered;
//   : text { label = "ID"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "A"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "B"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "C"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "D"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "E"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "F"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "G"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "G"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "H"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "H"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "I"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "J"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "K"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "L"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "M"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "N"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "O"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "P"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "Q"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "R"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "S"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "S"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "T"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "T"; horizontal_margin = none; vertical_margin = none;}
//}
: column {
   children_alignment = centered;
   : text { label = "Group"; horizontal_margin = none; vertical_margin = none;}
   : spacer { height = 1;}
   : text { key = "clg5_cno_10"; value = "10"; width = 4; horizontal_margin = none; vertical_margin = none;}
   : text { key = "clg5_cno_20"; value = "20"; width = 4; horizontal_margin = none; vertical_margin = none;}
   : text { key = "clg5_cno_30"; value = "30"; width = 4; horizontal_margin = none; vertical_margin = none;}
   : text { key = "clg5_cno_40"; value = "40"; width = 4; horizontal_margin = none; vertical_margin = none;}
   : text { key = "clg5_cno_50"; value = "50"; width = 4; horizontal_margin = none; vertical_margin = none;}
   : text { key = "clg5_cno_60"; value = "60"; width = 4; horizontal_margin = none; vertical_margin = none;}
   : text { key = "clg5_cno_70"; value = "70"; width = 4; horizontal_margin = none; vertical_margin = none;}
   : text { key = "clg5_cno_80"; value = "80"; width = 4; horizontal_margin = none; vertical_margin = none;}
   : text { key = "clg5_cno_90"; value = "90"; width = 4; horizontal_margin = none; vertical_margin = none;}
   : text { key = "clg5_cno_100"; value = "100"; width = 4; horizontal_margin = none; vertical_margin = none;}
   : text { key = "clg5_cno_110"; value = "110"; width = 4; horizontal_margin = none; vertical_margin = none;}
   : text { key = "clg5_cno_120"; value = "120"; width = 4; horizontal_margin = none; vertical_margin = none;}
   : text { key = "clg5_cno_130"; value = "130"; width = 4; horizontal_margin = none; vertical_margin = none;}
   : text { key = "clg5_cno_140"; value = "140"; width = 4; horizontal_margin = none; vertical_margin = none;}
   : text { key = "clg5_cno_150"; value = "150"; width = 4; horizontal_margin = none; vertical_margin = none;}
   : text { key = "clg5_cno_160"; value = "160"; width = 4; horizontal_margin = none; vertical_margin = none;}
   : text { key = "clg5_cno_170"; value = "170"; width = 4; horizontal_margin = none; vertical_margin = none;}
   : text { key = "clg5_cno_180"; value = "180"; width = 4; horizontal_margin = none; vertical_margin = none;}
   : text { key = "clg5_cno_190"; value = "190"; width = 4; horizontal_margin = none; vertical_margin = none;}
   : text { key = "clg5_cno_200"; value = "200"; width = 4; horizontal_margin = none; vertical_margin = none;}
   : text { key = "clg5_cno_210"; value = "210"; width = 4; horizontal_margin = none; vertical_margin = none;}
   : text { key = "clg5_cno_220"; value = "220"; width = 4; horizontal_margin = none; vertical_margin = none;}
   : text { key = "clg5_cno_230"; value = "230"; width = 4; horizontal_margin = none; vertical_margin = none;}
   : text { key = "clg5_cno_240"; value = "240"; width = 4; horizontal_margin = none; vertical_margin = none;}
   : spacer { height = 1;}
}
//: column {
//   children_alignment = centered;
//   : text { label = "Pen Thickness"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "1.30mm (.051\")"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "0.10mm (.004\")"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "0.30mm (.012\")"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "0.30mm (.012\")"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "0.30mm (.012\")"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "0.30mm (.012\")"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "0.30mm (.012\")"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "0.30mm (.012\")"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "0.30mm (.012\")"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "0.30mm (.012\")"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "0.30mm (.012\")"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "0.30mm (.012\")"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "0.30mm (.012\")"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "0.30mm (.012\")"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "0.30mm (.012\")"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "0.30mm (.012\")"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "0.30mm (.012\")"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "0.30mm (.012\")"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "0.30mm (.012\")"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "0.30mm (.012\")"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "0.30mm (.012\")"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "0.30mm (.012\")"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "0.30mm (.012\")"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "0.30mm (.012\")"; horizontal_margin = none; vertical_margin = none;}
//  }
//: column {
//   children_alignment = centered;
//   : text { label = "Leroy"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "~4"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "0000"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "00"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "00"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "00"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "00"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "00"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "00"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "00"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "00"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "00"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "00"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "00"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "00"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "00"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "00"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "00"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "00"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "00"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "00"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "00"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "00"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "00"; horizontal_margin = none; vertical_margin = none;}
//   : text { label = "00"; horizontal_margin = none; vertical_margin = none;}
// }
}
    :row {
//        fixed_width = true;
//        alignment = centered;
//        children_alignment = bottom;
//        :text {
//          horizontal_margin = none;
//          is_bold = true;
//          width = 23;
//          value = "";
//          key = "part_lbl";
//        }
        : spacer { width = 8;}
        :edit12_box {
            horizontal_margin = none;
            label = "Color:";
            key = "color_edit";
            allow_accept = true;
        }
        :myswatch {
            alignment = bottom;
            key = "color_image";
        }
        : spacer { width = 8;}
    }
    ok_cancel_help_errtile;
}

