;;;CLG Doctor ver. 5 main lsp file (a dialog CLG management tool).
;;;
;;;	Author:	Henry C. Francis
;;;		425 N. Ashe St.
;;;		Southern Pines, NC 28387
;;;
;;;	Copyright: 1996-2011
;;;
;;;	http://paracadd.com
;;;	All rights reserved.
;;;
;;;Requires:	UKWORD.LSP
;;;
;;;****************************************************************************
(defun c:clg5
       (/)                        ;clg5_discipline clg5_ltype clg5_major clg5_color clg5_minor1 clg5_minor2 clg5_user; clg5dis clg5llt clg5maj clg5col clg5min1 clg5min2 clg5usr
  (setq quit_clg5 nil)
  (setq res_hist NIL major_list nil);kills some phantom hook to the old clg (res_hist) function which is not called anywhere in this program!?
  (if check_for_doslib
    NIL
    (LOAD "check_for_doslib" "\nFile CHECK_FOR_DOSLIB.LSP not loaded! ")
  )
  (check_for_doslib)  
  (vl-arx-import 'DOS_HTMLBOX)
  (vl-arx-import 'DOS_DIRP)
  (vl-arx-import 'DOS_MSGBOX)
  (setq clg5_num (load_dialog "clg5"))
  (new_dialog
    "clg5"
    clg5_num
    ""
    (if (AND clg5_loc (not (equal clg5_loc '(0 0))))
      clg5_loc
      (IF old_clg5_loc
        old_clg5_loc
        '(-1 -1)
      ) ;_ end of IF
    ) ;_ end of if
  ) ;_ end of new_dialog
  (IF (EQUAL clg5_loc '(0 0))
    NIL
    (SETQ old_clg5_loc clg5_loc)
  ) ;_ end of IF
  (IF (SETQ fndclg5hlp (FINDFILE "clg5_help.htm"))
    NIL
    (SETQ fndclg5hlp "http://www.paracadd.com/clg/clg5_help.htm")
  ) ;_ end of IF
  (IF helphtm NIL (LOAD "helphtm" "\nFile HELPHTM.LSP not loaded! "))
  (if clg5_err
    (progn
      (set_tile "clg5_err" clg5_err)
      (setq clg5_err nil)
    ) ;_ end of progn
  ) ;_ end of if
  (setq clg5_funct nil)
  (IF clg5_color_no
    (SETQ sel_clg5_color clg5_color_no)
    (IF clg5_cur_colr
      (SETQ sel_clg5_color clg5_cur_colr)
      (IF sel_clg5_color
        (SETQ clg5_cur_colr sel_clg5_color
              clg5_color_no sel_clg5_color
        )
        (SETQ sel_clg5_color 1
              clg5_cur_colr 1
              clg5_color_no 1
        )
      )
    )
  )
  (IF clg5_lt_inx
    nil
    (SETQ clg5_lt_idx "0")
  ) ;_ end of if
  (set_clg5_ltype_list)
  (SETQ clg5_ltnmlst (MAPCAR 'CAR clg5_ltype_list))
  (clg5_makeltlists)
  (action_tile
    "Set_exlayr"
    "(clg5_clr_err)(srch_clg5_list)(setq curlay (get_tile \"Exist_lay\"))(setq clg5_loc(if from_f2f(done_dialog 2)(done_dialog 1)))"
;;;    "(clg5_clr_err)(setq curlay (get_tile \"Exist_lay\"))(setq clg5_loc(done_dialog 1))"
  ) ;_ end of action_tile
  (action_tile
    "accept"
    "(clg5_clr_err)(get_all_tiles)(setq clg5lay (get_tile \"clg5_layer\") curlay nil)(setq clg5_loc(done_dialog 1))";(set_hist)
  ) ;_ end of action_tile
  (action_tile
    "cancel"
    "(clg5_clr_err)(setq clg5lay nil curlay nil quit_clg5 T)(setq clg5_loc(done_dialog 2))"
  ) ;_ end of action_tile
  (action_tile
    "clg5_layer"
    "(clg5_clr_err)(setq clg5lay $value)(f_layer_list)"
  ) ;_ end of action_tile
  (action_tile
    "Discipline_list"
    "(clg5_clr_err)(setq clg5dis (get_tile \"Discipline_list\"))(setq discipline(substr(nth(atoi clg5dis)discipline_list)1 2))(f_discipline)(f_cc)"
  ) ;_ end of action_tile
  (action_tile
    "Edit_major"
    "(setq whlst \"major\")(clg5_edat)"
  ) ;_ end of action_tile
  (action_tile
    "Major_list"
    "(clg5_clr_err)(setq clg5maj (get_tile \"Major_list\"))(setq prod(substr(nth(atoi clg5maj)major_list)1 4))(setq clg5_major prod)(f_major)(f_cc)";(set_hist)
  ) ;_ end of action_tile
  (action_tile
    "Edit_minor1"
    "(clg5_clr_err)(setq whlst \"minor1\")(clg5_edat)"
  ) ;_ end of action_tile
  (action_tile
    "Minor1_list"
    "(clg5_clr_err)(setq clg5min1 (get_tile \"Minor1_list\") clg5_minor1 (substr(nth(atoi clg5min1)minor1_list)1 4))(f_cc)";(set_hist)
  ) ;_ end of action_tile
  (action_tile
    "Edit_minor2"
    "(clg5_clr_err)(setq whlst \"minor2\")(clg5_edat)"
  ) ;_ end of action_tile
  (action_tile
    "Minor2_list"
    "(clg5_clr_err)(setq clg5min2 (get_tile \"Minor2_list\") clg5_minor2 (substr(nth(atoi clg5min2)minor2_list)1 4))(f_cc)";(set_hist)
  ) ;_ end of action_tile
  (action_tile
    "Edit_user"
    "(clg5_clr_err)(setq whlst \"user\")(clg5_edat)"
  ) ;_ end of action_tile
  (action_tile
    "User_defined_list"
    "(clg5_clr_err)(setq clg5usr (get_tile \"User_defined_list\"))(f_user)(f_cc)";(set_hist)
  ) ;_ end of action_tile
  (action_tile
    "Status_list"
    "(clg5_clr_err)(setq clg5sta (get_tile \"Status_list\"))(f_status)(f_cc)";(set_hist)
  ) ;_ end of action_tile
  (action_tile
    "color_image"
    "(set_clg5_color)(set_clg5_color_no sel_clg5_color)(set_clg5_lt_image)";(clg5_ltedit_act)
  )
  (ACTION_TILE "color_edit" "(get_clg5_color_no(get_tile\"color_edit\"))(clg5_ltedit_act)")
  (action_tile
    "clg5_lt_image"
    "(set_clg5_ltype_list)(select_clg5_ltype)(set_clg5_lt_image)(set_clg5_co)(clg5_ltedit_act)"
  )
  (action_tile
    "edit_lt"
    "(clg5_ltedit_act)"
  )
  (action_tile
    "clg5_plot"
    "(setq clg5_plot (get_tile\"clg5_plot\"))"
  )
  (action_tile
    "manip_layers"
;;;    "(manip_layers)"
    "(clg5_clr_err)(setmansets)(setq clg5_funct '(c:manclg5))(setq clg5lay nil curlay nil quit_clg5 T)(setq clg5_loc(done_dialog 2))"
  ) ;_ end of action_tile
  (action_tile
    "help"
    "(setq clg5lay nil curlay nil quit_clg5 T do_help T)(setq clg5_loc (done_dialog 2))"
  ) ;_ end of action_tile
  (IF clg5_plot NIL (setq clg5_plot "1"))
  (SET_TILE "clg5_plot" clg5_plot)
;;;  (SET_TILE "color_edit"
;;;            (clg5_citocs (IF clg5_cur_colr
;;;                      clg5_cur_colr
;;;                      1
;;;                    ) ;_ end of if
;;;            ) ;_ end of clg5_citocs
;;;  ) ;_ end of set_tile
  (set_clg5_color_no (COND (clg5_cur_colr clg5_cur_colr)(sel_clg5_color sel_clg5_color)(clg5_color_no clg5_color_no)(t 1)))
  (set_clg5_lt_image)
  (if from_para
    (progn
      (mode_tile "Set_exlayr" 1)
      (mode_tile "exlaname" 1)
;;;      (mode_tile "user_txt" 1)
      (mode_tile "minor1_txt" 1)
      (mode_tile "minor2_txt" 1)
      (mode_tile "Exist_lay" 1)
      (mode_tile "clg5_length" 1)
      (mode_tile "Edit_minor1" 1)
      (mode_tile "Minor1_list" 1)
      (mode_tile "Edit_minor2" 1)
      (mode_tile "Minor2_list" 1)
;;;      (mode_tile "Edit_user" 1)
;;;      (mode_tile "User_defined_list" 1)
      (mode_tile "manip_layers" 1)
    ) ;_ end of progn
  ) ;_ end of if
  (if from_para
    (progn
      (set_lay_list)                        ;Constructs a list of layers in the drawing
      (setq clg5_discipline pipe_discipline)
      (f_discipline)
      (setq clg5_major pipe_majr)
      (start_list "Major_list")
      (mapcar 'add_list major_list)
      (end_list)
      (set_list major_list "Major_list" clg5_major 4)
      (setq clg5_minor1 "")
      (setq clg5_minor2 "")
      (setq clg5_user (IF pipe_user
                       pipe_user
                       ""
                     ) ;_ end of IF
      ) ;_ end of setq
      (f_cc)
      (f_user)
    ) ;_ end of progn
    (progn
      (f_all)
;;;      (clg5_res_hist)
    ) ;_ end of progn
  ) ;_ end of if
  (set_clg5_lt_image)
  (setq sd_result (start_dialog))
  (if (and do_help (EQ quit_clg5 T))
    (PROGN
      (helphtm "CLG Doctor - AIA CAD Layer Guidelines - USNCADS Version 5 - Management Dialog" fndclg5hlp)
      (SETQ do_help NIL)
    )
    (IF clg5_funct
      (progn
        (EVAL clg5_funct)
        (setq clg5_funct nil)
      )
      (clg5_done sd_result)
    )
  ) ;_ end of if
  (unload_dialog clg5_num)
  (princ)
)
;;;********************************************************************
(defun clg5vars ()
  (if (and sel_clg5_str (eq (type sel_clg5_str) 'STR))
    (progn
      (cond
        ((and
           (eq (strlen sel_clg5_str) 25)
           (eq(substr sel_clg5_str 3 1) "-")
           (eq(substr sel_clg5_str 8 1) "-")
           (eq(substr sel_clg5_str 13 1) "-")
           (eq(substr sel_clg5_str 18 1) "-")
           (eq(substr sel_clg5_str 23 1) "-")
         )
         (setq clg5_discipline (substr sel_clg5_str 1 2)
               clg5_major (substr sel_clg5_str 4 4)
               clg5_minor1 (substr sel_clg5_str 9 4)
               clg5_minor2 (substr sel_clg5_str 14 4)
               clg5_user (substr sel_clg5_str 19 4)
               clg5_status (substr sel_clg5_str 24 2)
         ))
        ((and
           (eq (strlen sel_clg5_str) 24)
           (eq(substr sel_clg5_str 3 1) "-")
           (eq(substr sel_clg5_str 8 1) "-")
           (eq(substr sel_clg5_str 13 1) "-")
           (eq(substr sel_clg5_str 18 1) "-")
           (eq(substr sel_clg5_str 23 1) "-")
         )
         (setq clg5_discipline (substr sel_clg5_str 1 2)
               clg5_major (substr sel_clg5_str 4 4)
               clg5_minor1 (substr sel_clg5_str 9 4)
               clg5_minor2 (substr sel_clg5_str 14 4)
               clg5_user (substr sel_clg5_str 19 4)
               clg5_status (substr sel_clg5_str 24 1)
         ))
        ((and
           (eq (strlen sel_clg5_str) 24)
           (eq(substr sel_clg5_str 2 1) "-")
           (eq(substr sel_clg5_str 7 1) "-")
           (eq(substr sel_clg5_str 12 1) "-")
           (eq(substr sel_clg5_str 17 1) "-")
           (eq(substr sel_clg5_str 22 1) "-")
         )
         (setq clg5_discipline (substr sel_clg5_str 1 1)
               clg5_major (substr sel_clg5_str 3 4)
               clg5_minor1 (substr sel_clg5_str 8 4)
               clg5_minor2 (substr sel_clg5_str 13 4)
               clg5_user (substr sel_clg5_str 18 4)
               clg5_status (substr sel_clg5_str 23 2)
         ))
        ((and
           (eq (strlen sel_clg5_str) 23)
           (eq(substr sel_clg5_str 2 1) "-")
           (eq(substr sel_clg5_str 7 1) "-")
           (eq(substr sel_clg5_str 12 1) "-")
           (eq(substr sel_clg5_str 17 1) "-")
           (eq(substr sel_clg5_str 22 1) "-")
         )
         (setq clg5_discipline (substr sel_clg5_str 1 1)
               clg5_major (substr sel_clg5_str 3 4)
               clg5_minor1 (substr sel_clg5_str 8 4)
               clg5_minor2 (substr sel_clg5_str 13 4)
               clg5_user (substr sel_clg5_str 18 4)
               clg5_status (substr sel_clg5_str 23 1)
         ))
        ((and
           (eq (strlen sel_clg5_str) 22)
           (eq(substr sel_clg5_str 3 1) "-")
           (eq(substr sel_clg5_str 8 1) "-")
           (eq(substr sel_clg5_str 13 1) "-")
           (eq(substr sel_clg5_str 18 1) "-")
         )
         (setq clg5_discipline (substr sel_clg5_str 1 2)
               clg5_major (substr sel_clg5_str 4 4)
               clg5_minor1 (substr sel_clg5_str 9 4)
               clg5_minor2 (substr sel_clg5_str 14 4)
               clg5_user (substr sel_clg5_str 19 4)
         ))
        ((and
           (eq (strlen sel_clg5_str) 21)
           (eq(substr sel_clg5_str 2 1) "-")
           (eq(substr sel_clg5_str 7 1) "-")
           (eq(substr sel_clg5_str 12 1) "-")
           (eq(substr sel_clg5_str 17 1) "-")
         )
         (setq clg5_discipline (substr sel_clg5_str 1 1)
               clg5_major (substr sel_clg5_str 3 4)
               clg5_minor1 (substr sel_clg5_str 8 4)
               clg5_minor2 (substr sel_clg5_str 13 4)
               clg5_user (substr sel_clg5_str 18 4)
         ))
        ((and
           (eq (strlen sel_clg5_str) 20)
           (eq(substr sel_clg5_str 3 1) "-")
           (eq(substr sel_clg5_str 8 1) "-")
           (eq(substr sel_clg5_str 13 1) "-")
           (eq(substr sel_clg5_str 18 1) "-")
         )
         (setq clg5_discipline (substr sel_clg5_str 1 2)
               clg5_major (substr sel_clg5_str 4 4)
               clg5_minor1 (substr sel_clg5_str 9 4)
               clg5_minor2 (substr sel_clg5_str 14 4)
               clg5_status (substr sel_clg5_str 19 2)
         ))
        ((and
           (eq (strlen sel_clg5_str) 19)
           (eq(substr sel_clg5_str 3 1) "-")
           (eq(substr sel_clg5_str 8 1) "-")
           (eq(substr sel_clg5_str 13 1) "-")
           (eq(substr sel_clg5_str 18 1) "-")
         )
         (setq clg5_discipline (substr sel_clg5_str 1 2)
               clg5_major (substr sel_clg5_str 4 4)
               clg5_minor1 (substr sel_clg5_str 9 4)
               clg5_minor2 (substr sel_clg5_str 14 4)
               clg5_status (substr sel_clg5_str 19 1)
         ))
        ((and
           (eq (strlen sel_clg5_str) 19)
           (eq(substr sel_clg5_str 2 1) "-")
           (eq(substr sel_clg5_str 7 1) "-")
           (eq(substr sel_clg5_str 12 1) "-")
           (eq(substr sel_clg5_str 17 1) "-")
         )
         (setq clg5_discipline (substr sel_clg5_str 1 1)
               clg5_major (substr sel_clg5_str 3 4)
               clg5_minor1 (substr sel_clg5_str 8 4)
               clg5_minor2 (substr sel_clg5_str 13 4)
               clg5_status (substr sel_clg5_str 18 2)
         ))
        ((and
           (eq (strlen sel_clg5_str) 18)
           (eq(substr sel_clg5_str 2 1) "-")
           (eq(substr sel_clg5_str 7 1) "-")
           (eq(substr sel_clg5_str 12 1) "-")
           (eq(substr sel_clg5_str 17 1) "-")
         )
         (setq clg5_discipline (substr sel_clg5_str 1 1)
               clg5_major (substr sel_clg5_str 3 4)
               clg5_minor1 (substr sel_clg5_str 8 4)
               clg5_minor2 (substr sel_clg5_str 13 4)
               clg5_status (substr sel_clg5_str 18 1)
         ))
        ((and
           (eq (strlen sel_clg5_str) 17)
           (eq(substr sel_clg5_str 3 1) "-")
           (eq(substr sel_clg5_str 8 1) "-")
           (eq(substr sel_clg5_str 13 1) "-")
         )
         (setq clg5_discipline (substr sel_clg5_str 1 2)
               clg5_major (substr sel_clg5_str 4 4)
               clg5_minor1 (substr sel_clg5_str 9 4)
               clg5_minor2 (substr sel_clg5_str 14 4)
         ))
        ((and
           (eq (strlen sel_clg5_str) 16)
           (eq(substr sel_clg5_str 2 1) "-")
           (eq(substr sel_clg5_str 7 1) "-")
           (eq(substr sel_clg5_str 12 1) "-")
         )
         (setq clg5_discipline (substr sel_clg5_str 1 1)
               clg5_major (substr sel_clg5_str 3 4)
               clg5_minor1 (substr sel_clg5_str 8 4)
               clg5_minor2 (substr sel_clg5_str 13 4)
         ))
        ((and
           (eq (strlen sel_clg5_str) 15)
           (eq(substr sel_clg5_str 3 1) "-")
           (eq(substr sel_clg5_str 8 1) "-")
           (eq(substr sel_clg5_str 13 1) "-")
         )
         (setq clg5_discipline (substr sel_clg5_str 1 2)
               clg5_major (substr sel_clg5_str 4 4)
               clg5_minor1 (substr sel_clg5_str 9 4)
               clg5_status (substr sel_clg5_str 14 2)
         ))
        ((and
           (eq (strlen sel_clg5_str) 14)
           (eq(substr sel_clg5_str 3 1) "-")
           (eq(substr sel_clg5_str 8 1) "-")
           (eq(substr sel_clg5_str 13 1) "-")
         )
         (setq clg5_discipline (substr sel_clg5_str 1 2)
               clg5_major (substr sel_clg5_str 4 4)
               clg5_minor1 (substr sel_clg5_str 9 4)
               clg5_status (substr sel_clg5_str 14 1)
         ))
        ((and
           (eq (strlen sel_clg5_str) 14)
           (eq(substr sel_clg5_str 2 1) "-")
           (eq(substr sel_clg5_str 7 1) "-")
           (eq(substr sel_clg5_str 12 1) "-")
         )
         (setq clg5_discipline (substr sel_clg5_str 1 1)
               clg5_major (substr sel_clg5_str 3 4)
               clg5_minor1 (substr sel_clg5_str 8 4)
               clg5_status (substr sel_clg5_str 13 2)
         ))
        ((and
           (eq (strlen sel_clg5_str) 13)
           (eq(substr sel_clg5_str 2 1) "-")
           (eq(substr sel_clg5_str 7 1) "-")
           (eq(substr sel_clg5_str 12 1) "-")
         )
         (setq clg5_discipline (substr sel_clg5_str 1 1)
               clg5_major (substr sel_clg5_str 3 4)
               clg5_minor1 (substr sel_clg5_str 8 4)
               clg5_status (substr sel_clg5_str 13 1)
         ))
        ((and
           (eq (strlen sel_clg5_str) 12)
           (eq(substr sel_clg5_str 3 1) "-")
           (eq(substr sel_clg5_str 8 1) "-")
         )
         (setq clg5_discipline (substr sel_clg5_str 1 2)
               clg5_major (substr sel_clg5_str 4 4)
               clg5_minor1 (substr sel_clg5_str 9 4)
         ))
        ((and
           (eq (strlen sel_clg5_str) 11)
           (eq(substr sel_clg5_str 2 1) "-")
           (eq(substr sel_clg5_str 7 1) "-")
         )
         (setq clg5_discipline (substr sel_clg5_str 1 1)
               clg5_major (substr sel_clg5_str 3 4)
               clg5_minor1 (substr sel_clg5_str 8 4)
         ))
        ((and
           (eq (strlen sel_clg5_str) 10)
           (eq(substr sel_clg5_str 3 1) "-")
           (eq(substr sel_clg5_str 8 1) "-")
         )
         (setq clg5_discipline (substr sel_clg5_str 1 2)
               clg5_major (substr sel_clg5_str 4 4)
               clg5_status (substr sel_clg5_str 9 2)
         ))
        ((and
           (eq (strlen sel_clg5_str) 9)
           (eq(substr sel_clg5_str 3 1) "-")
           (eq(substr sel_clg5_str 8 1) "-")
         )
         (setq clg5_discipline (substr sel_clg5_str 1 2)
               clg5_major (substr sel_clg5_str 4 4)
               clg5_status (substr sel_clg5_str 9 1)
         ))
        ((and
           (eq (strlen sel_clg5_str) 9)
           (eq(substr sel_clg5_str 2 1) "-")
           (eq(substr sel_clg5_str 7 1) "-")
         )
         (setq clg5_discipline (substr sel_clg5_str 1 1)
               clg5_major (substr sel_clg5_str 3 4)
               clg5_status (substr sel_clg5_str 8 2)
         ))
        ((and
           (eq (strlen sel_clg5_str) 8)
           (eq(substr sel_clg5_str 2 1) "-")
           (eq(substr sel_clg5_str 7 1) "-")
         )
         (setq clg5_discipline (substr sel_clg5_str 1 1)
               clg5_major (substr sel_clg5_str 3 4)
               clg5_status (substr sel_clg5_str 8 1)
         ))
        ((and
           (eq (strlen sel_clg5_str) 7)
           (eq(substr sel_clg5_str 3 1) "-")
         )
         (setq clg5_discipline (substr sel_clg5_str 1 2)
               clg5_major (substr sel_clg5_str 4 4)
         ))
        ((and
           (eq (strlen sel_clg5_str) 6)
           (eq(substr sel_clg5_str 2 1) "-")
         )
         (setq clg5_discipline (substr sel_clg5_str 1 1)
               clg5_major (substr sel_clg5_str 3 4)
         ))
      )
    )
  )
)
;;;********************************************************************
(defun get_all_tiles ()
  (if (eq (atoi (get_tile "Discipline_list")) 0)
    (setq discipline_txt nil)
    (setq discipline_txt (nth (atoi (get_tile "Discipline_list")) discipline_list))
  )
  (if (eq (atoi (get_tile "Major_list")) 0)
    (setq major_txt nil)
    (setq major_txt (nth (atoi (get_tile "Major_list")) major_list))
  )
  (if (eq (atoi (get_tile "Minor1_list")) 0)
    (setq minor1_txt nil)
    (setq minor1_txt (nth (atoi (get_tile "Minor1_list")) minor1_list))
  )
  (if (eq (atoi (get_tile "Minor2_list")) 0)
    (setq minor2_txt nil)
    (setq minor2_txt (nth (atoi (get_tile "Minor2_list")) minor2_list))
  )
  (if (eq (atoi (get_tile "User_defined_list")) 0)
    (setq user_txt nil)
    (setq user_txt (nth (atoi (get_tile "User_defined_list")) user_list))
  )
  (if (eq (atoi (get_tile "Status_list")) 0)
    (setq status_txt nil)
    (setq status_txt (nth (atoi (get_tile "Status_list")) status_list))
  )
)
;;;****************************************************************************
(DEFUN set_clg5_ltype_list ()
  (setq clg5_ltype_list (list (list (cdr (assoc 2 (tblnext "ltype" T)))(cdr (assoc 3 (tblnext "ltype" T))))))
  (while
    (setq this_ltype (tblnext "ltype"))
    (if (wcmatch (cdr(assoc 2 this_ltype)) "*|*")
      NIL
      (setq clg5_ltype_list (cons (list (cdr (assoc 2 this_ltype))(cdr (assoc 3 this_ltype))) clg5_ltype_list))
    )
  )
  (setq clg5_ltype_list (reverse clg5_ltype_list))
  (princ)
)
;;;****************************************************************************
(defun setmansets ()
  (IF (AND discipline_list (nth (read (get_tile "Discipline_list")) discipline_list))
    (setq
      clg5_discipline (substr (nth (read (get_tile "Discipline_list")) discipline_list) 1 1)
    ) ;_ end of setq
  )
  (IF (AND major_list (nth (read (get_tile "Major_list")) major_list))
    (setq
      clg5_major (substr (nth (read (get_tile "Major_list")) major_list) 1 4)
    ) ;_ end of setq
  )
  (IF (AND minor1_list (nth (read (get_tile "Minor1_list")) minor1_list))
    (setq clg5_minor1 (substr (nth (read (get_tile "Minor1_list")) minor1_list) 1 4))
  )
  (IF (AND minor2_list (nth (read (get_tile "Minor2_list")) minor2_list))
    (setq clg5_minor2 (substr (nth (read (get_tile "Minor2_list")) minor2_list) 1 4))
  )
  (IF (AND user_list (nth (read (get_tile "User_defined_list")) user_list))
    (setq clg5_user
           (IF (WCMATCH (STRCASE (nth (read (get_tile "User_defined_list")) user_list))
                        "??##P*"
               ) ;_ end of WCMATCH
             (substr (nth (read (get_tile "User_defined_list")) user_list) 1 5)
             (substr (nth (read (get_tile "User_defined_list")) user_list) 1 4)
           ) ;_ end of IF
    ) ;_ end of setq
  )
  (IF (AND status_list (nth (read (get_tile "Status_list")) status_list))
    (setq
      clg5_status (substr (nth (read (get_tile "Status_list")) status_list)
                        1
                        2
                ) ;_ end of substr
    ) ;_ end of setq
  )
  (IF (OR (WCMATCH clg5_status "? ")(WCMATCH clg5_status "?\t"))
    (SETQ clg5_status (SUBSTR clg5_status 1 1))
  )
  (IF (WCMATCH clg5_status " ")
    (SETQ clg5_status "")
  )
  (setq lay_onoff (get_tile "lay_onoff"))
  (setq lay_frzthw (get_tile "lay_frzthw"))
  (setq lay_vpfthw (get_tile "lay_vpfthw"))
  (setq lay_lckunl (get_tile "lay_lckunl"))
  (setq lay_pltnop (get_tile "lay_pltnop"))
) ;_ end of defun
;;;********************************************************************
(defun c:manclg5 ()
  (setq quit_manip nil)
  (setq manip_num (load_dialog "clg5"))
  (new_dialog
    "clg5_manip"
    manip_num
    ""
    (if manip_loc
      manip_loc
      '(-1 -1)
    ) ;_ end of if
  ) ;_ end of new_dialog
;;;  (strmanstr)
  (if not_xreflay
    nil
    (setq not_xreflay "0")
  ) ;_ end of if
  (IF (SETQ fndmanhlp (FINDFILE "clg5-manip.htm"))
    NIL
    (SETQ fndmanhlp "http://www.paracadd.com/clg/clg5-manip.htm")
  ) ;_ end of IF
  (IF helphtm NIL (LOAD "helphtm" "\nFile HELPHTM.LSP not loaded! "))
  (set_tile "not_xreflay" not_xreflay)
  (set_tile "clg5_select"
            (if (and clg5_select (eq (type clg5_select) 'STR))
              clg5_select
              "0"
            ) ;_ end of if
  ) ;_ end of set_tile
  (set_tile "clg5_discipline"
            (if (and clg5_discipline (eq (type clg5_discipline) 'STR))
              clg5_discipline
              ""
            ) ;_ end of if
  ) ;_ end of set_tile
  (set_tile "clg5_major"
            (if (and clg5_major (eq (type clg5_major) 'STR))
              clg5_major
              ""
            ) ;_ end of if
  ) ;_ end of set_tile
  (set_tile "clg5_minor1"
            (if (and clg5_minor1 (eq (type clg5_minor1) 'STR))
              clg5_minor1
              ""
            ) ;_ end of if
  ) ;_ end of set_tile
  (set_tile "clg5_minor2"
            (if (and clg5_minor2 (eq (type clg5_minor2) 'STR))
              clg5_minor2
              ""
            ) ;_ end of if
  ) ;_ end of set_tile
  (set_tile "clg5_user"
            (if (and clg5_user (eq (type clg5_user) 'STR))
              clg5_user
              ""
            ) ;_ end of if
  ) ;_ end of set_tile
  (set_tile "clg5_status"
            (if (and clg5_status (eq (type clg5_status) 'STR))
              clg5_status
              ""
            ) ;_ end of if
  ) ;_ end of set_tile
  (set_tile "lay_onoff"
            (if lay_onoff
              lay_onoff
              "0"
            ) ;_ end of if
  ) ;_ end of set_tile
  (set_tile "lay_frzthw"
            (if lay_frzthw
              lay_frzthw
              "0"
            ) ;_ end of if
  ) ;_ end of set_tile
  (set_tile "lay_vpfthw"
            (if lay_vpfthw
              lay_vpfthw
              "0"
            ) ;_ end of if
  ) ;_ end of set_tile
  (set_tile "lay_lckunl"
            (if lay_lckunl
              lay_lckunl
              "0"
            ) ;_ end of if
  ) ;_ end of set_tile
  (set_tile "lay_pltnop"
            (if lay_pltnop
              lay_pltnop
              "0"
            ) ;_ end of if
  ) ;_ end of set_tile
  (action_tile "not_xreflay" "(setq not_xreflay $value)")
  (action_tile
    "clg5_isolate"
    "(clg5_clr_err)(manipsets)(setq done_func\"(isolate_clg5layers)\")(setq manip_loc(done_dialog 1))"
  ) ;_ end of action_tile
  (action_tile "clg5_discipline" "(strmanstr)")
  (action_tile "clg5_major" "(strmanstr)")
  (action_tile "clg5_minor1" "(strmanstr)")
  (action_tile "clg5_minor2" "(strmanstr)")
  (action_tile "clg5_user" "(strmanstr)")
  (action_tile "clg5_status" "(strmanstr)")
  (action_tile
    "help"
    "(setq clg5lay nil curlay nil quit_clg5 T do_help T done_func NIL)(setq manip_loc (done_dialog 2))"
  ) ;_ end of action_tile
  (action_tile
    "accept"
    "(clg5_clr_err)(manipsets)(setq manip_loc(done_dialog 1))"
  ) ;_ end of action_tile
  (action_tile
    "cancel"
    "(clg5_clr_err)(setq quit_manip T)(setq manip_loc(done_dialog 2))"
  ) ;_ end of action_tile
  (strmanstr)
  (setq manip_result (start_dialog))
  (if quit_manip
    nil
    (progn
      (if (eq clg5_select "1")
        (progn
          (setq clg5ss (ssget "x" (list (cons 8 laymanstr))))
          (if clg5ss
            (command ".select" clg5ss "")
          ) ;_ end of if
        ) ;_ end of progn
      ) ;_ end of if
      (cond
        ((eq lay_onoff "0") nil)
        ((eq lay_onoff "1") (wclayaction "on" laymanstr))
                                        ;(command ".layer" "on" laymanstr ""))
        ((eq lay_onoff "2")
         (wclayaction "off" laymanstr)
;;;                         (if
;;;			      (wcmatch (getvar "clayer") laymanstr)
;;;			      (command ".layer" "off" laymanstr "Y" "")
;;;			      (command ".layer" "off" laymanstr "")
;;;			    )
        )
      ) ;_ end of cond
      (cond
        ((eq lay_frzthw "0") nil)
        ((eq lay_frzthw "1")
         (if (wcmatch (getvar "clayer") laymanstr)
           (progn
             (princ (strcat "\nCannot freeze "
                            (strcase (getvar "clayer"))
                            ".  It is the CURRENT layer. "
                    ) ;_ end of strcat
             ) ;_ end of princ
             (command ".layer"
                      "freeze"
                      (strcat "~" (getvar "clayer") "," laymanstr)
                      ""
             ) ;_ end of command
           ) ;_ end of progn
           (command ".layer" "freeze" laymanstr "")
         ) ;_ end of if
        )
        ((eq lay_frzthw "2") (command ".layer" "thaw" laymanstr ""))
      ) ;_ end of cond
      (cond
        ((eq lay_vpfthw "0") nil)
        ((eq lay_vpfthw "1")
         (command ".vplayer" "freeze" laymanstr "" "" "")
        )
        ((eq lay_vpfthw "2")
         (command ".vplayer" "thaw" laymanstr "" "" "")
        )
      ) ;_ end of cond
      (cond
        ((eq lay_lckunl "0") nil)
        ((eq lay_lckunl "1") (command ".layer" "lo" laymanstr ""))
        ((eq lay_lckunl "2") (command ".layer" "u" laymanstr ""))
      ) ;_ end of cond
      (cond
        ((eq lay_pltnop "0") nil)
        ((eq lay_pltnop "1")
         (command ".layer" "p" "p" laymanstr "")
        )
        ((eq lay_pltnop "2")
         (command ".layer" "p" "n" laymanstr "")
        )
      ) ;_ end of cond
      (IF done_func
        (PROGN
          (EVAL (READ done_func))
          (SETQ done_func NIL)
        ) ;_ end of PROGN
        (if (and do_help (EQ quit_clg5 T))
          (PROGN
            (helphtm "CLG Doctor - AIA CAD Layer Guidelines - USNCADS Version 5 - Management Dialog" fndmanhlp)
            (SETQ do_help NIL)
          )
        )
      ) ;_ end of IF
    ) ;_ end of progn
  ) ;_ end of if
  (princ)
) ;_ end of defun
;;;********************************************************************
(DEFUN wclayaction (layact laystr /)
  (SETQ this_lay (TBLNEXT "LAYER" T))
  (WHILE this_lay
    (SETQ this_layname (CDR (ASSOC 2 this_lay)))
    (IF (WCMATCH (STRCASE this_layname) (STRCASE laystr))
      (COND
        ((EQ (STRCASE layact) "ON")
         (IF (AND (eq not_xreflay "1") (WCMATCH this_layname "*|*"))
           NIL
           (PROGN
             (force_layonthaw this_layname)
           ) ;_ end of PROGN
         ) ;_ end of IF
        )
        ((EQ (STRCASE layact) "OFF")
         (IF (AND (eq not_xreflay "1") (WCMATCH this_layname "*|*"))
           NIL
           (force_layoffreeze this_layname)
         ) ;_ end of IF
        )
      ) ;_ end of COND
    ) ;_ end of IF
    (SETQ this_lay (TBLNEXT "LAYER"))
  ) ;_ end of WHILE
  (vla-regen (vla-get-activedocument (vlax-get-acad-object))
             acAllViewports
  ) ;_ end of vla-regen
) ;_ end of DEFUN
;;;********************************************************************
(DEFUN isolate_clg5layers ()
  (COND
    ((WCMATCH (SUBSTR laymanstr 1 6) "`*`*`*`*`*`*")
     (SETQ laymanstr (SUBSTR laymanstr 7))
    )
    ((WCMATCH (SUBSTR laymanstr 1 5) "`*`*`*`*`*")
     (SETQ laymanstr (SUBSTR laymanstr 6))
    )
    ((WCMATCH (SUBSTR laymanstr 1 4) "`*`*`*`*")
     (SETQ laymanstr (SUBSTR laymanstr 5))
    )
    ((WCMATCH (SUBSTR laymanstr 1 3) "`*`*`*")
     (SETQ laymanstr (SUBSTR laymanstr 4))
    )
    ((WCMATCH (SUBSTR laymanstr 1 2) "`*`*")
     (SETQ laymanstr (SUBSTR laymanstr 3))
    )
    ((WCMATCH (SUBSTR laymanstr 1 1) "`*")
     (SETQ laymanstr (SUBSTR laymanstr 2))
    )
  ) ;_ end of COND
  (if (not (wcmatch (STRCASE (getvar "clayer"))
                    (STRCASE (STRCAT "*[~|]*" laymanstr "*"))
           ) ;_ end of wcmatch
      ) ;_ end of not
    (PROGN
      (SETQ this_laent (TBLNEXT "layer" T))
      (WHILE
        (AND
          this_laent
          (OR
            (WCMATCH (STRCASE (CDR (ASSOC 2 this_laent)))
                     (STRCASE (STRCAT "*|*" laymanstr "*"))
            ) ;_ end of WCMATCH
            (NOT (WCMATCH (STRCASE (CDR (ASSOC 2 this_laent)))
                          (STRCASE (STRCAT "*" laymanstr "*"))
                 ) ;_ end of WCMATCH
            ) ;_ end of NOT
            (WCMATCH (STRCASE (CDR (ASSOC 2 this_laent))) "*HIDE*")
          ) ;_ end of OR
        ) ;_ end of AND
         (SETQ this_laent (TBLNEXT "layer"))
;;;        (ALERT (STRCAT (STRCASE (CDR (ASSOC 2 this_laent))) " does not = " (STRCASE(STRCAT "*[~|]*" laymanstr "*"))))
      ) ;_ end of WHILE
      (SETQ this_laname (CDR (ASSOC 2 this_laent)))
;;;      (IF (NOT this_laname)
;;;        (ALERT "NO LAYER NAME")
;;;        (ALERT (STRCAT "Layer name is " this_laname))
;;;      )
      (IF (AND this_laname (TBLSEARCH "LAYER" this_laname))
        (PROGN
          (force_layonthaw this_laname)
          (SETVAR "clayer" this_laname)
        ) ;_ end of PROGN
        (PROGN
          (force_layonthaw "DEFPOINTS")
          (SETVAR "clayer" "DEFPOINTS")
        ) ;_ end of PROGN
      ) ;_ end of IF
    ) ;_ end of PROGN
  ) ;_ end of if
  (SETQ this_layent (TBLNEXT "layer" T))
  (WHILE (SETQ this_layent (TBLNEXT "layer"))
    (IF
      (if (eq not_xreflay "1")
        (OR
          (WCMATCH (CDR (ASSOC 2 this_layent)) "*|*")
          (WCMATCH (STRCASE (CDR (ASSOC 2 this_layent)))
                   (STRCASE (GETVAR "clayer"))
          ) ;_ end of WCMATCH
          (WCMATCH (STRCASE (CDR (ASSOC 2 this_layent))) "?????X??")
          (WCMATCH (STRCASE (CDR (ASSOC 2 this_layent))) "DEFPOINTS")
        ) ;_ end of OR
        (OR
          (WCMATCH (STRCASE (CDR (ASSOC 2 this_layent)))
                   (STRCASE (GETVAR "clayer"))
          ) ;_ end of WCMATCH
          (WCMATCH (STRCASE (CDR (ASSOC 2 this_layent))) "?????X??")
        ) ;_ end of OR
      ) ;_ end of if
       NIL
       (PROGN
         (SETQ this_layename
                (TBLOBJNAME "LAYER" (CDR (ASSOC 2 this_layent)))
         ) ;_ end of SETQ
         (IF this_layename
           (PROGN
             (SETQ this_layent  (ENTGET this_layename)
                   this_layname (CDR (ASSOC 2 this_layent))
             ) ;_ end of SETQ
             (IF (WCMATCH (STRCASE this_layname)
                          (STRCASE (STRCAT "*" laymanstr "*"))
                 ) ;_ end of WCMATCH
               (IF
                 (AND (eq not_xreflay "1") (WCMATCH this_layname "*|*"))
                  NIL
                  (force_layonthaw this_layname)
               ) ;_ end of IF
               (IF
                 (AND (eq not_xreflay "1") (WCMATCH this_layname "*|*"))
                  NIL
                  (force_layoffreeze this_layname)
               ) ;_ end of IF
             ) ;_ end of IF
           ) ;_ end of PROGN
         ) ;_ end of IF
       ) ;_ end of PROGN
    ) ;_ end of IF
  ) ;_ end of WHILE
  (setq isolay_ss
         (ssget "x"
                (LIST (CONS 8 (STRCASE (STRCAT "*" laymanstr "*"))))
         ) ;_ end of ssget
  ) ;_ end of setq
  (IF isolay_ss
    (PROGN
      (SETQ isolay_cnt 0)
      (WHILE (< isolay_cnt (SSLENGTH isolay_ss))
        (ENTUPD (SSNAME isolay_ss isolay_cnt))
        (SETQ isolay_cnt (1+ isolay_cnt))
      ) ;_ end of WHILE
      (vla-regen (vla-get-activedocument (vlax-get-acad-object))
                 acAllViewports
      ) ;_ end of vla-regen
    ) ;_ end of PROGN
    (ALERT "Nothing to do!")
  ) ;_ end of IF
) ;_ end of DEFUN
;;;********************************************************************
(defun strmanstr ()
  (manipsets)
  (setq
    laymanstr (strcat (if (and clg5_discipline
                               (not (eq clg5_discipline ""))
                               (not (eq clg5_discipline "    "))
                          ) ;_ end of and
                        clg5_discipline
                        "?"
                      ) ;_ end of if
                      "-"
                      (if (and clg5_major
                               (not (eq clg5_major ""))
                               (not (eq clg5_major "    "))
                          ) ;_ end of and
                        clg5_major
                        "????"
                      ) ;_ end of if
                      (if (and clg5_minor1
                               (not (eq clg5_minor1 ""))
                               (not (eq clg5_minor1 "    "))
                          ) ;_ end of and
                        (strcat "-" clg5_minor1)
                        ""
                      ) ;_ end of if
                      (if (and clg5_minor2
                               (not (eq clg5_minor2 ""))
                               (not (eq clg5_minor2 "    "))
                          ) ;_ end of and
                        (strcat "-" clg5_minor2)
                        ""
                      ) ;_ end of if
                      (IF (and clg5_user
                               (not (eq clg5_user ""))
                               (not (eq clg5_user "    "))
                          ) ;_ end of and
                        (strcat "-" clg5_user)
                        ""
                      ) ;_ end of IF
                      (if (and clg5_status
                               (not (eq clg5_status ""))
                               (not (eq clg5_status "    "))
                          ) ;_ end of and
                        (strcat "-" clg5_status)
                        ""
                      ) ;_ end of if
              ) ;_ end of strcat
  ) ;_ end of setq
  (set_tile "man_str" (strcat "Layer Match String: " laymanstr))
) ;_ end of defun
;;;********************************************************************
(defun manipsets ()
  (setq clg5_isolate (get_tile "clg5_isolate"))
  (setq clg5_select (get_tile "clg5_select"))
  (setq clg5_discipline (get_tile "clg5_discipline"))
  (setq clg5_major (get_tile "clg5_major"))
  (setq clg5_minor1 (get_tile "clg5_minor1"))
  (setq clg5_minor2 (get_tile "clg5_minor2"))
  (setq clg5_user (get_tile "clg5_user"))
  (setq clg5_status (get_tile "clg5_status"))
  (if (eq clg5_discipline "")
    (setq clg5_discipline "?")
  ) ;_ end of if
  (if (eq clg5_major "")
    (setq clg5_major "????")
  ) ;_ end of if
  (setq lay_onoff (get_tile "lay_onoff"))
  (setq lay_frzthw (get_tile "lay_frzthw"))
  (setq lay_vpfthw (get_tile "lay_vpfthw"))
  (setq lay_lckunl (get_tile "lay_lckunl"))
  (setq lay_pltnop (get_tile "lay_pltnop"))
  (princ)
) ;_ end of defun
;;;********************************************************************
(defun clg5_done (sd_result /)
  (if (and clg5lay (wcmatch clg5lay "*\t*"))
    (progn
      (setq cnt 1)
      (while
        (not (wcmatch (substr clg5lay cnt) "\t*"))
        (setq cnt (1+ cnt))
      )
      (setq clg5lname (substr clg5lay 1 (1- cnt)))
      (while
        (and
          (<= cnt (strlen clg5lay))
          (wcmatch (substr clg5lay cnt) "*\t*")
        )
        (setq cnt (1+ cnt))
      )
      (if (eq cnt (strlen clg5lay))
        (setq clg5ldescr "")
        (setq clg5ldescr (substr clg5lay cnt))
      )
      (setq clg5lay clg5lname)
    )
  )
  (if (and (= sd_result 1) (not from_para) (not from_f2f));Accept CLG Settings
    (progn
      (if curlay
        (manylay)
        (if
          (and clg5lay
;;;               (not
;;;                 (or
;;;                   (eq (substr clg5lay 1 1) " ")
;;;                   (eq (substr clg5lay 2 1) " ")
;;;                   (eq (substr clg5lay 3 1) " ")
;;;                   (eq (substr clg5lay 4 1) " ")
;;;                   (eq (substr clg5lay 5 1) " ")
;;;                   (eq (substr clg5lay 6 1) " ")
;;;                   (eq (substr clg5lay 7 1) " ")
;;;                   (eq (substr clg5lay 8 1) " ")
;;;                   (eq (substr clg5lay 9 1) " ")
;;;                   (eq (substr clg5lay 10 1) " ")
;;;                   (eq (substr clg5lay 11 1) " ")
;;;                   (eq (substr clg5lay 12 1) " ")
;;;                   (eq (substr clg5lay 13 1) " ")
;;;                   (eq (substr clg5lay 14 1) " ")
;;;                   (eq (substr clg5lay 15 1) " ")
;;;                   (eq (substr clg5lay 16 1) " ")
;;;                   (eq (substr clg5lay 17 1) " ")
;;;                   (eq (substr clg5lay 18 1) " ")
;;;                   (eq (substr clg5lay 19 1) " ")
;;;                   (eq (substr clg5lay 20 1) " ")
;;;                   (eq (substr clg5lay 21 1) " ")
;;;                   (eq (substr clg5lay 22 1) " ")
;;;                   (eq (substr clg5lay 23 1) " ")
;;;                   (eq (substr clg5lay 24 1) " ")
;;;                   (eq (substr clg5lay 25 1) " ")
;;;                 ) ;_ end of or
;;;               ) ;_ end of not
          ) ;_ end of and
           (mlay)
           (if (or quit_clg5 (= sd_result 3))
             nil
             (progn
               (setq clg5_err "Invalid, blank characters in layer name.")
               (unload_dialog clg5_num)
               (c:clg5)
             ) ;_ end of progn
           ) ;_ end of if
        ) ;_ end of if
      ) ;_ end of if
      (clg5_pcpyrt)
    ) ;_ end of progn
    (if (eq sd_result 1)
      (if from_para
        (progn
          (setq from_para nil
                pipe_discipline clg5_discipline
                pipe_majr clg5_major
                pipe_user clg5_user
                pipe_status clg5_status
                clg5_discipline    tmp_clg5_discipline
                clg5_major tmp_clg5_major
                clg5_user  tmp_clg5_user
                clg5_status  tmp_clg5_status
          ) ;_ end of setq
          (unload_dialog clg5_num)
          (set_tile "base_layer"
                    (strcat (if pipe_discipline
                              pipe_discipline
                              "?"
                            ) ;_ end of if
                            " "
                            (if pipe_majr
                              pipe_majr
                              "????"
                            ) ;_ end of if
                            (if stat_char
                              stat_char
                              "?"
                            ) ;_ end of if
                            (if pipe_user
                              (STRCAT "*-" pipe_user)
                              ""
                            ) ;_ end of if
                    ) ;_ end of strcat
          ) ;_ end of set_tile
        ) ;_ end of progn
        (progn
          (setq from_f2f nil)
          (unload_dialog clg5_num)
          (if (eq sd_result 1)
            (setq newf2flay
                   (strcat (if clg5_discipline
                             clg5_discipline
                             "?"
                           ) ;_ end of if
                           "-"
                           (if clg5_major
                             clg5_major
                             "????"
                           ) ;_ end of if
                           (if clg5_minor1
                             (strcat "-" clg5_minor1)
                             ""
                           ) ;_ end of if
                           (if clg5_minor2
                             (strcat "-" clg5_minor2)
                             ""
                           ) ;_ end of if
                           (if (AND clg5_user (/= clg5_user ""))
                             (STRCAT "-" clg5_user)
                             ""
                           ) ;_ end of if
                           (if (AND clg5_status (/= clg5_status ""))
                             (STRCAT "-" clg5_status)
                             ""
                           ) ;_ end of if
                   ) ;_ end of strcat
            ) ;_ end of setq
            (setq newf2flay nil)
          ) ;_ end of if
        ) ;_ end of progn
      ) ;_ end of if
      (if (eq sd_result 2)              ;Cancel CLG
        (progn
          (setq clg5_discipline tmp_clg5_discipline)
          (setq clg5_major (if tmp_clg5_major tmp_clg5_major ""))
          (setq clg5_minor1 (if tmp_clg5_minor1 tmp_clg5_minor1 ""))
          (setq clg5_minor2 (if tmp_clg5_minor2 tmp_clg5_minor2 ""))
          (setq clg5_user (if tmp_clg5_user tmp_clg5_user ""))
          (setq clg5_status (if tmp_clg5_status tmp_clg5_status ""))
          (setq clg5dis (if tmp_clg5dis tmp_clg5dis "0"))
          (setq clg5maj (if tmp_clg5maj tmp_clg5maj "0"))
          (setq clg5min1 (if tmp_clg5min1 tmp_clg5min1 "0"))
          (setq clg5min2 (if tmp_clg5min2 tmp_clg5min2 "0"))
          (setq clg5usr (if tmp_clg5usr tmp_clg5usr "0"))
          (setq clg5sta (if tmp_clg5sta tmp_clg5sta "0"))
          (setq discipline (IF clg5_discipline clg5_discipline "G "))
          (IF clg5_major (setq prod clg5_major))
          (setq minr1 clg5_minor1)
          (setq minr2 clg5_minor2)
          (setq usdf clg5_user)
          (setq stat clg5_status)
;;;          (if old_clg5_hist
;;;            (setq clg5_hist old_clg5_hist)
;;;          ) ;_ end of if
          (if (or from_para from_f2f)
            (progn
              (setq from_para nil
                    from_f2f nil
              ) ;_ end of setq
              (unload_dialog clg5_num)
            ) ;_ end of progn
          ) ;_ end of if
        ) ;_ end of progn
      ) ;_ end of if
    ) ;_ end of if
  ) ;_ end of if
  (princ)
) ;_ end of defun
;;;********************************************************************
(defun f_all (/)
  (if (or from_para from_f2f)
    (IF from_para
      (progn
        (f_discipline)
        (f_cc)
        (f_user)
      ) ;_ end of progn
      (progn
        (f_layer_list)
        (f_discipline)
        (f_cc)
        (f_minor1)
        (f_minor2)
        (f_user)
        (f_status)
      ) ;_ end of progn
    ) ;_ end of IF
    (progn
      (f_layer_list)
      (f_discipline)
      (if discipline_list
        (progn
          (if (and clg5dis (<(atoi clg5dis)(length discipline_list)))
            nil
            (setq clg5dis "0")
          )
          (f_major)
          (if major_list
            (progn
              (f_minor1)
              (f_minor2)
            )
          )
          (f_user)
          (f_status)
          (f_cc)
        )
      )
    ) ;_ end of progn
  ) ;_ end of if
  (setq init T)
  (princ)
) ;_ end of defun
;;;********************************************************************
(defun f_discipline (/)
  (if discipline_list
    NIL
    (get_discipline_list)
  )
  (IF discipline_list
    (progn
      (if discipline
        (setq clg5_discipline (substr discipline 1 2))
        (setq discipline "G "
              clg5_discipline "G "
              clg5dis "1"
        )
      )
      (IF (wcmatch (nth (atoi clg5dis) discipline_list) (strcat discipline "*"))
        NIL
        (progn
          (setq cnt 0)
          (while (and (< cnt (length discipline_list))(not(wcmatch(nth cnt discipline_list)(strcat discipline "*"))))
            (setq cnt (1+ cnt))
          )
          (setq clg5dis (itoa (min (1- cnt)(length discipline_list))))
        )
      )
      (if (setq dis_slst (acad_strlsort discipline_list))
        (setq discipline_list dis_slst)
      )
      (start_list "Discipline_list")
      (mapcar 'add_list discipline_list)
      (end_list)
      (set_list discipline_list "Discipline_list" clg5_discipline 2)
      (f_major)
      (f_minor1)
;;;      (clg5_res_hist)
    )
  )
) ;_ end of defun
;;;********************************************************************
(defun f_layer_list (/)
  (set_lay_list)
  (if (and from_f2f key_props)
    (set_key_lay_list)
  ) ;_ end of if
  (start_list "Exist_lay")
  (mapcar 'add_list newlist)
  (end_list)
  (if (member (getvar "clayer") newlist)
    (progn
      (setq clg5_lay (getvar "clayer"))
      (set_list newlist "Exist_lay" clg5_lay (strlen clg5_lay))
    ) ;_ end of progn
  ) ;_ end of if
  (princ)
) ;_ end of defun
;;;********************************************************************
(DEFUN set_key_lay_list ()
  (setq key_lay_list (mapcar 'cadr key_props))
  (if newlist
    (foreach n key_lay_list
      (if (member n newlist)
        nil
        (setq newlist (append newlist (list n)))
      ) ;_ end of if
    ) ;_ end of foreach
    (SETQ newlist key_lay_list)
  ) ;_ end of if
  (if newlist
    (setq newlist (acad_strlsort newlist))
  ) ;_ end of if
) ;_ end of DEFUN
;;;********************************************************************
(defun f_major (/)
  (if (and discipline_file
           clg5_discipline
           (eq (type clg5_discipline) 'STR)
           (wcmatch clg5_discipline "@,@@,@ ")
      ) ;_ end of and
    (setq major_file
           (strcat (substr discipline_file 1 (-(strlen discipline_file)14))
                   "maj"
                   (if (wcmatch clg5_discipline "@ ")
                     (substr clg5_discipline 1 1)
                     clg5_discipline
                   )
                   ".dat"
           ) ;_ end of strcat
    ) ;_ end of setq
  ) ;_ end of if
  (if (and major_file (findfile major_file))
    (progn
      (if debug_clg5_lists
        (progn
          (princ (strcat "\nWe found " (findfile major_file)))
          (princ)
        ) ;_ end of progn
      ) ;_ end of if
      (get_major_list)
      (start_list "Major_list")
      (mapcar 'add_list major_list)
      (end_list)
      (set_list major_list "Major_list" clg5_major 4)
      (get_minor1_list)
      (start_list "Minor1_list")
      (mapcar 'add_list minor1_list)
      (end_list)
      (set_list minor1_list "Minor1_list" clg5_minor1 4)
      
    ) ;_ end of progn
    (progn
      (if debug_clg5_lists
        (progn
          (princ (strcat "\nWe did not find "
                         major_file
                         " so we created one. "
                 ) ;_ end of strcat
          ) ;_ end of princ
          (princ)
        ) ;_ end of progn
      ) ;_ end of if
      (setq tmpfile (open major_file "w"))
      (write-line
        (strcat "    \t-\tno "
                (substr (nth (atoi clg5dis) discipline_list) 9)
                " Major Group Active"
        ) ;_ end of strcat
        tmpfile
      ) ;_ end of write-line
      (write-line "ANNO\t-\tAnnotation" tmpfile)
      (write-line "DETL\t-\tDetail" tmpfile)
      (write-line "ELEV\t-\tElevation" tmpfile)
      (write-line "SECT\t-\tSection" tmpfile)
      (close tmpfile)
      (if major_list
        nil
        (get_major_list)
      ) ;_ end of if
      (start_list "Major_list")
      (mapcar 'add_list major_list)
      (end_list)
      (set_list major_list "Major_list" clg5_major 4)
    ) ;_ end of progn
  ) ;_ end of if
  (princ)
) ;_ end of defun
;;;;********************************************************************
(defun f_minor1 (/)
  (get_minor1_list)
  (IF minor1_list
    (progn
      (start_list "Minor1_list")
      (mapcar 'add_list minor1_list)
      (end_list)
      (set_list minor1_list "Minor1_list" clg5_minor1 4)
    ) ;_ end of progn
  ) ;_ end of IF
  (princ)
  (if discipline
    (progn
      (setq minor1_file
           (strcat "clg5min1"
                   (IF (wcmatch discipline "@ ") (substr discipline 1 1) discipline)
                   ".dat"
           ) ;_ end of strcat
      ) ;_ end of setq
      (if (findfile minor1_file)
        (progn
          (if debug_clg5_lists
            (progn
              (princ
                (strcat
                  "\nWe found "
                  (findfile minor1_file)
                ) ;_ end of strcat
              ) ;_ end of princ
              (princ)
            ) ;_ end of progn
          ) ;_ end of if
          (get_minor1_list)
          (start_list "Minor1_list")
          (mapcar 'add_list minor1_list)
          (end_list)
          (set_list minor1_list "Minor1_list" clg5_minor1 4)
        ) ;_ end of progn
        (progn
          (if debug_clg5_lists
            (progn
              (princ (strcat "\nWe did not find "
                             minor1_file
                             " so we created one. "
                     ) ;_ end of strcat
              ) ;_ end of princ
              (princ)
            ) ;_ end of progn
          ) ;_ end of if
          (setq tmpfile (open minor1_file "w"))
          (write-line
            (strcat "    \t-\tNo "
                    (substr (nth (atoi clg5dis) discipline_list) 9)
                    " Minor Group Active (optional)"
            ) ;_ end of strcat
            tmpfile
          ) ;_ end of write-line
          (write-line "ANNO\t-\tAnnotation" tmpfile)
          (write-line "DETL\t-\tDetail" tmpfile)
          (write-line "ELEV\t-\tElevation" tmpfile)
          (write-line "SECT\t-\tSection" tmpfile)
          (close tmpfile)
          (start_list "Minor1_list")
          (mapcar 'add_list minor1_list)
          (end_list)
          (set_list minor1_list "Minor1_list" clg5_minor1 4)
        )
      )
    )
  )
  (princ)
)
;;;;********************************************************************
(defun f_minor2 (/)
  (get_minor2_list)
  (IF minor2_list
    (progn
      (start_list "Minor2_list")
      (mapcar 'add_list minor2_list)
      (end_list)
      (set_list minor2_list "Minor2_list" clg5_minor2 4)
    ) ;_ end of progn
  ) ;_ end of IF
  (princ)
) ;_ end of defun
;;;;********************************************************************
(defun f_user (/)
  (if (and user_list clg5usr)
    (if (>= (atoi clg5usr) (length user_list))
      (setq clg5usr (itoa (1- (length user_list))))
    ) ;_ end of if
    (setq clg5usr "0")
  ) ;_ end of if
  (get_user_list)
  (IF user_list
    (progn
      (start_list "User_defined_list")
      (mapcar 'add_list user_list)
      (end_list)
      (if init
        (if (= clg5usr "0")
          (setq usrd nil
                cusrd nil
                usdf nil
          )
          (setq usrd (substr (nth (atoi clg5usr) user_list) 1 4))
        ) ;_ end of if
      ) ;_ end of if
      (setq usr_idx nil)
      (foreach n user_list
        (setq usr_idx (append usr_idx (list (substr n 1 4))))
      ) ;_ end of foreach
      (if (setq usr_ils (member usrd usr_idx))
        (progn
          (setq clg5usr (itoa (- (length user_list) (length usr_ils))))
          (set_tile "User_defined_list" clg5usr)
        ) ;_ end of progn
      ) ;_ end of if
      (if
        clg5usr
         (setq clg5_user (substr (nth (atoi clg5usr) user_list) 1 4))
      ) ;_ end of if
      (set_list user_list
                "User_defined_list"
                clg5_user
                (STRLEN clg5_user)
      ) ;_ end of set_list
    ) ;_ end of progn
  ) ;_ end of IF
  (princ)
) ;_ end of defun
;;;********************************************************************
(defun f_status (/)
  (if (and status_list clg5sta)
    (if (>= (atoi clg5sta) (length status_list))
      (setq clg5sta (itoa (1- (length status_list))))
    ) ;_ end of if
    (setq clg5sta "0")
  ) ;_ end of if
  (get_status_list)
  (if status_list
    (progn
      (start_list "Status_list")
      (mapcar 'add_list status_list)
      (end_list)
      (if init
        (if (= clg5sta "0")
          (setq stat nil)
          (setq stat (substr (nth (atoi clg5sta) status_list) 1 2))
        ) ;_ end of if
      ) ;_ end of if
      (IF (AND stat (WCMATCH stat "? "))
        (SETQ stat (SUBSTR stat 1 1))
      )
      (setq sta_idx nil)
      (foreach n status_list
        (COND
          ((WCMATCH (SUBSTR n 1 2) "??")
            (setq sta_idx (append sta_idx (list (substr n 1 2)))))
          ((OR (WCMATCH (SUBSTR n 1 2) "? ")(WCMATCH (SUBSTR n 1 2) "?\t"))
            (setq sta_idx (append sta_idx (list (substr n 1 1)))))
          ((WCMATCH (SUBSTR n 1 1) " ")
            (setq sta_idx (append sta_idx (list ""))))
          (T
            (setq sta_idx (append sta_idx (list (substr n 1 1)))))
        )
      ) ;_ end of foreach
      (if (setq sta_ils (member stat sta_idx))
        (setq clg5sta (itoa (- (length status_list) (length sta_ils))))
      ) ;_ end of if
      (if (and clg5sta (/= clg5sta "0"))
        (setq clg5_status (substr (nth (atoi clg5sta) status_list) 1 2))
        (setq clg5_status "")
      ) ;_ end of if
      (IF (WCMATCH clg5_status "? ")
        (SETQ clg5_status (SUBSTR clg5_status 1 2))
      )
      (IF (WCMATCH clg5_status "?\t")
        (SETQ clg5_status (STRCAT (SUBSTR clg5_status 1 1) " "))
      )
      (set_list status_list "Status_list" clg5_status 2)
    ) ;_ end of progn
  ) ;_ end of if
  (princ)
) ;_ end of defun
;;;********************************************************************
(defun f_cc (/)
    (setq lstr
           (strcat
             (if (and clg5_discipline (not (= clg5_discipline "")))
               (if (wcmatch clg5_discipline "? ")
                 (substr clg5_discipline 1 1)
                 clg5_discipline
               )
               " "
             ) ;_ end of if
             "-"
             (if clg5_major
               clg5_major
               "    "
             ) ;_ end of if
             (if (and clg5_minor1 (wcmatch clg5_minor1 "????")(not(wcmatch clg5_minor1 "* *")))
               (strcat "-" clg5_minor1)
               ""
             ) ;_ end of if
             (if (and clg5_minor2 (wcmatch clg5_minor2 "????")(not(wcmatch clg5_minor2 "* *")))
               (strcat "-" clg5_minor2)
               ""
             ) ;_ end of if
             (if (and clg5_user (wcmatch (STRCASE clg5_user) "????,????P")(not(wcmatch clg5_user "* *")))
               (strcat "-" clg5_user)
               ""
             ) ;_ end of if
             (COND
               ((OR (WCMATCH clg5_status "@")(WCMATCH clg5_status "@@")(WCMATCH clg5_status "@#")(WCMATCH clg5_status "#")(WCMATCH clg5_status "##"))
                 (strcat "-" clg5_status))
               ((OR (WCMATCH clg5_status "? ")(WCMATCH clg5_status "?\t"))
                (strcat "-" (SUBSTR clg5_status 1 1)))
               (T "")
             ) ;_ end of COND
           ) ;_ end of strcat
    ) ;_ end of setq
  (set_tile "clg5_layer" lstr)
  (setq ex_layer_ent (tblsearch "layer" lstr))
  (if ex_layer_ent
    (progn
      (get_clg5_color_no (itoa (cdr (assoc 62 ex_layer_ent))))
      (SET_TILE "color_edit" (itoa (cdr (assoc 62 ex_layer_ent))))
      (set_clg5_co)
      (set_clg5_lt_image)
    )
  )
  (princ)
) ;_ end of defun
;;;********************************************************************
;;;Constructs the list of Discipline Groups
(defun get_discipline_list (/)
  (setq discipline_list nil)
  (setq discipline_file (findfile "clg5discipline.dat"))
  (if discipline_file
    (progn
      (setq discipline_dat (open discipline_file "r"))
      (while
        (setq str (read-line discipline_dat))
         (setq discipline_list (append discipline_list (list str)))
      )                                 ;while
      (close discipline_dat)
    ) ;_ end of progn
    (IF dos_msgbox
      (dos_msgbox
        (STRCAT
          "File \"clg5discipline.dat\" not found!\n" "\n"
          "This and all of the \"*.dat\" files included with this application must\n"
          "be placed in a folder that is included in the AutoCAD search path.  To\n"
          "include the folder they are in within AutoCAD's search path, add it to\n"
          "the \"Support file search path\" in the \"Files\" tab under \"Preferences\""
        )
        "Missing Data File"
        1
        1
      ) ;_ end of dos_msgbox
      (ALERT
        (STRCAT
          "File \"clg5discipline.dat\" not found!\n" "\n"
          "This and all of the \"*.dat\" files included with this application must\n"
          "be placed in a folder that is included in the AutoCAD search path.  To\n"
          "include the folder they are in within AutoCAD's search path, add it to\n"
          "the \"Support file search path\" in the \"Files\" tab under \"Preferences\""
        )
      ) ;_ end of ALERT
    ) ;_ end of IF
  ) ;_ end of if
  (princ)
) ;_ end of defun
;;;********************************************************************
;;;Constructs Major Group List associated with the current Discipline Group
(defun get_major_list (/)
  (setq major_list nil)
  (if clg5_discipline
    nil
    (setq clg5_discipline "")
  ) ;_ end of if
  (if (findfile major_file)
    (progn
      (setq major_dat (open (findfile major_file) "r"))
      (while (setq str (read-line major_dat))
        (setq major_list (append major_list (list str)))
      ) ;_ end of while
      (close major_dat)
      (if (setq mj_lst (acad_strlsort major_list))
        (setq major_list mj_lst)
        (setq clg5_err "Not enough memory to sort major group list.")
      ) ;_ end of if
    ) ;_ end of progn
    (setq clg5_err (strcat "\nFile " major_file " not found! "))
  ) ;_ end of if
  (princ)
) ;_ end of defun
;;;********************************************************************
(defun get_minor1_list (/)
  (setq dis_splitpath (dos_splitpath discipline_file))
  (setq minor1_file
         (strcat (nth 0 dis_splitpath)
                 (nth 1 dis_splitpath)
                 (if (and clg5_major (wcmatch (strcase clg5_major) "ANNO"))
                   "clg5minAnno.dat"
                   (strcat
                     "clg5min1"
                     (if (wcmatch discipline "@ ")
                       (substr discipline 1 1)
                       discipline
                     ) ;_ end of if
                     ".dat"
                   )
                 )
         ) ;_ end of strcat
  ) ;_ end of setq
  (if (setq fnd_minor1_file (findfile minor1_file))
    (progn
      (setq minor1_dat (open fnd_minor1_file "r"))
      (setq minor1_list nil)
      (while (setq str (read-line minor1_dat))
        (setq minor1_list (cons str minor1_list))
      ) ;_ end of while
      (close minor1_dat)
      (if (setq mino_slst (acad_strlsort minor1_list))
        (setq minor1_list mino_slst)
        (setq clg5_err "Not enough memory to sort minor list 1. ")
      ) ;_ end of if
    ) ;_ end of progn
    (PROGN
      (setq tmpfile (open minor1_file "w"))
      (write-line (CAR
          (setq minor1_list (list
                 (strcat
                   "    \t-\tno Minor Group Active (optional)"
                 ) ;_ end of strcat
          ))) ;_ end of setq
        tmpfile
      ) ;_ end of write-line
      (close tmpfile)
      (if (setq mn1_lst (acad_strlsort minor1_list))
        (setq minor1_list mn1_lst)
        (setq clg5_err "Not enough memory to sort minor list 1. ")
      ) ;_ end of if
      (start_list "Minor1_list")
      (mapcar 'add_list minor1_list)
      (end_list)
      (set_list minor1_list "Minor1_list" clg5_minor1 4)
    ) ;_ end of PROGN
  ) ;_ end of if
  (princ)
) ;_ end of defun
;;;********************************************************************
(defun get_minor2_list (/)
  (setq dis_splitpath (dos_splitpath discipline_file))
  (setq minor2_file
         (strcat (nth 0 dis_splitpath)
                 (nth 1 dis_splitpath)
                 "clg5min2all.dat"
         ) ;_ end of strcat
  ) ;_ end of setq

  (if (setq minor2_file (findfile minor2_file))
    (progn
      (setq minor2_dat (open minor2_file "r"))
      (setq minor2_list nil)
      (while (setq str (read-line minor2_dat))
        (setq minor2_list (cons str minor2_list))
      ) ;_ end of while
      (close minor2_dat)
      (if (setq mino_slst (acad_strlsort minor2_list))
        (setq minor2_list mino_slst)
        (setq clg5_err "Not enough memory to sort minor list 2. ")
      ) ;_ end of if
    ) ;_ end of progn
    (PROGN
      (setq minor2_file
             (strcat (nth 0 dis_splitpath)
                     (nth 1 dis_splitpath)
                     "clg5min2all.dat"
             ) ;_ end of strcat
      ) ;_ end of setq
      (setq tmpfile (open minor2_file "w"))
      (write-line (CAR (LIST
        (setq minor2_list
               (strcat
                 "    \t-\tno additional Minor Group Active (optional)"
               ) ;_ end of strcat
        ))) ;_ end of setq
        tmpfile
      ) ;_ end of write-line
      (write-line
        (CAR (setq minor2_list
                    (cons
                      "BRNG\t-\tBearings and distance labels (survey coordinates)"
                      minor2_list
                    ) ;_ end of cons
             ) ;_ end of setq
        ) ;_ end of CAR
        tmpfile
      ) ;_ end of write-line
      (write-line
        (car
          (setq minor2_list (cons "DIMS\t-\tDimensions" minor2_list))
        ) ;_ end of car
        tmpfile
      ) ;_ end of write-line
      (write-line
        (car
          (setq minor2_list
                 (cons "IDEN\t-\tIdentification tags" minor2_list)
          ) ;_ end of setq
        ) ;_ end of setq
        tmpfile
      ) ;_ end of write-line
      (write-line
        (car
          (setq minor2_list (cons "KEYN\t-\tKeynotes" minor2_list))
        ) ;_ end of car
        tmpfile
      ) ;_ end of write-line
      (write-line
        (CAR
          (setq minor2_list (cons "LABL\t-\tLabels" minor2_list))
        ) ;_ end of CAR
        tmpfile
      ) ;_ end of write-line
      (write-line
        (car
          (setq minor2_list
                 (cons "LEGN\t-\tLegends, symbol keys" minor2_list)
          ) ;_ end of setq
        ) ;_ end of setq
        tmpfile
      ) ;_ end of write-line
      (write-line
        (car
          (setq minor2_list
                 (cons "MARK\t-\tMarkers, break marks, leaders"
                       minor2_list
                 ) ;_ end of cons
          ) ;_ end of setq
        ) ;_ end of setq
        tmpfile
      ) ;_ end of write-line
      (write-line
        (car
          (setq minor2_list (cons "MATC\t-\tMatch lines" minor2_list))
        ) ;_ end of car
        tmpfile
      ) ;_ end of write-line
      (write-line
        (car
          (setq minor2_list (cons "NOTE\t-\tNotes" minor2_list))
        ) ;_ end of car
        tmpfile
      ) ;_ end of write-line
      (write-line
        (car
          (setq minor2_list
                 (cons "NPLT\t-\tNon-plotting graphic information"
                       minor2_list
                 ) ;_ end of cons
          ) ;_ end of setq
        ) ;_ end of setq
        tmpfile
      ) ;_ end of write-line
      (write-line
        (car
          (setq minor2_list
                 (cons "RDME\t-\tRead-me layer (not plotted)"
                       minor2_list
                 ) ;_ end of cons
          ) ;_ end of setq
        ) ;_ end of setq
        tmpfile
      ) ;_ end of write-line
      (write-line
        (car
          (setq minor2_list (cons "REDL\t-\tRedlines" minor2_list))
        ) ;_ end of car
        tmpfile
      ) ;_ end of write-line
      (write-line
        (car
          (setq minor2_list
                 (cons "REFR\t-\tReference, external files"
                       minor2_list
                 ) ;_ end of cons
          ) ;_ end of setq
        ) ;_ end of setq
        tmpfile
      ) ;_ end of write-line
      (write-line
        (car
          (setq minor2_list
                 (cons "REVC\t-\tRevision clouds" minor2_list)
          ) ;_ end of setq
        ) ;_ end of car
        tmpfile
      ) ;_ end of write-line
      (write-line
        (car
          (setq minor2_list (cons "REVS\t-\tRevisions" minor2_list))
        ) ;_ end of car
        tmpfile
      ) ;_ end of write-line
      (write-line
        (car
          (setq minor2_list (cons "SCHD\t-\tSchedules" minor2_list))
        ) ;_ end of car
        tmpfile
      ) ;_ end of write-line
      (write-line
        (car
          (setq minor2_list
                 (cons "SYMB\t-\tReference symbols" minor2_list)
          ) ;_ end of setq
        ) ;_ end of setq
        tmpfile
      ) ;_ end of write-line
      (write-line
        (car
          (setq minor2_list (cons "TEXT\t-\tText" minor2_list))
        ) ;_ end of car
        tmpfile
      ) ;_ end of write-line
      (write-line
        (car
          (setq minor2_list (cons "TABL\t-\tData tables" minor2_list))
        ) ;_ end of car
        tmpfile
      ) ;_ end of write-line
      (write-line
        (car
          (setq minor2_list
                 (cons "TITL\t-\tDrawing or detail titles"
                       minor2_list
                 ) ;_ end of cons
          ) ;_ end of setq
        ) ;_ end of setq
        tmpfile
      ) ;_ end of write-line
      (write-line
        (car
          (setq minor2_list
                 (cons "TTLB\t-\tBorder and title block"
                       minor2_list
                 ) ;_ end of cons
          ) ;_ end of setq
        ) ;_ end of setq
        tmpfile
      ) ;_ end of write-line
      (close tmpfile)
      (if (setq mn2_lst (acad_strlsort minor2_list))
        (setq minor2_list mn2_lst)
        (setq clg5_err "Not enough memory to sort minor list 2. ")
      ) ;_ end of if
      (start_list "Minor2_list")
      (mapcar 'add_list minor2_list)
      (end_list)
      (set_list minor2_list "Minor2_list" clg5_minor2 4)
    ) ;_ end of progn
  ) ;_ end of if
  (princ)
) ;_ end of defun
;;;********************************************************************
(defun get_user_list (/)
  (setq user_list nil)
  (setq user_file (findfile "clg5_user.dat"))
  (if user_file
    (progn
      (setq user_dat (open user_file "r"))
      (while (setq str (read-line user_dat))
        (setq user_list (append user_list (list str)))
      ) ;_ end of while
      (close user_dat)
      (if (setq us_lst (acad_strlsort user_list))
        (setq user_list us_lst)
        (setq clg5_err "Not enough memory to sort user defined list. ")
      ) ;_ end of if
    ) ;_ end of progn
  ) ;_ end of if
  (princ)
) ;_ end of defun
;;;********************************************************************
(defun get_status_list (/)
  (setq status_list nil)
  (setq status_file (findfile "clg5status.dat"))
  (if status_file
    (progn
      (setq status_dat (open status_file "r"))
      (while (setq str (read-line status_dat))
        (setq status_list (append status_list (list str)))
      ) ;_ end of while
      (close status_dat)
;;;      (if (setq st_lst (acad_strlsort status_list))
;;;        (setq status_list st_lst)
;;;        (setq clg_err "Not enough memory to sort status list.")
;;;      ) ;_ end of if
    ) ;_ end of progn
  ) ;_ end of if
  (princ)
) ;_ end of defun
;;;********************************************************************
;;;Constructs a list of layers in the drawing.
(defun set_lay_list (/)
  (progn
    (setq it (tblnext "layer" "T"))
    (setq itn (cdr (assoc 2 it)))
    (VL-LOAD-COM)
    (IF (< (ATOF (GETVAR "ACADVER")) 17.0)
      (SETQ this_description "")
      (SETQ this_description (VLA-GET-DESCRIPTION (VLAX-ENAME->VLA-OBJECT (TBLOBJNAME "LAYER" itn))))
    ) ;_ end of IF
    (setq newlist (list (strcat itn "\t-\t" this_description)))
    (while
      (setq it (tblnext "layer"))
       (progn
         (setq itn (cdr (assoc 2 it)))
         (IF (< (ATOF (GETVAR "ACADVER")) 17.0)
           (SETQ this_description "")
           (SETQ this_description (VLA-GET-DESCRIPTION (VLAX-ENAME->VLA-OBJECT (TBLOBJNAME "LAYER" itn))))
         ) ;_ end of IF
         (IF (WCMATCH itn "*|*")
           NIL
           (setq newlist (append newlist (list (strcat itn "\t-\t" this_description))))
         ) ;_ end of IF
       ) ;_ end of progn
    ) ;_ end of while
;;;    (setq newlist (acad_strlsort newlist))
;;;    (if	(>= (ATOF(getvar "acadver")) 14.00)
;;;      (setq
;;;	lay_f (open (strcat (substr (getvar "dwgname")
;;;				    1
;;;				    (- (strlen (getvar "dwgname")) 4)
;;;			    ) ;_ end of substr
;;;			    ".LST"
;;;		    ) ;_ end of strcat
;;;		    "w"
;;;	      ) ;_ end of open
;;;      ) ;_ end of setq
;;;      (setq lay_f (open (strcat (getvar "dwgname") ".LST") "w"))
;;;    ) ;_ end of if
;;;    (foreach n newlist (write-line n lay_f))
;;;    (close lay_f)
    (if (setq nw_lst (acad_strlsort newlist))
      (setq newlist nw_lst)
      (setq clg5_err "Not enough memory to sort layer list. ")
    ) ;_ end of if
  ) ;_ end of progn
  (princ)
) ;_ end of defun
;;;********************************************************************
;;;Sets current selection in a listbox to a specified value
(defun set_list (aalist key value slno /)
  (if (eq (type aalist) 'SYM)
    (setq aalist (eval aalist))
  )
  (if (eq (type value) 'SYM)
    (setq value (eval value))
  )
  (setq count 0)
  (while (< count (length aalist))
    (if
      (eq (substr (nth count aalist) 1 slno) value)
       (progn
         (set_tile key (itoa count))
         (setq count (length aalist))
       ) ;_ end of progn
       (progn
         (set_tile key "0")
         (setq count (1+ count))
       ) ;_ end of progn
    ) ;_ end of if
  ) ;_ end of while
  (if debug_set_list
    (progn
      (if stacklist
        nil
        (load "stacklist" "\nFile STACKLIST.LSP not loaded! ")
      ) ;_ end of if
      (princ "\nOur list: \n")
      (stacklist aalist)
      (princ "\nOur Key: ")
      (princ key)
      (princ "\nOur Value: ")
      (princ value)
      (princ "\nOur slno: ")
      (princ slno)
      (princ)
    ) ;_ end of progn
  ) ;_ end of if
  (princ)
) ;_ end of defun
;;;********************************************************************
(defun clg5_edat ( / )
  (setq newitem nil)
  (cond
    ((= whlst "discipline")
     (setq keyname "discipline_add"
           whsl    "dis"
     ) ;_ end of setq
     (setq discipline_file (findfile "clg5discipline.dat"))
    )
    ((= whlst "major")
     (setq keyname "major_add"
           whsl    "maj"
     ) ;_ end of setq
     (if major_file
       nil
       (setq major_file (findfile (strcat "clg" whsl clg5_discipline ".dat")))
     )
     (setq pre-edit_major_list major_list)
    )
    ((= whlst "minor1")
     (setq keyname "minor_add"
           whsl    "min1"
     ) ;_ end of setq
     (if minor1_file
       nil
       (setq minor1_file (findfile (strcat "clg5min1" discipline ".dat")))
     )
     (setq pre-edit_minor1_list minor1_list)
    )
    ((= whlst "minor2")
     (setq keyname "minor_add"
           whsl    "min2"
     ) ;_ end of setq
     (if minor2_file
       nil
       (setq minor2_file (findfile (strcat "clg5min2all.dat")))
     )
     (setq pre-edit_minor2_list minor2_list)
    )
    ((= whlst "user")
     (setq keyname "user_add"
           whsl    "usr"
     ) ;_ end of setq
     (if user_file
       nil
       (setq user_file (findfile "clg5_user.dat"))
     )
     (setq pre-edit_user_list user_list)
    )
  ) ;_ end of cond
  (new_dialog (strcat "clg5_" (if (wcmatch whlst "minor#") "minor" whlst))
    clg5_num
    ""
    (if (AND clg5_editloc (not (equal clg5_editloc '(0 0))))
      clg5_editloc
      (IF old_clg5_editloc
        old_clg5_editloc
        '(-1 -1)
      ) ;_ end of IF
    ) ;_ end of if
  ) ;_ end of new_dialog
  (mode_tile "new_item" 2)
  (set_tile (strcat (if (wcmatch whlst "minor#") "minor" whlst) "_file") (strcat "Filename: " (eval(read (strcat whlst "_file")))))
  (action_tile (strcat (if (wcmatch whlst "minor#") "minor" whlst) "_add") "(set_edit_box)")
  (action_tile
    "Add_more"
    "(setq newitem (get_tile \"new_item\"))(add_item)(set_tile \"new_item\" \"\")(mode_tile \"new_item\" 2)"
  ) ;_ end of action_tile
  (action_tile
    "Repl_line"
    "(setq repl_key (get_tile(strcat(if(wcmatch whlst \"minor#\") \"minor\" whlst)\"_add\")))(repl_item)"
  ) ;_ end of action_tile
  (action_tile
    "Delete_line"
    "(setq del_key (get_tile (strcat(if(wcmatch whlst \"minor#\") \"minor\" whlst)\"_add\")))(del_lines)(set_tile\"new_item\" \"\")"
  ) ;_ end of action_tile
  (action_tile
    "insert_tab"
    "(set_tile \"new_item\"(strcat(get_tile\"new_item\")\"\t-\t\"))(mode_tile\"new_item\" 2)"
  ) ;_ end of action_tile
  (action_tile
    "Save_edits" "(setq clg5_funct2 '(save_edits))(setq clg5_editloc (done_dialog 1))"
  )
;;;  (action_tile
;;;    "Add_done"
;;;    ""
;;;  ) ;_ end of action_tile
  (action_tile
    "Add_cancel"
    "(setq clg5_editloc (done_dialog 0))"
  ) ;_ end of action_tile
  (eval (read (strcat "set_" whlst "_list")))
  (start_list (strcat (if (wcmatch whlst "minor#") "minor" whlst) "_add"))
  (mapcar 'add_list (eval (read (strcat whlst "_list"))))
  (end_list)
  (set_list (eval (read (strcat whlst "_list")))
            (strcat (if (wcmatch whlst "minor#") "minor" whlst) "_add")
            "0"
            (if (or (wcmatch whlst "minor#")
                    (wcmatch whlst "major")
                    (wcmatch whlst "user")
                )
              4
              (if (wcmatch whlst "disci*")
                2
                1
              )
            )
  ) ;_ end of set_list
;;;  (if (and (= clg5dis "0") (= whlst "major"))
;;;    (progn
;;;      (mode_tile "new_item" 1)
;;;      (mode_tile "Add_more" 1)
;;;      (mode_tile "Repl_line" 1)
;;;      (mode_tile "Delete_line" 1)
;;;      (mode_tile "insert_tab" 1)
;;;      (mode_tile "Save_edits" 1)
;;;      (mode_tile "Add_done" 1)
;;;    ) ;_ end of progn
;;;  ) ;_ end of if
  (setq done_mode (start_dialog))
  (IF clg5_funct2
    (progn
      (EVAL clg5_funct2)
      (setq clg5_funct2 nil)
    )
  )
  (IF (EQ done_mode 0)
    nil
    (f_all)
  )
) ;_ end of defun
;;;********************************************************************
(defun set_edit_box (/)
  (setq del_key (get_tile (strcat (if (wcmatch whlst "minor#") "minor" whlst) "_add")))
  (if (or (eq (strlen del_key) 1)(eq (strlen del_key) 2)(eq (strlen del_key) 3))
    (set_tile "new_item"
              (nth (atoi del_key) (if (eval (read (strcat whlst "_list"))) (eval (read (strcat whlst "_list"))) (strcat "    \t-\tno " (if (wcmatch whlst "minor#") "Minor" whlst) " Group Active (optional)")))
    ) ;_ end of set_tile
    (set_tile "new_item" "")
  ) ;_ end of if
  (princ)
) ;_ end of defun
;;;********************************************************************
;;;(defun repl_item (/)
;;;  (if (eq (strlen repl_key) 1)
;;;    (progn
;;;      (setq exst_str (nth (atoi repl_key)
;;;			  (eval (read (strcat whlst "_list")))
;;;		     ) ;_ end of nth
;;;	    repl_str (get_tile "new_item")
;;;      ) ;_ end of setq
;;;      (set (read (strcat "new_" whlst "_list"))
;;;	   (subst repl_str
;;;		  exst_str
;;;		  (eval (read (strcat whlst "_list")))
;;;	   ) ;_ end of subst
;;;      ) ;_ end of set
;;;      (set_tile "new_item" "")
;;;      (mode_tile "new_item" 2)
;;;      (start_list (strcat whlst "_add") 1 (atoi repl_key))
;;;      (add_list repl_str)
;;;      (end_list)
;;;    ) ;_ end of progn
;;;  ) ;_ end of if
;;;  (princ)
;;;) ;_ end of defun
;;;********************************************************************
(DEFUN repl_item (/)
  (IF (EQ (TYPE (READ repl_key)) 'INT)
    (PROGN
      (SETQ exst_str (NTH (ATOI repl_key)
                          (eval (read (strcat whlst "_list")))
                     ) ;_ end of NTH
            repl_str (GET_TILE "new_item")
            rslen    (STRLEN repl_str)
            chrcnt   1
      ) ;_ end of setq
      (SETQ new_list (SUBST repl_str
                            exst_str
                            (eval (read (strcat whlst "_list")))
                     ) ;_ end of SUBST
      ) ;_ end of SETQ
      (SET (read (strcat whlst "_list")) new_list)
      (SET_TILE "new_item" "")
      (MODE_TILE "new_item" 2)
      (start_list (strcat (if (wcmatch whlst "minor#") "minor" whlst) "_add") 1 (atoi repl_key))
      (add_list repl_str)
      (end_list)
      (SET_TILE (strcat (if (wcmatch whlst "minor#") "minor" whlst) "_add") repl_key)
      (SET_TILE
        "new_item"
        (NTH (ATOI repl_key) (eval (read (strcat whlst "_list"))))
      ) ;_ end of SET_TILE
      (MODE_TILE "new_item" 3)
    ) ;_ end of progn
  ) ;_ end of if
  (PRINC)
) ;_ end of DEFUN
;;;********************************************************************
(defun add_item (/)
  (if (eq newitem "")
    nil
    (progn
;;;      (alert newitem)
      (start_list keyname 2)
      (add_list newitem)
      (set (read (strcat whlst "_list"))
           (append (eval (read (strcat whlst "_list"))) (list newitem))
      ) ;_ end of set
      (set (read (strcat "new_" whlst "_list"))
           (eval (read (strcat whlst "_list")))
      ) ;_ end of set
      (setq newitem nil)
      (end_list)
    ) ;_ end of progn
  ) ;_ end of if
  (princ)
) ;_ end of defun
;;;********************************************************************
(defun save_edits (/)
  (if (eval (read (strcat "new_" whlst "_list")))
    (progn
;;;      (ALERT (strcat "SAVE_EDITS\n"(LAST (eval (read (strcat "new_" whlst "_list"))))))
      (set (read (strcat whlst "_dat"))
           (open (eval (read (strcat whlst "_file"))) "w")
      ) ;_ end of set
      (foreach n (eval (read (strcat "new_" whlst "_list")))
        (write-line n (eval (read (strcat whlst "_dat"))))
      ) ;_ end of foreach
      (close (eval (read (strcat whlst "_dat"))))
      (set (read (strcat whlst "_list"))
           (eval (read (strcat "new_" whlst "_list")))
      )
    ) ;_ end of progn
    (alert "NO LIST")
  ) ;_ end of if
;;;  (if (= newitem "")
;;;    nil
;;;    (progn
;;;      (if (member newitem (eval (read (strcat whlst "_list"))))
;;;        nil
;;;        (progn
;;;          (start_list keyname 2)
;;;          (add_list newitem)
;;;          (set
;;;            (read (strcat whlst "_list"))
;;;            (append (eval (read (strcat whlst "_list"))) (list newitem))
;;;          ) ;_ end of set
;;;          (set (read (strcat "clg5" whsl))
;;;               (itoa (1- (length (eval (read (strcat whlst "_list"))))))
;;;          ) ;_ end of set
;;;          (set (read (strcat whlst "_dat"))
;;;               (open (eval (read (strcat whlst "_file"))) "a")
;;;          ) ;_ end of set
;;;          (write-line newitem (eval (read (strcat whlst "_dat"))))
;;;          (close (eval (read (strcat whlst "_dat"))))
;;;        ) ;_ end of progn
;;;      ) ;_ end of if
;;;      (if (member newitem (eval (read (strcat "new_" whlst "_list"))))
;;;        nil
;;;        (set (read (strcat "new_" whlst "_list"))
;;;             (append (eval (read (strcat "new_" whlst "_list")))
;;;                     (list newitem)
;;;             ) ;_ end of append
;;;        ) ;_ end of set
;;;      ) ;_ end of if
;;;      (setq newitem nil)
;;;      (end_list)
;;;    ) ;_ end of progn
;;;  ) ;_ end of if
  (princ)
) ;_ end of defun
;;;********************************************************************
(defun manylay (/)
  (setq thislayer (nth (atoi curlay) newlist))
  (IF (and thislayer (>= (strlen thislayer) 6))
    (PROGN
      (COND
        ((AND sel_clg5_color clg5_ltname)
          (command ".layer" "m" thislayer "c" sel_clg5_color thislayer "l" clg5_ltname thislayer ""))
        (sel_clg5_color
          (command ".layer" "m" thislayer "c" sel_clg5_color thislayer ""))
        (clg5_ltname
          (command ".layer" "m" thislayer "l" clg5_ltname thislayer ""))
        (T
          (command ".layer" "m" thislayer ""))
      )
    )
    (if (eq clg5_plot "0") (command ".layer" "p" "No" thislayer ""))
  )
  (setq discipline_key nil)
  (foreach n discipline_list
    (if discipline_key
      (setq discipline_key (append discipline_key (list (substr n 1 1))))
      (setq discipline_key (list (substr n 1 1)))
    ) ;_ end of if
  ) ;_ end of foreach
  (if (setq memlst (member (substr thislayer 1 1) discipline_key))
    (progn
      (setq discipline   (car memlst)
            clg5_discipline discipline
      ) ;_ end of setq
      (setq clg5dis (itoa (- (length discipline_key) (length memlst))))
    ) ;_ end of progn
    (setq clg5dis "0")
  ) ;_ end of if
  (setq discipline_file (findfile "clg5discipline.dat"))
  (f_major)
  (setq maj_key nil)
  (foreach n major_list
    (if maj_key
      (setq maj_key (append maj_key (list (substr n 1 4))))
      (setq maj_key (list (substr n 1 4)))
    ) ;_ end of if
  ) ;_ end of foreach
   (setq maj_idx 3
         maj_dur 4
   ) ;_ end of setq
  (setq majcnt 0)
  (while
    (and
      (< majcnt (length maj_key))
      (not
        (wcmatch (nth majcnt maj_key)
                 (strcat (substr thislayer maj_idx maj_dur) "*")
        ) ;_ end of wcmatch
      ) ;_ end of not
    ) ;_ end of and
     (setq majcnt (1+ majcnt))
  ) ;_ end of while
  (if (setq memlst (member (nth majcnt maj_key) maj_key))
    (progn
      (setq prod (car memlst)
            clg5_major prod
      ) ;_ end of setq
      (setq clg5maj (itoa (- (length maj_key) (length memlst))))
    ) ;_ end of progn
    (setq clg5maj "0")
  ) ;_ end of if
  (setq min1_key nil)
  (foreach n minor1_list
    (if min1_key
      (setq min1_key (append min1_key (list (substr n 1 4))))
      (setq min1_key (list (substr n 1 4)))
    ) ;_ end of if
  ) ;_ end of foreach
  (setq min1_idx 8
        min1_dur 4
  ) ;_ end of setq
  (if (not no_min1)
    (progn
      (setq min1cnt 0)
      (while
        (and
          (< min1cnt (length min1_key))
          (not
            (wcmatch (nth min1cnt min1_key)
                     (strcat (substr thislayer min1_idx min1_dur) "*")
            ) ;_ end of wcmatch
          ) ;_ end of not
        ) ;_ end of and
         (setq min1cnt (1+ min1cnt))
      ) ;_ end of while
      (if (setq memlst (member (nth min1cnt min1_key) min1_key))
        (progn
          (setq minr1 (car memlst)
                clg5_minor1 minr1
          ) ;_ end of setq
          (setq clg5min1 (itoa (- (length min1_key) (length memlst))))
        ) ;_ end of progn
        (setq clg5min1 "0")
      ) ;_ end of if
    ) ;_ end of progn
  ) ;_ end of if
  (setq min2_key nil)
  (foreach n minor2_list
    (if min2_key
      (setq min2_key (append min2_key (list (substr n 1 4))))
      (setq min2_key (list (substr n 1 4)))
    ) ;_ end of if
  ) ;_ end of foreach
  (setq min2_idx 8
        min2_dur 4
  ) ;_ end of setq
  (if (not no_min2)
    (progn
      (setq min2cnt 0)
      (while
        (and
          (< min2cnt (length min2_key))
          (not
            (wcmatch (nth min2cnt min2_key)
                     (strcat (substr thislayer min2_idx min2_dur) "*")
            ) ;_ end of wcmatch
          ) ;_ end of not
        ) ;_ end of and
         (setq min2cnt (1+ min2cnt))
      ) ;_ end of while
      (if (setq memlst (member (nth min2cnt min2_key) min2_key))
        (progn
          (setq minr1 (car memlst)
                clg5_minor1 minr1
          ) ;_ end of setq
          (setq clg5min2 (itoa (- (length min2_key) (length memlst))))
        ) ;_ end of progn
        (setq clg5min2 "0")
      ) ;_ end of if
    ) ;_ end of progn
  ) ;_ end of if
  (setq usr_key nil
        usr_idx nil
        usr_dur nil
  ) ;_ end of setq
  (foreach n user_list
    (if usr_key
      (setq usr_key (append usr_key (list (substr n 1 4))))
      (setq usr_key (list (substr n 1 4)))
    ) ;_ end of if
  ) ;_ end of foreach
  (cond
    (no_usr
     (setq usdf ""
           clg5_user ""
           clg5usr "0"
     ) ;_ end of setq
    )
    (T
     (setq usr_idx 13
           usr_dur 4
     ) ;_ end of setq
    )
  )
  (if (not no_usr)
    (progn
      (setq usrcnt 0)
      (while
        (and
          (< usrcnt (length usr_key))
          (not
            (wcmatch (nth usrcnt usr_key)
                     (strcat (substr thislayer usr_idx usr_dur) "*")
            ) ;_ end of wcmatch
          ) ;_ end of not
        ) ;_ end of and
         (setq usrcnt (1+ usrcnt))
      ) ;_ end of while
      (if (setq memlst (member (nth usrcnt usr_key) usr_key))
        (progn
          (setq usdf     (car memlst)
                clg5_user usdf
          ) ;_ end of setq
          (setq clg5usr (itoa (- (length usr_key) (length memlst))))
        ) ;_ end of progn
        (setq clg5usr "0")
      ) ;_ end of if
    ) ;_ end of progn
  ) ;_ end of if
  (setq do_manylay T)
;;;  (set_hist)
  (setq do_manylay nil)
  (princ)
) ;_ end of defun
;;;********************************************************************
(defun mlay (/)
  (if (and clg5lay (>= (strlen clg5lay) 6))
    (progn
      (setq thislayer clg5lay)
      (COND
        ((AND sel_clg5_color clg5_ltname)
         (command ".layer"    "m"         thislayer   "c"
                  sel_clg5_color          thislayer   "l"
                  clg5_ltname      thislayer   ""
                 ) ;_ end of command
        )
        (sel_clg5_color
         (command ".layer" "m" thislayer "c" sel_clg5_color thislayer "") ;_ end of command
        )
        (clg5_ltname
         (command ".layer" "m" thislayer "l" clg5_ltname thislayer "")
        )
        (T
         (command ".layer" "m" thislayer "")
        )
      ) ;_ end of COND
      (if discipline_txt
        (progn
          (if (wcmatch discipline_txt "*\t")
            (setq discipline_txt "")
            (while (wcmatch discipline_txt "*\t*")
              (setq discipline_txt (substr discipline_txt 2))
            ) ;_ end of while
          ) ;_ end of if
        ) ;_ end of progn
        (setq discipline_txt "")
      ) ;_ end of if
      (if major_txt
        (progn
          (if (wcmatch major_txt "*\t")
            (setq major_txt "")
            (while (wcmatch major_txt "*\t*")
              (setq major_txt (substr major_txt 2))
            ) ;_ end of while
          ) ;_ end of if
        ) ;_ end of progn
        (setq major_txt "")
      ) ;_ end of if
      (if minor1_txt
        (progn
          (if (wcmatch minor1_txt "*\t")
            (setq minor1_txt "")
            (while (wcmatch minor1_txt "*\t*")
              (setq minor1_txt (substr minor1_txt 2))
            ) ;_ end of while
          ) ;_ end of if
        ) ;_ end of progn
        (setq minor1_txt nil)
      ) ;_ end of if
      (if minor2_txt
        (progn
          (if (wcmatch minor2_txt "*\t")
            (setq minor2_txt "")
            (while (wcmatch minor2_txt "*\t*")
              (setq minor2_txt (substr minor2_txt 2))
            ) ;_ end of while
          ) ;_ end of if
        ) ;_ end of progn
        (setq minor2_txt nil)
      ) ;_ end of if
      (if user_txt
        (progn
          (if (wcmatch user_txt "*\t")
            (setq user_txt "")
            (while (wcmatch user_txt "*\t*")
              (setq user_txt (substr user_txt 2))
            ) ;_ end of while
          ) ;_ end of if
        ) ;_ end of progn
        (setq user_txt nil)
      ) ;_ end of if
      (if status_txt
        (progn
          (if (wcmatch status_txt "*\t")
            (setq status_txt "")
            (while (wcmatch status_txt "*\t*")
              (setq status_txt (substr status_txt 2))
            ) ;_ end of while
          ) ;_ end of if
        ) ;_ end of progn
        (setq status_txt nil)
      ) ;_ end of if
      (SETQ this_descr
             (strcat (IF (AND
                           (WCMATCH clg5_discipline "V ")
                           (OR
                             (WCMATCH clg5_major "NODE")
                             (WCMATCH clg5_major "CTRL")
                           )
                         )
                       "Survey"
                       discipline_txt
                     )
                     " "
                     (COND
                       ((AND
                           (WCMATCH clg5_discipline "V ")
                           (WCMATCH clg5_major "NODE")
                        )
                       "Node:")
                       ((AND
                           (WCMATCH clg5_discipline "V ")
                           (WCMATCH clg5_major "CTRL")
                        )
                       "Control:")
                       (T (strcase major_txt T))
                     )
                     (if (and minor1_txt (/= minor1_txt ""))
                       (strcase (strcat " " minor1_txt) T)
                       ""
                     ) ;_ end of if
                     (if (and minor2_txt (/= minor2_txt ""))
                       (strcase (strcat " " minor2_txt) T)
                       ""
                     ) ;_ end of if
                     (if (and user_txt (/= user_txt ""))
                       (strcase (strcat " " user_txt) T)
                       ""
                     ) ;_ end of if
                     (if (and status_txt (/= status_txt ""))
                       (strcase (strcat " - " status_txt) T)
                       ""
                     ) ;_ end of if
             ) ;_ end of strcat
      ) ;_ end of SETQ
      (setq discipline_txt
             nil
            major_txt nil
            minor1_txt
             nil
            minor2_txt
             nil
            user_txt nil
            status_txt
             nil
      ) ;_ end of setq
      (IF this_descr
        (PROGN (VL-LOAD-COM)
               (VLA-PUT-DESCRIPTION
                 (VLAX-ENAME->VLA-OBJECT
                   (TBLOBJNAME "LAYER" (GETVAR "clayer"))
                 ) ;_ end of VLAX-ENAME->VLA-OBJECT
                 this_descr
               ) ;_ end of VLA-PUT-DESCRIPTION
        ) ;_ end of PROGN
      ) ;_ end of IF
    ) ;_ end of progn
  ) ;_ end of if
  (setq clg5lay nil)
  (princ)
) ;_ end of defun
;;;********************************************************************
(defun intchk (ivar /)
  (if (atoi ivar)
    nil
    (setq ivar "0")
  ) ;_ end of if
) ;_ end of defun
;;;********************************************************************
(defun c:nvars (/)
  (princ (strcat "\nclg5_discipline = "
                 (if clg5_discipline
                   clg5_discipline
                   "NIL"
                 ) ;_ end of if
                 "\nclg5_ltype = "
                 (if clg5_ltype
                   clg5_ltype
                   "NIL"
                 ) ;_ end of if
                 "\nclg5_major = "
                 (if clg5_major
                   clg5_major
                   "NIL"
                 ) ;_ end of if
                 "\nclg5_color = "
                 (if clg5_color
                   clg5_color
                   "NIL"
                 ) ;_ end of if
                 "\nclg5_minor1 = "
                 (if clg5_minor1
                   clg5_minor1
                   "NIL"
                 ) ;_ end of if
                 "\nclg5_minor2 = "
                 (if clg5_minor2
                   clg5_minor2
                   "NIL"
                 ) ;_ end of if
                 "\nclg5_user = "
                 (if clg5_user
                   clg5_user
                   "NIL"
                 ) ;_ end of if
                 "\nclg5dis = "
                 (if clg5dis
                   clg5dis
                   "NIL"
                 ) ;_ end of if
                 "\nclg5llt = "
                 (if clg5llt
                   clg5llt
                   "NIL"
                 ) ;_ end of if
                 "\nclg5maj = "
                 (if clg5maj
                   clg5maj
                   "NIL"
                 ) ;_ end of if
                 "\nclg5col = "
                 (if clg5col
                   clg5col
                   "NIL"
                 ) ;_ end of if
                 "\nclg5min1 = "
                 (if clg5min1
                   clg5min1
                   "NIL"
                 ) ;_ end of if
                 "\nclg5min2 = "
                 (if clg5min2
                   clg5min2
                   "NIL"
                 ) ;_ end of if
                 "\nclg5usr = "
                 (if clg5usr
                   clg5usr
                   "NIL"
                 ) ;_ end of if
         ) ;_ end of strcat
  ) ;_ end of princ
  (princ)
) ;_ end of defun
;;;********************************************************************
(defun del_lines ()
  (setq del_ndx_lst
         nil
        cur_list nil
  ) ;_ end of setq
  (if whlst
    (set (read (strcat "new_" whlst "_list")) nil)
  ) ;_ end of if
  (setq count 1)
  (while (<= count (strlen del_key))
    (while (and (eq (substr del_key count 1) " ")
                (not (> count (strlen del_key)))
           ) ;_ end of and
      (setq count (1+ count))
    ) ;_ end of while
    (setq strt_cnt count
          end_cnt 0
    ) ;_ end of setq
    (while (and (not (eq (substr del_key count 1) " "))
                (not (> count (strlen del_key)))
           ) ;_ end of and
      (setq count   (1+ count)
            end_cnt (1+ end_cnt)
      ) ;_ end of setq
    ) ;_ end of while
    (if (<= strt_cnt (strlen del_key))
      (setq del_ndx_lst
             (if del_ndx_lst
               (append del_ndx_lst
                       (list (atoi (substr del_key strt_cnt end_cnt)))
               ) ;_ end of append
               (list (atoi (substr del_key strt_cnt end_cnt)))
             ) ;_ end of if
      ) ;_ end of setq
    ) ;_ end of if
  ) ;_ end of while
  (setq cur_list (eval (read (strcat whlst "_list"))))
  (if cur_list
    (progn
      (foreach n del_ndx_lst
        (setq cur_list
               (subst nil (nth n cur_list) cur_list)
        ) ;_ end of setq
      ) ;_ end of foreach
      (foreach n cur_list
        (if n
          (set (read (strcat "new_" whlst "_list"))
               (if (read (strcat "new_" whlst "_list"))
                 (append (eval (read (strcat "new_" whlst "_list")))
                         (list n)
                 ) ;_ end of append
                 (list n)
               ) ;_ end of if
          ) ;_ end of set
        ) ;_ end of if
      ) ;_ end of foreach
      (set (read (strcat whlst "_list"))
           (eval (read (strcat "new_" whlst "_list")))
      ) ;_ end of set
    ) ;_ end of progn
    (set
      (read (strcat whlst "_list"))
      (list
        (strcat "    \t-\tno "
                (if (wcmatch whlst "minor#")
                  "Minor"
                  (strcat (strcase (substr whlst 1 1)) (substr whlst 2))
                ) ;_ end of if
                " Group Active (optional)"
        ) ;_ end of strcat
      ) ;_ end of list
    ) ;_ end of set
  ) ;_ end of if
  (start_list
    (strcat (if (wcmatch whlst "minor#")
              "minor"
              whlst
            ) ;_ end of if
            "_add"
    ) ;_ end of strcat
  ) ;_ end of start_list
  (mapcar 'add_list
          (eval (read (strcat "new_" whlst "_list")))
  ) ;_ end of mapcar
  (end_list)
  (princ)
) ;_ end of defun
;;;********************************************************************
;;;History remembers last settings for each Discipline Group.
;;;(But startup of the dialog should always show the current CLG settings)---FIX THIS!!!
(defun set_hist ()
  (if do_manylay
    nil
    (setq clg5dis (get_tile "Discipline_list")
          clg5_discipline (substr (nth (atoi clg5dis) discipline_list) 1 2)
          clg5maj (get_tile "Major_list")
          clg5min1 (get_tile "Minor1_list")
          clg5min2 (get_tile "Minor2_list")
          clg5usr (get_tile "User_defined_list")
          clg5sta (get_tile "Status_list")
    ) ;_ end of setq
  ) ;_ end of if
;;;  (if clg5_hist
;;;    (if (member (assoc clg5_discipline clg5_hist) clg5_hist)
;;;      (setq clg5_hist
;;;             (subst
;;;               (cons clg5_discipline
;;;                     (list
;;;                       (if clg5maj
;;;                         clg5maj
;;;                         "0"
;;;                       ) ;_ end of if
;;;                       (if clg5min
;;;                         clg5min
;;;                         "0"
;;;                       ) ;_ end of if
;;;                       (if clg5usr
;;;                         clg5usr
;;;                         "0"
;;;                       ) ;_ end of if
;;;                     ) ;_ end of list
;;;               ) ;_ end of cons
;;;               (assoc clg5_discipline clg5_hist)
;;;               clg5_hist
;;;             ) ;_ end of subst
;;;      ) ;_ end of setq
;;;      (if (and clg5_discipline (/= clg5_discipline ""))
;;;        (setq clg5_hist
;;;               (append clg5_hist
;;;                       (list
;;;                         (cons clg5_discipline
;;;                               (list
;;;                                 (if clg5maj
;;;                                   clg5maj
;;;                                   "0"
;;;                                 ) ;_ end of if
;;;                                 (if clg5min
;;;                                   clg5min
;;;                                   "0"
;;;                                 ) ;_ end of if
;;;                                 (if clg5usr
;;;                                   clg5usr
;;;                                   "0"
;;;                                 ) ;_ end of if
;;;                               ) ;_ end of list
;;;                         ) ;_ end of cons
;;;                       ) ;_ end of list
;;;               ) ;_ end of append
;;;        ) ;_ end of setq
;;;      ) ;_ end of if
;;;    ) ;_ end of if
    (progn
      (foreach n discipline_list
        (if (eq (substr n 1 2) clg5_discipline)
;;;          (if clg5_hist
;;;            (setq clg5_hist
;;;                   (append clg5_hist
;;;                           (list
;;;                             (cons clg5_discipline
;;;                                   (list
;;;                                     (if clg5maj
;;;                                       clg5maj
;;;                                       "0"
;;;                                     ) ;_ end of if
;;;                                     (if clg5min
;;;                                       clg5min
;;;                                       "0"
;;;                                     ) ;_ end of if
;;;                                     (if clg5usr
;;;                                       clg5usr
;;;                                       "0"
;;;                                     ) ;_ end of if
;;;                                   ) ;_ end of list
;;;                             ) ;_ end of cons
;;;                           ) ;_ end of list
;;;                   ) ;_ end of append
;;;            ) ;_ end of setq
            (setq clg5_hist
                   (list
                     (cons clg5_discipline
                           (list
                             (if clg5maj
                               clg5maj
                               "0"
                             ) ;_ end of if
                             (if clg5min1
                               clg5min1
                               "0"
                             ) ;_ end of if
                             (if clg5min2
                               clg5min2
                               "0"
                             ) ;_ end of if
                             (if clg5usr
                               clg5usr
                               "0"
                             ) ;_ end of if
                             (if clg5sta
                               clg5sta
                               "0"
                             ) ;_ end of if
                           ) ;_ end of list
                     ) ;_ end of cons
                   ) ;_ end of list
            ) ;_ end of setq
;;;          ) ;_ end of if
;;;          (if clg5_hist
;;;            (setq clg5_hist
;;;                   (append clg5_hist
;;;                           (list (cons (substr n 1 1) '("0" "0" "0" "0" "0")))
;;;                   ) ;_ end of append
;;;            ) ;_ end of setq
            (setq clg5_hist
                   (list (cons (substr n 1 2) '("0" "0" "0" "0" "0"))
                   ) ;_ end of list
            ) ;_ end of setq
;;;          ) ;_ end of if
        ) ;_ end of if
      ) ;_ end of foreach
    ) ;_ end of progn
;;;  ) ;_ end of if
  (princ)
) ;_ end of defun
;;;********************************************************************
(defun clg5_res_hist ()
  (if discipline_list
    (PROGN
      (setq clg5dis (get_tile "Discipline_list")
            clg5_discipline (substr (nth (atoi clg5dis) discipline_list) 1 2)
      ) ;_ end of setq
;;;      (if clg5_hist
;;;        (if (member (assoc clg5_discipline clg5_hist) clg5_hist)
;;;          (progn
;;;            (setq mj_count 0
;;;                  clg5dis "0"
;;;            ) ;_ end of setq
;;;            (foreach n discipline_list
;;;              (if (eq (substr n 1 1) clg5_discipline)
;;;                (setq clg5dis (itoa mj_count))
;;;              ) ;_ end of if
;;;              (setq mj_count (1+ mj_count))
;;;            ) ;_ end of foreach
;;;            (setq last_clg (assoc clg5_discipline clg5_hist))
;;;            (setq clg5maj (nth 2 last_clg)
;;;                  clg5min (nth 4 last_clg)
;;;                  clg5usr (nth 5 last_clg)
;;;            ) ;_ end of setq
;;;          ) ;_ end of progn
;;;        ) ;_ end of if
        (progn
          (if clg5dis
            nil
            (setq clg5dis "0")
          ) ;_ end of if
          (if clg5maj
            nil
            (setq clg5maj "0")
          ) ;_ end of if
          (if clg5min1
            nil
            (setq clg5min1 "0")
          ) ;_ end of if
          (if clg5min2
            nil
            (setq clg5min2 "0")
          ) ;_ end of if
          (if clg5usr
            nil
            (setq clg5usr "0")
          ) ;_ end of if
          (if clg5sta
            nil
            (setq clg5sta "0")
          ) ;_ end of if
        ) ;_ end of progn
;;;      ) ;_ end of if
      (if clg5dis (set_tile "Discipline_list" clg5dis))
      (if clg5maj (set_tile "Major_list" clg5maj))
      (if clg5min1 (set_tile "Minor1_list" clg5min1))
      (if clg5min2 (set_tile "Minor2_list" clg5min2))
      (if clg5usr (set_tile "User_defined_list" clg5usr))
      (if clg5sta (set_tile "Status_list" clg5sta))
      (if (and major_list clg5maj (>(ATOI clg5maj)0)(<(ATOI clg5maj)(LENGTH major_list)))
        (setq clg5_major (substr (nth (atoi clg5maj) major_list) 1 4))
        (setq clg5_major "")         ;there is a problem here after some deletes!!!
      ) ;_ end of if
      (if (and minor1_list clg5min1 (>(ATOI clg5min1)0)(<(ATOI clg5min1)(LENGTH minor1_list)))
        (setq clg5_minor1 (substr (nth (atoi clg5min1) minor1_list) 1 4))
        (setq clg5_minor1 "    ")         ;there is a problem here after some deletes!!!
      ) ;_ end of if
      (if (and minor2_list clg5min1 (>(ATOI clg5min1)0)(<(ATOI clg5min1)(LENGTH minor2_list)))
        (setq clg5_minor2 (substr (nth (atoi clg5min1) minor2_list) 1 4))
        (setq clg5_minor2 "    ")         ;there is a problem here after some deletes!!!
      ) ;_ end of if
      (if (and user_list clg5usr (<(ATOI clg5usr)(LENGTH user_list)))
        (IF (WCMATCH (STRCASE (nth (atoi clg5usr) user_list)) "??##P*")
          (setq clg5_user (substr (nth (atoi clg5usr) user_list) 1 5))
          (setq clg5_user (substr (nth (atoi clg5usr) user_list) 1 4))
        ) ;_ end of IF
        (setq clg5_user "")
      ) ;_ end of if
      (if (and status_list clg5sta (>(ATOI clg5sta)0)(<(ATOI clg5sta)(LENGTH status_list)))
        (setq clg5_status (substr (nth (atoi clg5sta) status_list) 1 2))
        (setq clg5_status " ")         ;there is a problem here after some deletes!!!
      ) ;_ end of if
;;;      (if (AND user_list (<(ATOI clg5usr)(LENGTH user_list)))
;;;        (progn
;;;          (setq ucnt 1)
;;;          (while
;;;            (and
;;;              (/= (substr (nth (atoi clg5usr) user_list) ucnt 1) " ")
;;;              (/= (substr (nth (atoi clg5usr) user_list) ucnt 1) "\t")
;;;              (< ucnt (strlen (nth (atoi clg5usr) user_list)))
;;;            ) ;_ end of and
;;;             (setq ucnt (1+ ucnt))
;;;          ) ;_ end of while
;;;          (setq clg5_user
;;;                 (substr (nth (atoi clg5usr) user_list) 1 (1- ucnt))
;;;          ) ;_ end of setq
;;;        ) ;_ end of progn
;;;        (setq clg5_user "")
;;;      ) ;_ end of if
      (if (and status_list clg5sta (/= clg5sta "0")(<(ATOI clg5sta)(LENGTH status_list)))
        (setq clg5_status (substr (nth (atoi clg5sta) status_list) 1 2))
        (setq clg5_status "")         ;there is a problem here after some deletes!!!
      ) ;_ end of if
      (IF (OR (WCMATCH clg5_status "? ")(WCMATCH clg5_status "?\t"))
        (SETQ clg5_status (SUBSTR clg5_status 1 1))
      )
    ) ;_ end of PROGN
  ) ;_ end of if
  (princ)
) ;_ end of defun
;;;********************************************************************
(DEFUN select_clg5_ltype (/)
  (SET_TILE "error" "")
  (IF clg5_ltype_list
    (SETQ sel_clg5_ltype_list
           (MAPCAR
             '(LAMBDA (x)
                (EVAL (CONS 'STRCAT
                            (MAPCAR '(LAMBDA (y)
                                       (IF (EQ y (LAST x))
                                         (STRCAT y "")
                                         (STRCAT y "\t-\t")
                                       ) ;_ end of IF
                                     ) ;_ end of LAMBDA
                                    x
                            ) ;_ end of MAPCAR
                      ) ;_ end of CONS
                ) ;_ end of EVAL
              ) ;_ end of LAMBDA
             clg5_ltype_list
           ) ;_ end of MAPCAR
    ) ;_ end of SETQ
  ) ;_ end of IF
  (IF sel_clg5_ltype_list
    (PROGN
      (SETQ sel_ltypekey nil)
      (SETQ newdlg_selltype
             (NEW_DIALOG
               "selltype"
               clg5_num
               (IF defact_selltype
                 defact_selltype
                 ""
               ) ;_ end of IF
               (IF selltype_loc
                 selltype_loc
                 '(-1 -1)
               ) ;_ end of IF
             ) ;_ end of NEW_DIALOG
      ) ;_ end of SETQ
      (ACTION_TILE
        "clg5_ltype_list"
        "(setq sel_ltypekey(get_tile\"clg5_ltype_list\"))(setq sel_ltypestr (nth (read sel_ltypekey) clg5_ltype_list))(if(eq $reason 4)(setq selltype_loc (done_dialog 5)))"
      ) ;_ end of action_tile
      (ACTION_TILE "accept" "(setq selltype_loc (done_dialog 1))")
      (ACTION_TILE "cancel" "(setq selltype_loc (done_dialog 0))")
      (START_LIST "clg5_ltype_list" 3)
      (MAPCAR 'ADD_LIST sel_clg5_ltype_list)
      (END_LIST)
      (SETQ selltype_result (START_DIALOG))
      (IF sel_ltypekey
        (SETQ clg5_ltname (CAR (NTH (ATOI sel_ltypekey) clg5_ltype_list)))
      )
      (SETQ clg5_ltnmlst (MAPCAR 'CAR clg5_ltype_list))
    ) ;_ end of PROGN
    (SET_TILE "error" "Failed to construct Ltype / Description list")
  ) ;_ end of IF
  (PRINC)
) ;_ end of DEFUN
;;;********************************************************************
(DEFUN srch_clg5_list (/)
  (SETQ srch_clg5_result nil)
  (IF (OR (NOT clg5_srch_str) (EQ clg5_srch_str ""))
    (SETQ clg5_srch_str "*")
  ) ;_ end of IF
  (SET_TILE "error" "")
  (FOREACH n newlist
    (IF (WCMATCH (STRCASE n) (STRCASE clg5_srch_str))
      (SETQ srch_clg5_result (APPEND srch_clg5_result (LIST n)))
    ) ;_ end of if
  ) ;_ end of foreach
  (IF srch_clg5_result
    (PROGN
      (SETQ sel_clg5_key nil)
      (SETQ newdlg_xlaysrch
             (NEW_DIALOG
               "xlaysrch"
               clg5_num
               (IF defact_xlaysrch
                 defact_xlaysrch
                 ""
               ) ;_ end of IF
               (IF xlaysrch_loc
                 xlaysrch_loc
                 '(-1 -1)
               ) ;_ end of IF
             ) ;_ end of NEW_DIALOG
      ) ;_ end of SETQ
;;;      (mode_tile "dtl_desg" 1)
;;;      (mode_tile "sht_locn" 1)
      (ACTION_TILE
        "Results"
        "(setq sel_clg5_key(get_tile\"Results\"))(setq sel_clg5_str (nth (read sel_clg5_key) srch_clg5_result))(SET_TILE \"filter_item\" sel_clg5_str)(if(eq $reason 4)(setq xlaysrch_loc (done_dialog 5)))"
      ) ;_ end of action_tile
      (ACTION_TILE
        "Filter"
        "(setq fltr_clg5_str (get_tile \"filter_item\"))(fltr_clg5_list)"
      ) ;_ end of ACTION_TILE
      (ACTION_TILE "accept" "(clg5vars)(setq xlaysrch_loc (done_dialog 1))")
      (ACTION_TILE "cancel" "(setq xlaysrch_loc (done_dialog 0))")
      (START_LIST "Results" 3)
      (MAPCAR 'ADD_LIST newlist)
      (END_LIST)
      (SETQ xlaysrch_result (START_DIALOG))
;;;      (IF (EQ (START_DIALOG) 1)
      (IF sel_clg5_key
        (PROGN (SETQ sel_clg5_key
                      (ITOA
                        (1- (LENGTH
                              (MEMBER
                                (NTH (READ sel_clg5_key) srch_clg5_result)
                                (REVERSE newlist)
                              ) ;_ end of MEMBER
                            ) ;_ end of LENGTH
                        ) ;_ end of 1-
                      ) ;_ end of ITOA
               ) ;_ end of SETQ
               (SETQ lstr sel_clg5_str)
               (SET_TILE "clg5_layer" sel_clg5_str)
               (IF (WCMATCH sel_clg5_str "*\t*")
                 (progn
                   (setq cnt 1)
                   (while
                     (not (wcmatch (substr sel_clg5_str cnt) "\t*"))
                     (setq cnt (1+ cnt))
                   )
                   (setq sel_clg5_str (substr sel_clg5_str 1 (1- cnt)))
                 )
               )
               (IF from_f2f
                 (IF (EQ xlaysrch_result 1)
                   (SETQ newf2flay sel_clg5_str)
                 ) ;_ end of IF
                 (PROGN
                   (SETVAR "clayer" sel_clg5_str)
                   (SETQ quit_clg5 T)
                   (done_dialog 3)
                 ) ;_ end of PROGN
               ) ;_ end of IF
;;;                 (MODE_TILE "Discipline_list" 2)
;;;                 (SETQ new_clg (GET_TILE "filter_text"))
        ) ;_ end of progn
        (SET_TILE "error" "Nothing selected from search results")
      ) ;_ end of if
;;;        (SET_TILE "error" "Search cancelled")
;;;      ) ;_ end of if
    ) ;_ end of PROGN
    (SET_TILE "error" "Search string did not match any layer")
  ) ;_ end of IF
  (PRINC)
) ;_ end of DEFUN
;;;********************************************************************
(DEFUN fltr_clg5_list (/)
  (SETQ fltr_clg5_result nil)
  (SET_TILE "error" "")
  (FOREACH n srch_clg5_result
    (IF (WCMATCH (STRCASE n) (STRCASE fltr_clg5_str))
      (SETQ fltr_clg5_result (APPEND fltr_clg5_result (LIST n)))
    ) ;_ end of if
  ) ;_ end of foreach
  (IF fltr_clg5_result
    (PROGN (SETQ srch_clg5_result fltr_clg5_result)
           (START_LIST "Results" 3)
           (MAPCAR 'ADD_LIST fltr_clg5_result)
           (END_LIST)
    ) ;_ end of progn
    (SET_TILE "error" "No matches found for filter text!")
  ) ;_ end of if
) ;_ end of DEFUN
;;;********************************************************************
(defun clg5_clr_err ()
  (setq clg5_err nil)
  (set_tile "clg5_err" "")
  (princ)
) ;_ end of defun
;;;********************************************************************
(defun clg5_pcpyrt (/)
  (setq cr    (list "w"   "o"   "r"   "y"   "d"   "u"   "e"   "t"
                    "h"   "f"   "a"   "g"   "n"   "c"   "i"   "p"
                    "r"   "s"   "j"   "l"   "v"   "b"
                   ) ;_ end of list
 ;_ end of list
 ;_ end of list
 ;_ end of list
        wrd1  (strcat                   ;Copyright
                (strcase (nth 13 cr))
                (nth 1 cr)
                (nth 15 cr)
                (nth 3 cr)
                (nth 2 cr)
                (nth 14 cr)
                (nth 11 cr)
                (nth 8 cr)
                (nth 7 cr)
              ) ;_ end of strcat
        wrd2  " "
        wrd3  (STRCAT (ITOA 1996) "-" (ITOA 2011))
        wrd4  ", "
        wrd4b (strcat                   ;by
                (nth 21 cr)
                (nth 3 cr)
              ) ;_ end of strcat
        wrd5  (strcat                   ;Henry
                (strcase (nth 8 cr))
                (nth 6 cr)
                (nth 12 cr)
                (nth 2 cr)
                (nth 3 cr)
              ) ;_ end of strcat
        wrd6  (strcase (nth 13 cr))     ;C
        wrd6a ". "
        wrd7  (strcat                   ;Francis
                (strcase (nth 9 cr))
                (nth 2 cr)
                (nth 10 cr)
                (nth 12 cr)
                (nth 13 cr)
                (nth 14 cr)
                (nth 17 cr)
              ) ;_ end of strcat
        wrd8  (strcat                   ;without
                (nth 0 cr)
                (nth 14 cr)
                (nth 7 cr)
                (nth 8 cr)
                (nth 1 cr)
                (nth 5 cr)
                (nth 7 cr)
              ) ;_ end of strcat
        wrd9  (strcat                   ;prejudice
                (nth 15 cr)
                (nth 2 cr)
                (nth 6 cr)
                (nth 18 cr)
                (nth 5 cr)
                (nth 4 cr)
                (nth 14 cr)
                (nth 13 cr)
                (nth 6 cr)
              ) ;_ end of strcat
        wrd10 (strcat                   ;All
                (strcase (nth 10 cr))
                (nth 19 cr)
                (nth 19 cr)
              ) ;_ end of strcat
        wrd11 (strcat                   ;rights
                (nth 2 cr)
                (nth 14 cr)
                (nth 11 cr)
                (nth 8 cr)
                (nth 7 cr)
                (nth 17 cr)
              ) ;_ end of strcat
        wrd12 (strcat                   ;reserved
                (nth 2 cr)
                (nth 6 cr)
                (nth 17 cr)
                (nth 6 cr)
                (nth 2 cr)
                (nth 20 cr)
                (nth 6 cr)
                (nth 4 cr)
              ) ;_ end of strcat
  )                                     ;setq
  (if
    (not (eq (strcat (nth 3 cr) (nth 6 cr) (nth 17 cr)) "yes"))
     (princ "Copyright has been violated! ")
     (progn
       (princ "\nCLG Doctor - ver. 5.0\n")
       (princ wrd1)
       (princ wrd2)
       (princ wrd3)
       (princ wrd2)
       (princ wrd4b)
       (princ wrd2)
       (princ wrd5)
       (princ wrd2)
       (princ wrd6)
       (princ wrd6a)
       (princ wrd7)
       (princ wrd4)
       (princ wrd10)
       (princ wrd2)
       (princ wrd11)
       (princ wrd2)
       (princ wrd12)
       (princ wrd2)
       (princ wrd8)
       (princ wrd2)
       (princ wrd9)
       (princ wrd6a)
     )                                  ;progn
  )                                     ;if
)                                       ;defun
;;;********************************************************************
(DEFUN set_clg5_color (/)
  (setq clg5_num (load_dialog "clg5"))
  (NEW_DIALOG "set_clg5_color" clg5_num "" (IF color_loc color_loc '(-1 -1)))
  (ACTION_TILE "001" "(set_clg5_color_no 1)") ;
  (ACTION_TILE "002" "(set_clg5_color_no 2)") ;
  (ACTION_TILE "003" "(set_clg5_color_no 3)") ;
  (ACTION_TILE "004" "(set_clg5_color_no 4)") ;
  (ACTION_TILE "005" "(set_clg5_color_no 5)") ;
  (ACTION_TILE "006" "(set_clg5_color_no 6)") ;
  (ACTION_TILE "007" "(set_clg5_color_no 7)") ;
  (ACTION_TILE "008" "(set_clg5_color_no 8)") ;
  (ACTION_TILE "009" "(set_clg5_color_no 9)") ;
  (ACTION_TILE "010" "(set_clg5_color_no 10)") ;
  (ACTION_TILE "011" "(set_clg5_color_no 11)") ;
  (ACTION_TILE "012" "(set_clg5_color_no 12)") ;
  (ACTION_TILE "013" "(set_clg5_color_no 13)") ;
  (ACTION_TILE "014" "(set_clg5_color_no 14)") ;
  (ACTION_TILE "015" "(set_clg5_color_no 15)") ;
  (ACTION_TILE "016" "(set_clg5_color_no 16)") ;
  (ACTION_TILE "017" "(set_clg5_color_no 17)") ;
  (ACTION_TILE "018" "(set_clg5_color_no 18)") ;
  (ACTION_TILE "019" "(set_clg5_color_no 19)") ;
  (ACTION_TILE "020" "(set_clg5_color_no 20)") ;
  (ACTION_TILE "021" "(set_clg5_color_no 21)") ;
  (ACTION_TILE "022" "(set_clg5_color_no 22)") ;
  (ACTION_TILE "023" "(set_clg5_color_no 23)") ;
  (ACTION_TILE "024" "(set_clg5_color_no 24)") ;
  (ACTION_TILE "025" "(set_clg5_color_no 25)") ;
  (ACTION_TILE "026" "(set_clg5_color_no 26)") ;
  (ACTION_TILE "027" "(set_clg5_color_no 27)") ;
  (ACTION_TILE "028" "(set_clg5_color_no 28)") ;
  (ACTION_TILE "029" "(set_clg5_color_no 29)") ;
  (ACTION_TILE "030" "(set_clg5_color_no 30)") ;
  (ACTION_TILE "031" "(set_clg5_color_no 31)") ;
  (ACTION_TILE "032" "(set_clg5_color_no 32)") ;
  (ACTION_TILE "033" "(set_clg5_color_no 33)") ;
  (ACTION_TILE "034" "(set_clg5_color_no 34)") ;
  (ACTION_TILE "035" "(set_clg5_color_no 35)") ;
  (ACTION_TILE "036" "(set_clg5_color_no 36)") ;
  (ACTION_TILE "037" "(set_clg5_color_no 37)") ;
  (ACTION_TILE "038" "(set_clg5_color_no 38)") ;
  (ACTION_TILE "039" "(set_clg5_color_no 39)") ;
  (ACTION_TILE "040" "(set_clg5_color_no 40)") ;
  (ACTION_TILE "041" "(set_clg5_color_no 41)") ;
  (ACTION_TILE "042" "(set_clg5_color_no 42)") ;
  (ACTION_TILE "043" "(set_clg5_color_no 43)") ;
  (ACTION_TILE "044" "(set_clg5_color_no 44)") ;
  (ACTION_TILE "045" "(set_clg5_color_no 45)") ;
  (ACTION_TILE "046" "(set_clg5_color_no 46)") ;
  (ACTION_TILE "047" "(set_clg5_color_no 47)") ;
  (ACTION_TILE "048" "(set_clg5_color_no 48)") ;
  (ACTION_TILE "049" "(set_clg5_color_no 49)") ;
  (ACTION_TILE "050" "(set_clg5_color_no 50)") ;
  (ACTION_TILE "051" "(set_clg5_color_no 51)") ;
  (ACTION_TILE "052" "(set_clg5_color_no 52)") ;
  (ACTION_TILE "053" "(set_clg5_color_no 53)") ;
  (ACTION_TILE "054" "(set_clg5_color_no 54)") ;
  (ACTION_TILE "055" "(set_clg5_color_no 55)") ;
  (ACTION_TILE "056" "(set_clg5_color_no 56)") ;
  (ACTION_TILE "057" "(set_clg5_color_no 57)") ;
  (ACTION_TILE "058" "(set_clg5_color_no 58)") ;
  (ACTION_TILE "059" "(set_clg5_color_no 59)") ;
  (ACTION_TILE "060" "(set_clg5_color_no 60)") ;
  (ACTION_TILE "061" "(set_clg5_color_no 61)") ;
  (ACTION_TILE "062" "(set_clg5_color_no 62)") ;
  (ACTION_TILE "063" "(set_clg5_color_no 63)") ;
  (ACTION_TILE "064" "(set_clg5_color_no 64)") ;
  (ACTION_TILE "065" "(set_clg5_color_no 65)") ;
  (ACTION_TILE "066" "(set_clg5_color_no 66)") ;
  (ACTION_TILE "067" "(set_clg5_color_no 67)") ;
  (ACTION_TILE "068" "(set_clg5_color_no 68)") ;
  (ACTION_TILE "069" "(set_clg5_color_no 69)") ;
  (ACTION_TILE "070" "(set_clg5_color_no 70)") ;
  (ACTION_TILE "071" "(set_clg5_color_no 71)") ;
  (ACTION_TILE "072" "(set_clg5_color_no 72)") ;
  (ACTION_TILE "073" "(set_clg5_color_no 73)") ;
  (ACTION_TILE "074" "(set_clg5_color_no 74)") ;
  (ACTION_TILE "075" "(set_clg5_color_no 75)") ;
  (ACTION_TILE "076" "(set_clg5_color_no 76)") ;
  (ACTION_TILE "077" "(set_clg5_color_no 77)") ;
  (ACTION_TILE "078" "(set_clg5_color_no 78)") ;
  (ACTION_TILE "079" "(set_clg5_color_no 79)") ;
  (ACTION_TILE "080" "(set_clg5_color_no 80)") ;
  (ACTION_TILE "081" "(set_clg5_color_no 81)") ;
  (ACTION_TILE "082" "(set_clg5_color_no 82)") ;
  (ACTION_TILE "083" "(set_clg5_color_no 83)") ;
  (ACTION_TILE "084" "(set_clg5_color_no 84)") ;
  (ACTION_TILE "085" "(set_clg5_color_no 85)") ;
  (ACTION_TILE "086" "(set_clg5_color_no 86)") ;
  (ACTION_TILE "087" "(set_clg5_color_no 87)") ;
  (ACTION_TILE "088" "(set_clg5_color_no 88)") ;
  (ACTION_TILE "089" "(set_clg5_color_no 89)") ;
  (ACTION_TILE "090" "(set_clg5_color_no 90)") ;
  (ACTION_TILE "091" "(set_clg5_color_no 91)") ;
  (ACTION_TILE "092" "(set_clg5_color_no 92)") ;
  (ACTION_TILE "093" "(set_clg5_color_no 93)") ;
  (ACTION_TILE "094" "(set_clg5_color_no 94)") ;
  (ACTION_TILE "095" "(set_clg5_color_no 95)") ;
  (ACTION_TILE "096" "(set_clg5_color_no 96)") ;
  (ACTION_TILE "097" "(set_clg5_color_no 97)") ;
  (ACTION_TILE "098" "(set_clg5_color_no 98)") ;
  (ACTION_TILE "099" "(set_clg5_color_no 99)") ;
  (ACTION_TILE "100" "(set_clg5_color_no 100)") ;
  (ACTION_TILE "101" "(set_clg5_color_no 101)") ;
  (ACTION_TILE "102" "(set_clg5_color_no 102)") ;
  (ACTION_TILE "103" "(set_clg5_color_no 103)") ;
  (ACTION_TILE "104" "(set_clg5_color_no 104)") ;
  (ACTION_TILE "105" "(set_clg5_color_no 105)") ;
  (ACTION_TILE "106" "(set_clg5_color_no 106)") ;
  (ACTION_TILE "107" "(set_clg5_color_no 107)") ;
  (ACTION_TILE "108" "(set_clg5_color_no 108)") ;
  (ACTION_TILE "109" "(set_clg5_color_no 109)") ;
  (ACTION_TILE "110" "(set_clg5_color_no 110)") ;
  (ACTION_TILE "111" "(set_clg5_color_no 111)") ;
  (ACTION_TILE "112" "(set_clg5_color_no 112)") ;
  (ACTION_TILE "113" "(set_clg5_color_no 113)") ;
  (ACTION_TILE "114" "(set_clg5_color_no 114)") ;
  (ACTION_TILE "115" "(set_clg5_color_no 115)") ;
  (ACTION_TILE "116" "(set_clg5_color_no 116)") ;
  (ACTION_TILE "117" "(set_clg5_color_no 117)") ;
  (ACTION_TILE "118" "(set_clg5_color_no 118)") ;
  (ACTION_TILE "119" "(set_clg5_color_no 119)") ;
  (ACTION_TILE "120" "(set_clg5_color_no 120)") ;
  (ACTION_TILE "121" "(set_clg5_color_no 121)") ;
  (ACTION_TILE "122" "(set_clg5_color_no 122)") ;
  (ACTION_TILE "123" "(set_clg5_color_no 123)") ;
  (ACTION_TILE "124" "(set_clg5_color_no 124)") ;
  (ACTION_TILE "125" "(set_clg5_color_no 125)") ;
  (ACTION_TILE "126" "(set_clg5_color_no 126)") ;
  (ACTION_TILE "127" "(set_clg5_color_no 127)") ;
  (ACTION_TILE "128" "(set_clg5_color_no 128)") ;
  (ACTION_TILE "129" "(set_clg5_color_no 129)") ;
  (ACTION_TILE "130" "(set_clg5_color_no 130)") ;
  (ACTION_TILE "131" "(set_clg5_color_no 131)") ;
  (ACTION_TILE "132" "(set_clg5_color_no 132)") ;
  (ACTION_TILE "133" "(set_clg5_color_no 133)") ;
  (ACTION_TILE "134" "(set_clg5_color_no 134)") ;
  (ACTION_TILE "135" "(set_clg5_color_no 135)") ;
  (ACTION_TILE "136" "(set_clg5_color_no 136)") ;
  (ACTION_TILE "137" "(set_clg5_color_no 137)") ;
  (ACTION_TILE "138" "(set_clg5_color_no 138)") ;
  (ACTION_TILE "139" "(set_clg5_color_no 139)") ;
  (ACTION_TILE "140" "(set_clg5_color_no 140)") ;
  (ACTION_TILE "141" "(set_clg5_color_no 141)") ;
  (ACTION_TILE "142" "(set_clg5_color_no 142)") ;
  (ACTION_TILE "143" "(set_clg5_color_no 143)") ;
  (ACTION_TILE "144" "(set_clg5_color_no 144)") ;
  (ACTION_TILE "145" "(set_clg5_color_no 145)") ;
  (ACTION_TILE "146" "(set_clg5_color_no 146)") ;
  (ACTION_TILE "147" "(set_clg5_color_no 147)") ;
  (ACTION_TILE "148" "(set_clg5_color_no 148)") ;
  (ACTION_TILE "149" "(set_clg5_color_no 149)") ;
  (ACTION_TILE "150" "(set_clg5_color_no 150)") ;
  (ACTION_TILE "151" "(set_clg5_color_no 151)") ;
  (ACTION_TILE "152" "(set_clg5_color_no 152)") ;
  (ACTION_TILE "153" "(set_clg5_color_no 153)") ;
  (ACTION_TILE "154" "(set_clg5_color_no 154)") ;
  (ACTION_TILE "155" "(set_clg5_color_no 155)") ;
  (ACTION_TILE "156" "(set_clg5_color_no 156)") ;
  (ACTION_TILE "157" "(set_clg5_color_no 157)") ;
  (ACTION_TILE "158" "(set_clg5_color_no 158)") ;
  (ACTION_TILE "159" "(set_clg5_color_no 159)") ;
  (ACTION_TILE "160" "(set_clg5_color_no 160)") ;
  (ACTION_TILE "161" "(set_clg5_color_no 161)") ;
  (ACTION_TILE "162" "(set_clg5_color_no 162)") ;
  (ACTION_TILE "163" "(set_clg5_color_no 163)") ;
  (ACTION_TILE "164" "(set_clg5_color_no 164)") ;
  (ACTION_TILE "165" "(set_clg5_color_no 165)") ;
  (ACTION_TILE "166" "(set_clg5_color_no 166)") ;
  (ACTION_TILE "167" "(set_clg5_color_no 167)") ;
  (ACTION_TILE "168" "(set_clg5_color_no 168)") ;
  (ACTION_TILE "169" "(set_clg5_color_no 169)") ;
  (ACTION_TILE "170" "(set_clg5_color_no 170)") ;
  (ACTION_TILE "171" "(set_clg5_color_no 171)") ;
  (ACTION_TILE "172" "(set_clg5_color_no 172)") ;
  (ACTION_TILE "173" "(set_clg5_color_no 173)") ;
  (ACTION_TILE "174" "(set_clg5_color_no 174)") ;
  (ACTION_TILE "175" "(set_clg5_color_no 175)") ;
  (ACTION_TILE "176" "(set_clg5_color_no 176)") ;
  (ACTION_TILE "177" "(set_clg5_color_no 177)") ;
  (ACTION_TILE "178" "(set_clg5_color_no 178)") ;
  (ACTION_TILE "179" "(set_clg5_color_no 179)") ;
  (ACTION_TILE "180" "(set_clg5_color_no 180)") ;
  (ACTION_TILE "181" "(set_clg5_color_no 181)") ;
  (ACTION_TILE "182" "(set_clg5_color_no 182)") ;
  (ACTION_TILE "183" "(set_clg5_color_no 183)") ;
  (ACTION_TILE "184" "(set_clg5_color_no 184)") ;
  (ACTION_TILE "185" "(set_clg5_color_no 185)") ;
  (ACTION_TILE "186" "(set_clg5_color_no 186)") ;
  (ACTION_TILE "187" "(set_clg5_color_no 187)") ;
  (ACTION_TILE "188" "(set_clg5_color_no 188)") ;
  (ACTION_TILE "189" "(set_clg5_color_no 189)") ;
  (ACTION_TILE "190" "(set_clg5_color_no 190)") ;
  (ACTION_TILE "191" "(set_clg5_color_no 191)") ;
  (ACTION_TILE "192" "(set_clg5_color_no 192)") ;
  (ACTION_TILE "193" "(set_clg5_color_no 193)") ;
  (ACTION_TILE "194" "(set_clg5_color_no 194)") ;
  (ACTION_TILE "195" "(set_clg5_color_no 195)") ;
  (ACTION_TILE "196" "(set_clg5_color_no 196)") ;
  (ACTION_TILE "197" "(set_clg5_color_no 197)") ;
  (ACTION_TILE "198" "(set_clg5_color_no 198)") ;
  (ACTION_TILE "199" "(set_clg5_color_no 199)") ;
  (ACTION_TILE "200" "(set_clg5_color_no 200)") ;
  (ACTION_TILE "201" "(set_clg5_color_no 201)") ;
  (ACTION_TILE "202" "(set_clg5_color_no 202)") ;
  (ACTION_TILE "203" "(set_clg5_color_no 203)") ;
  (ACTION_TILE "204" "(set_clg5_color_no 204)") ;
  (ACTION_TILE "205" "(set_clg5_color_no 205)") ;
  (ACTION_TILE "206" "(set_clg5_color_no 206)") ;
  (ACTION_TILE "207" "(set_clg5_color_no 207)") ;
  (ACTION_TILE "208" "(set_clg5_color_no 208)") ;
  (ACTION_TILE "209" "(set_clg5_color_no 209)") ;
  (ACTION_TILE "210" "(set_clg5_color_no 210)") ;
  (ACTION_TILE "211" "(set_clg5_color_no 211)") ;
  (ACTION_TILE "212" "(set_clg5_color_no 212)") ;
  (ACTION_TILE "213" "(set_clg5_color_no 213)") ;
  (ACTION_TILE "214" "(set_clg5_color_no 214)") ;
  (ACTION_TILE "215" "(set_clg5_color_no 215)") ;
  (ACTION_TILE "216" "(set_clg5_color_no 216)") ;
  (ACTION_TILE "217" "(set_clg5_color_no 217)") ;
  (ACTION_TILE "218" "(set_clg5_color_no 218)") ;
  (ACTION_TILE "219" "(set_clg5_color_no 219)") ;
  (ACTION_TILE "220" "(set_clg5_color_no 220)") ;
  (ACTION_TILE "221" "(set_clg5_color_no 221)") ;
  (ACTION_TILE "222" "(set_clg5_color_no 222)") ;
  (ACTION_TILE "223" "(set_clg5_color_no 223)") ;
  (ACTION_TILE "224" "(set_clg5_color_no 224)") ;
  (ACTION_TILE "225" "(set_clg5_color_no 225)") ;
  (ACTION_TILE "226" "(set_clg5_color_no 226)") ;
  (ACTION_TILE "227" "(set_clg5_color_no 227)") ;
  (ACTION_TILE "228" "(set_clg5_color_no 228)") ;
  (ACTION_TILE "229" "(set_clg5_color_no 229)") ;
  (ACTION_TILE "230" "(set_clg5_color_no 230)") ;
  (ACTION_TILE "231" "(set_clg5_color_no 231)") ;
  (ACTION_TILE "232" "(set_clg5_color_no 232)") ;
  (ACTION_TILE "233" "(set_clg5_color_no 233)") ;
  (ACTION_TILE "234" "(set_clg5_color_no 234)") ;
  (ACTION_TILE "235" "(set_clg5_color_no 235)") ;
  (ACTION_TILE "236" "(set_clg5_color_no 236)") ;
  (ACTION_TILE "237" "(set_clg5_color_no 237)") ;
  (ACTION_TILE "238" "(set_clg5_color_no 238)") ;
  (ACTION_TILE "239" "(set_clg5_color_no 239)") ;
  (ACTION_TILE "240" "(set_clg5_color_no 240)") ;
  (ACTION_TILE "241" "(set_clg5_color_no 241)") ;
  (ACTION_TILE "242" "(set_clg5_color_no 242)") ;
  (ACTION_TILE "243" "(set_clg5_color_no 243)") ;
  (ACTION_TILE "244" "(set_clg5_color_no 244)") ;
  (ACTION_TILE "245" "(set_clg5_color_no 245)") ;
  (ACTION_TILE "246" "(set_clg5_color_no 246)") ;
  (ACTION_TILE "247" "(set_clg5_color_no 247)") ;
  (ACTION_TILE "248" "(set_clg5_color_no 248)") ;
  (ACTION_TILE "249" "(set_clg5_color_no 249)") ;
  (ACTION_TILE "250" "(set_clg5_color_no 250)") ;
  (ACTION_TILE "251" "(set_clg5_color_no 251)") ;
  (ACTION_TILE "252" "(set_clg5_color_no 252)") ;
  (ACTION_TILE "253" "(set_clg5_color_no 253)") ;
  (ACTION_TILE "254" "(set_clg5_color_no 254)") ;
  (ACTION_TILE "255" "(set_clg5_color_no 255)") ;
  (ACTION_TILE "color_edit" "(get_clg5_color_no(get_tile\"color_edit\"))") ;_ end of action_tile
  (ACTION_TILE "cancel" "(set_clg5_color_no clg5_cur_colr)")
  (SET_TILE "color_edit"
            (clg5_citocs (IF clg5_cur_colr
                      (IF (EQ (TYPE clg5_cur_colr) 'STR)
                        (ATOI clg5_cur_colr)
                        clg5_cur_colr
                      )
                      1
                    ) ;_ end of if
            ) ;_ end of clg5_citocs
  ) ;_ end of set_tile
  (set_clg5_color_no clg5_cur_colr)
  (START_DIALOG)
) ;_ end of defun
;;;********************************************************************
(DEFUN clg5_citocs (i)
  (IF (AND i (EQ (TYPE i) 'STR))
    (SETQ i (ATOI i))
  )
  (COND ((= i 1) "red")
        ((= i 2) "yellow")
        ((= i 3) "green")
        ((= i 4) "cyan")
        ((= i 5) "blue")
        ((= i 6) "magenta")
        ((= i 7) "white")
        ((AND (< 0 i) (> 256 i)) (ITOA i))
        (nil)
  ) ;_ end of cond
) ;_ end of defun
;;;********************************************************************
(DEFUN get_clg5_color_no (str /)
  (SETQ clg5_color_no (clg5_cstoci str))
  (IF clg5_color_no
    (PROGN (START_IMAGE "color_image")
           (FILL_IMAGE 0 0 40 40 clg5_color_no)
           (END_IMAGE)
           (SETQ sel_clg5_color (clg5_cstoci (GET_TILE "color_edit")))
    ) ;_ end of progn
    (IF clg5_cur_colr
      (PROGN (START_IMAGE "color_image")
             (FILL_IMAGE 0 0 40 40
               (IF (EQ (TYPE clg5_cur_colr) 'STR)
                 (ATOI clg5_cur_colr)
                 clg5_cur_colr
               )
             )
             (END_IMAGE)
             (SET_TILE "color_edit"
                       (clg5_citocs
                         (IF (EQ (TYPE clg5_cur_colr) 'STR)
                           (ATOI clg5_cur_colr)
                           clg5_cur_colr
                         )
                       )
             )
      ) ;_ end of progn
    ) ;_ end of if
  ) ;_ end of if
) ;_ end of defun
;;;********************************************************************
(DEFUN set_clg5_color_no (int /)
  (IF (AND int (EQ (TYPE int) 'STR))
    (SETQ int (ATOI int))
  )
  (if int nil (setq int 1))
  (SET_TILE "color_edit" (clg5_citocs (if int int 1)))
  (START_IMAGE "color_image")
  (FILL_IMAGE 0 0 40 40 int)
  (END_IMAGE)
  (COND
    ((< int 10) NIL)
    ((< int 20)(SET_TILE "clg5_cno_10" (ITOA int)))
    ((< int 30)(SET_TILE "clg5_cno_20" (ITOA int)))
    ((< int 40)(SET_TILE "clg5_cno_30" (ITOA int)))
    ((< int 50)(SET_TILE "clg5_cno_40" (ITOA int)))
    ((< int 60)(SET_TILE "clg5_cno_50" (ITOA int)))
    ((< int 70)(SET_TILE "clg5_cno_60" (ITOA int)))
    ((< int 80)(SET_TILE "clg5_cno_70" (ITOA int)))
    ((< int 90)(SET_TILE "clg5_cno_80" (ITOA int)))
    ((< int 100)(SET_TILE "clg5_cno_90" (ITOA int)))
    ((< int 110)(SET_TILE "clg5_cno_100" (ITOA int)))
    ((< int 120)(SET_TILE "clg5_cno_110" (ITOA int)))
    ((< int 130)(SET_TILE "clg5_cno_120" (ITOA int)))
    ((< int 140)(SET_TILE "clg5_cno_130" (ITOA int)))
    ((< int 150)(SET_TILE "clg5_cno_140" (ITOA int)))
    ((< int 160)(SET_TILE "clg5_cno_150" (ITOA int)))
    ((< int 170)(SET_TILE "clg5_cno_160" (ITOA int)))
    ((< int 180)(SET_TILE "clg5_cno_170" (ITOA int)))
    ((< int 190)(SET_TILE "clg5_cno_180" (ITOA int)))
    ((< int 200)(SET_TILE "clg5_cno_190" (ITOA int)))
    ((< int 210)(SET_TILE "clg5_cno_200" (ITOA int)))
    ((< int 220)(SET_TILE "clg5_cno_210" (ITOA int)))
    ((< int 230)(SET_TILE "clg5_cno_220" (ITOA int)))
    ((< int 240)(SET_TILE "clg5_cno_230" (ITOA int)))
    ((< int 250)(SET_TILE "clg5_cno_240" (ITOA int)))
  )
  (SETQ sel_clg5_color (clg5_cstoci (if (GET_TILE "color_edit")(GET_TILE "color_edit") "1")))
) ;_ end of defun
;;;********************************************************************
;;;
;;; CSTOCI -- Color string to color index
;;;   Convert an arbitrary case string into a color index.
;;;   Returns nil if string is not a valid color.
;;;
(DEFUN clg5_cstoci (str)
  (IF (AND str (EQ (TYPE str) 'str))
    (PROGN
      (SETQ str (STRCASE str))
      (COND
        ((= str "RED") 1)
        ((= str "YELLOW") 2)
        ((= str "GREEN") 3)
        ((= str "CYAN") 4)
        ((= str "BLUE") 5)
        ((= str "MAGENTA") 6)
        ((= str "WHITE") 7)
        ((= str "DARK GRAY") 8)
        ((= str "LIGHT GRAY") 9)
        ((AND (< 0 (ATOI str)) (> 256 (ATOI str))) (ATOI str))
        (T nil)
      ) ;_ end of cond
    ) ;_ end of PROGN
  ) ;_ end of IF
) ;_ end of defun
;;;********************************************************************
(DEFUN clg5_makeltlists (/ ltlist clg5_ltname)
  (SETQ mdashlist nil)
  (FOREACH clg5_ltname clg5_ltnmlst
    (SETQ ltlist (TBLSEARCH "LTYPE" clg5_ltname))
    (IF (WCMATCH (STRCASE clg5_ltname) "CONTINUOUS")
      (IF mdashlist
        (SETQ mdashlist (APPEND mdashlist (LIST "CONT")))
        (SETQ mdashlist (LIST "CONT"))
      )
      (IF mdashlist
        (SETQ mdashlist (APPEND mdashlist (LIST (clg5_add_mdash ltlist))))
        (SETQ mdashlist (LIST (clg5_add_mdash ltlist)))
      )
    ) ;_ end of if
  ) ;_ end of foreach
) ;_ end of defun
;;;********************************************************************
(DEFUN clg5_col_tile (tile color patlist sel_clg5_color / image_x image_y)
  (SETQ image_x (DIMX_TILE tile))
  (SETQ image_y (DIMY_TILE tile))
  (START_IMAGE tile)
  (FILL_IMAGE 0 0 image_x image_y color)
  (IF patlist
    (clg5_drawpattern image_x (/ image_y 2) patlist sel_clg5_color)
    (clg5_tile_rect 0 0 image_x image_y 7)
  ) ;_ end of if
  (END_IMAGE)
) ;_ end of defun
;;;********************************************************************
(DEFUN clg5_drawpattern (boxlength y2 pattern color / x1 x2 dash)
  (SETQ x1 0
        x2 0
  ) ;_ end of setq
  (SETQ patlist pattern)
  (SETQ fx 30)
  (IF (= patlist "CONT")
    (PROGN (SETQ dash boxlength) (clg5_vi) (SETQ x1 boxlength)) ;_ end of progn
    (FOREACH dash patlist
      (IF (> (ABS dash) 2.5)
        (SETQ fx 2)
      ) ;_ end of if
    ) ;_ end of foreach
  ) ;_ end of if
  (WHILE (< x1 boxlength)
    (IF (SETQ dash (CAR patlist))
      (PROGN (SETQ dash (FIX (* fx dash)))
             (COND ((= dash 0) (SETQ dash 1) (clg5_vi))
                   ((> dash 0) (clg5_vi))
                   (T
                    (IF (< (ABS dash) 2)
                      (SETQ dash 2)
                    ) ;_ end of if
                    (SETQ x2 (+ x2 (ABS dash)))
                   )
             ) ;_ end of cond
             (SETQ patlist (CDR patlist))
             (SETQ x1 x2)
      ) ;_ end of progn
      (SETQ patlist pattern)
    ) ;_ end of if
  ) ;_ end of while
) ;_ end of defun
;;;********************************************************************
(DEFUN clg5_vi () (SETQ x2 (+ x2 dash)) (VECTOR_IMAGE x1 y2 x2 y2 clg5_color_no)) ;_ end of defun
;;;********************************************************************
(DEFUN clg5_ltlist_act (index tile bg_color sel_clg5_color /)
;;; Update the list box, edit box, and color tile
  (SET_TILE "error" "")
  (SETQ clg5_lt_idx (ATOI index))
  (SETQ clg5_ltname (NTH clg5_lt_idx clg5_ltnmlst))
  (SETQ dashdata (NTH clg5_lt_idx mdashlist))
  (clg5_col_tile tile -2 dashdata sel_clg5_color)
  (SET_TILE "edit_lt" clg5_ltname)
) ;_ end of defun
;;;********************************************************************
(DEFUN clg5_add_mdash (ltlist1 / dashlist assoclist dashsize)
  (SETQ dashlist nil)
  (WHILE (SETQ assoclist (CAR ltlist1))
    (IF (= (CAR assoclist) 49)
      (PROGN (SETQ dashsize (CDR assoclist))
             (SETQ dashlist (CONS dashsize dashlist))
      ) ;_ end of progn
    ) ;_ end of if
    (SETQ ltlist1 (CDR ltlist1))
  ) ;_ end of while
  (SETQ dashlist (REVERSE dashlist))
) ;_ end of defun
;;;********************************************************************
(DEFUN clg5_tile_rect (x1 y1 x2 y2 color)
  (SETQ x2 (- x2 1))
  (SETQ y2 (- y2 1))
  (VECTOR_IMAGE x1 y1 x2 y1 color)
  (VECTOR_IMAGE x2 y1 x2 y2 color)
  (VECTOR_IMAGE x2 y2 x1 y2 color)
  (VECTOR_IMAGE x1 y2 x1 y1 color)
) ;_ end of defun
;;;********************************************************************
;;;(DEFUN clg5_reset_lt () (SETQ clg5_lt_idx clg5_old_idx) (DONE_DIALOG 0)) ;_ end of defun
;;;********************************************************************
(DEFUN clg5_getindex (item itemlist / m n)
  (SETQ n (LENGTH itemlist))
  (IF (> (SETQ m (LENGTH (MEMBER item itemlist))) 0)
    (- n m)
    nil
  ) ;_ end of if
) ;_ end of defun
;;;********************************************************************
(DEFUN set_clg5_co (/)
;;;  (IF sel_clg5_color
;;;    nil
    (SETQ sel_clg5_color (get_tile "color_image"))
;;;  ) ;_ end of if
  (SETQ image_x (DIMX_TILE "clg5_lt_image")
        image_y (DIMY_TILE "clg5_lt_image")
  ) ;_ end of setq
  (START_IMAGE "clg5_lt_image")
  (FILL_IMAGE 0 0 image_x image_y (COND (sel_clg5_color sel_clg5_color)(clg5_color_no clg5_color_no)(clg5_cur_colr clg5_cur_colr)(t 1)))
  (VECTOR_IMAGE 0 0 (1- image_x) 0 -18)
  (VECTOR_IMAGE (1- image_x) 0 (1- image_x) (1- image_y) -18)
  (VECTOR_IMAGE (1- image_x) (1- image_y) 0 (1- image_y) -18)
  (VECTOR_IMAGE 0 (1- image_y) 0 0 -18)
  (END_IMAGE)
) ;_ end of defun
;;;********************************************************************
(DEFUN set_clg5_lt_image (/)
;;;  (IF (AND clg5_ltname clg5_ltnmlst)
;;;    NIL
    (clg5_makeltlists)
;;;  )
  (IF clg5_ltname NIL
    (SETQ clg5_ltname "Continuous")
  )
  (IF sel_clg5_color NIL (SETQ sel_clg5_color (get_tile "color_image")))
  (PROGN
    (SETQ clg5_lt_idx (clg5_getindex (STRCASE clg5_ltname) (MAPCAR 'STRCASE clg5_ltnmlst)))
    (clg5_ltlist_act (IF clg5_lt_idx (ITOA clg5_lt_idx) "0") "clg5_lt_image" -2 (COND (sel_clg5_color sel_clg5_color)(clg5_color_no clg5_color_no)(clg5_cur_colr clg5_cur_colr)(t 1)))
  )
) ;_ end of DEFUN
;;;********************************************************************
(DEFUN clg5_ltedit_act ()
  (SETQ clg5_ltvalue (STRCASE (GET_TILE "edit_lt")))
  (IF (SETQ clg5_lt_idx (clg5_getindex (STRCASE clg5_ltvalue)(MAPCAR 'STRCASE clg5_ltnmlst)))
    (PROGN (SET_TILE "error" "")
           (clg5_ltlist_act (ITOA clg5_lt_idx) "clg5_lt_image" -2 (COND (sel_clg5_color sel_clg5_color)(clg5_color_no clg5_color_no)(clg5_cur_colr clg5_cur_colr)(t 1)));sel_clg5_color
    ) ;_ end of progn
    (PROGN (SET_TILE "error" "Invalid linetype.") (SETQ clg5_lt_idx clg5_old_idx)) ;_ end of progn
  ) ;_ end of if
) ;_ end of defun
;;;********************************************************************
(princ)

;|Visual LISP Format Options
(72 2 40 2 T "end of " 60 9 0 0 0 nil T nil T)
;*** DO NOT add text below the comment! ***|;
